<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.ck_log.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class ck_log {

//---- Update Log

    function update_log($script,$op,$parents,$children,$timestamp,$trans_id,$logid) {
	global $ckapi,$phpgw,$pre ;

	$db_type = $ckapi[hostsys][dbtype] ;
	$app = $ckapi[params][app] ;
	$ip =($_SERVER['HTTP_X_FORWARDED_FOR']) ? $_SERVER['HTTP_X_FORWARDED_FOR'] : $_SERVER['REMOTE_ADDR'] ;
	$user = $ckapi[hostsys][username];
	$sql = ($db_type=="mysql") ? "BEGIN" : "BEGIN TRANSACTION" ;
	$phpgw->db->query($sql);

	$table = $parents[0] ;
	if ($db_type=="mysql")	$sql = "SELECT a.* FROM $table a LEFT JOIN ${pre}log b ON a.id=b.id WHERE b.id IS NULL" ;
	  else	$sql = "SELECT * FROM $table EXCEPT (SELECT a.* FROM $table a, ${pre}log b WHERE a.id=b.id)" ;
	if ($trans_id<>"")	$sql = "SELECT * FROM $table WHERE id='$trans_id'" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$idarr[$i] = $phpgw->db->f('id') ;
		$header[$i][$table] = $phpgw->db->Record;
		}
	foreach ($parents as $key => $value) {
		if ($key==0)	continue ;
		For ($i=1;isset($idarr[$i]);$i++) {
			$phpgw->db->query("SELECT * FROM $value WHERE id = $idarr[$i]");
			$phpgw->db->next_record();
			$header[$i][$value] = $phpgw->db->Record ;		
			}
		}
	if (is_array($children)) {
		foreach ($children as $key => $value) {
			For ($i=1;isset($idarr[$i]);$i++) {
				$sql = "SELECT * FROM $key WHERE $value = '$idarr[$i]'" ;
				$phpgw->db->query($sql);
				For ($j=1;$phpgw->db->next_record();$j++) {
					$detail[$i][$key][$j] = $phpgw->db->Record ;
					}
				}
			}
		}
	For ($i=1;isset($idarr[$i]);$i++) {
		$id = $idarr[$i] ;
		$lid = ($logid=='') ? $id : $logid ;
		$iptime = "$ip=$timestamp=$script=$id" ;
		$headerarr = addslashes(serialize($header[$i]));
		$detailarr = ( is_array($detail[$i]) ) ? addslashes(serialize($detail[$i])) : '' ;
		$sql= "INSERT INTO ${pre}log (id,trans_id,app,script,ip,userid,op,timestamp,header,detail,iptime) ";
		$sql.= "VALUES ('$lid','$id','$app','$script','$ip','$user','$op','$timestamp','$headerarr','$detailarr','$iptime')";
		$phpgw->db->query($sql);
		}

	$sql = ($db_type=="mysql") ? "COMMIT" : "END TRANSACTION" ;
	$phpgw->db->query($sql);

	}

//---- Write Log Detail

    function log_write(&$t, $l) {
	global $ckapi,$phpgw ;

	$th_bg = $ckapi[hostsys][th_bg] ;
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('th_bg',$th_bg);
	$t->set_var('lang_id',lang('Audit / LogTable ID'));
	$t->set_var('lang_timestamp',lang('Timestamp'));
	$t->set_var('lang_date',lang('Date(y/m/d)'));
	$t->set_var('lang_time',lang('Time'));
	$t->set_var('lang_iptime',lang('IPTime'));
	$t->set_var('lang_trans_id',lang('Transaction ID'));
	$t->set_var('lang_app',lang('Application'));
	$t->set_var('lang_op',lang('Operation'));
	$t->set_var('lang_script',lang('Script'));
	$t->set_var('lang_ip',lang('IP'));
	$t->set_var('lang_user',lang('User'));
	$t->set_var('lang_detail_id',lang('Detail Record ID'));
	$t->set_var('lang_table',lang('Table Name'));
	$t->set_var('lang_field',lang('Field Name'));
	$t->set_var('lang_value',lang('Value'));
	$op = $l[op] ;
	switch ($op) :
		case "new" :	$desc = lang("Post-insert image") ;	break ;
		case "edit" :	$desc = lang("Post-edit image") ;	break ;
		case "delete" :	$desc = lang("Pre-delete image") ;	break ;
		case "clear" :	$desc = lang("Pre-clear image") ;	break ;
		case "approve":	$desc = lang("Post-approve image") ;	break ;
		case "cancel":	$desc = lang("Post-cancel image") ;	break ;
		case "reject":	$desc = lang("Post-reject image") ;	break ;
		endswitch ;
	$t->set_var('lang_header',lang('Header Record')." [$desc]");
	$t->set_var('lang_detail',lang('Detail Records')." [$desc]");

	$timestamp = $l[timestamp] ;
	$t->set_var('id',$l[id]);
	$t->set_var('timestamp',$timestamp);
	$t->set_var('year',date("Y",$timestamp));
	$t->set_var('month',date("m",$timestamp));
	$t->set_var('day',date("d",$timestamp));
	$t->set_var('time',date("H:i:s",$timestamp));
	$t->set_var('trans_id',$l[trans_id]);
	$t->set_var('app',$l[app]);
	$t->set_var('op',$op);
	$t->set_var('script',$l[script]);
	$t->set_var('ip',$l[ip]);
	$t->set_var('iptime',$l[iptime]);
	$t->set_var('user',$l[userid]);

	if ($l[header]<>"") {
		$header = unserialize($l[header]) ;
		foreach ($header as $hdrkey => $hdrvalue) {
			$t->set_var('table',$hdrkey);
			if (is_array($hdrvalue)) {
				foreach ($hdrvalue as $key => $value)
					if (!is_numeric($key)) {
						$t->set_var('field',$key);
						$t->set_var('value',$value);
						$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
						$t->set_var('tr_color',$tr_color) ;
						$t->parse('header_section','header', True);
						}
				$t->set_var('table',"");
				$t->set_var('field',"");
				$t->set_var('value',"");
				$t->set_var('tr_color',$th_bg) ;
				$t->parse('header_section','header', True);
				}
			else if (!is_numeric($hdrkey)) {
				$t->set_var('field',$hdrkey);
				$t->set_var('value',$hdrvalue);
				$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
				$t->set_var('tr_color',$tr_color) ;
				$t->parse('header_section','header', True);
				}
			}
		}
	   else $t->set_var('header_section','') ;
	if ($l[detail]<>"") {
		$detail = unserialize($l[detail]) ;
		foreach ($detail as $detkey => $detail_i) {
			foreach ($detail_i as $key_i => $val_i) {
				$t->set_var('table',$detkey);
				$detail_id = $val_i['id'] ;
				foreach ($val_i as $key => $value)
					if (!is_numeric($key)) {
						$t->set_var('detail_id',$detail_id);
						$t->set_var('field',$key);
						$t->set_var('value',$value);
						$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
						$t->set_var('tr_color',$tr_color) ;
						$t->parse('detail_section','detail', True);
						}
				$t->set_var('table',"");
				$t->set_var('detail_id',"");
				$t->set_var('field',"");
				$t->set_var('value',"");
				$t->set_var('tr_color',$th_bg) ;
				$t->parse('detail_section','detail', True);
				}
			}
		}
	   else $t->set_var('detail_section','') ;
	}

    }

?>
