<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: logfilter_validate.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'log' ;
	$noheader = $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$op = ($_GET["op"]) ? $_GET["op"] : $_POST["op"] ;
	$from_date = ($_GET["from_date"]) ? $_GET["from_date"] : $_POST["from_date"] ;
	$to_date = ($_GET["to_date"]) ? $_GET["to_date"] : $_POST["to_date"] ;
	$from_id = ($_GET["from_id"]) ? $_GET["from_id"] : $_POST["from_id"] ;
	$to_id = ($_GET["to_id"]) ? $_GET["to_id"] : $_POST["to_id"] ;
	$script = ($_GET["script"]) ? $_GET["script"] : $_POST["script"] ;
	$ip = ($_GET["ip"]) ? $_GET["ip"] : $_POST["ip"] ;
	$userid = ($_GET["userid"]) ? $_GET["userid"] : $_POST["userid"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	$err="" ;  $error=lang("Error") ;  $markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	
	$choices = "ALL,new,edit,delete,clear,start" ;
	if (substr_count($choices,$op)<=0)	$err=lang("Invalid Operation choice")." - $op" ;
	if ($from_date<>"") {
		$date = input2date($from_date) ;
		if ($date=="")	$err="[$from_date]".lang("Invalid date");
			else	{
				$year = substr($from_date,0,4) ;
				$month = substr($from_date,5,2) ;
				$day = substr($from_date,8,2) ;
				$from_d = mktime(0,0,0,$month,$day,$year) ;
				}
		}
	if ($to_date<>"") {
		$date = input2date($to_date) ;
		if ($date=="")	$err="[$to_date]".lang("Invalid date");
			else	{
				$year = substr($to_date,0,4) ;
				$month = substr($to_date,5,2) ;
				$day = substr($to_date,8,2) ;
				$to_d = mktime(0,0,0,$month,$day+1,$year) ;
				}
		}

	if (strlen($from_id)>15)		$err="[$from_id]".lang("Search string too long") ;
	if (strlen($to_id)>15)			$err="[$to_id]".lang("Search string too long") ;
	if (strlen($script)>15)			$err="[$script]".lang("Search string too long") ;
	if (strlen($ip)>15)			$err="[$ip]".lang("Search string too long") ;
	if (strlen($userid)>15)			$err="[$userid]".lang("Search string too long") ;
	if (substr_count($from_id,$markpri)>0)	$err="[$from_id]".lang("Search string contains reserved pattern")." - $markpri";
	if (substr_count($from_id,$marksec)>0)	$err="[$from_id]".lang("Search string contains reserved pattern")." - $marksec";
	if (substr_count($to_id,$markpri)>0)	$err="[$to_id]".lang("Search string contains reserved pattern")." - $markpri";
	if (substr_count($to_id,$marksec)>0)	$err="[$to_id]".lang("Search string contains reserved pattern")." - $marksec";
	if (substr_count($script,$markpri)>0)	$err="[$script]".lang("Search string contains reserved pattern")." - $markpri";
	if (substr_count($script,$marksec)>0)	$err="[$script]".lang("Search string contains reserved pattern")." - $marksec";
	if (substr_count($ip,$markpri)>0)	$err="[$ip]".lang("Search string contains reserved pattern")." - $markpri";
	if (substr_count($ip,$marksec)>0)	$err="[$ip]".lang("Search string contains reserved pattern")." - $marksec";
	if (substr_count($userid,$markpri)>0)	$err="[$userid]".lang("Search string contains reserved pattern")." - $markpri";
	if (substr_count($userid,$marksec)>0)	$err="[$userid]".lang("Search string contains reserved pattern")." - $marksec";
	if (substr_count($from_id," ")>0)	$err="[$from_id]".lang("Search string should not contain space(s)");
	if (substr_count($to_id," ")>0)		$err="[$to_id]".lang("Search string should not contain space(s)");
	if (substr_count($script," ")>0)	$err="[$script]".lang("Search string should not contain space(s)");
	if (substr_count($ip," ")>0)		$err="[$ip]".lang("Search string should not contain space(s)");
	if (substr_count($userid," ")>0)	$err="[$userid]".lang("Search string should not contain space(s)");

	if ($err)	$err = "<b>$error:  $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

	if (!$err)
		{
					$logfilter .= $markpri."01=1";
		if ($op<>'ALL')		$logfilter .= $markpri."1op".$marksec.$op ;
		if ($from_date)		$logfilter .= $markpri."2timestamp".$marksec.$from_d ;
		if ($to_date)		$logfilter .= $markpri."5timestamp".$marksec.$to_d ;
		if ($from_id)		$logfilter .= $markpri."2trans_id".$marksec.$from_id ;
		if ($to_id)		$logfilter .= $markpri."4trans_id".$marksec.$to_id ;
		if ($script)		$logfilter .= $markpri."6script".$marksec.$script ;
		if ($ip)		$logfilter .= $markpri."6ip".$marksec.$ip ;
		if ($userid)		$logfilter .= $markpri."6userid".$marksec.$userid ;

		$logfilter = urlencode($logfilter) ;
		Header('Location: '.$phpgw->link("/$app/${tran}list.php","logfilter=$logfilter"));
		$phpgw->common->phpgw_exit();
		}
	else
		{
		$getstr = "op=$op&from_date=$from_date&to_date=$to_date&from_id=$from_id&" ;
		$getstr.= "to_id=$to_id&script=$script&ip=$ip&userid=$userid&err=$err" ;
		Header('Location: '.$phpgw->link("/$app/${tran}filter.php",$getstr));
		$phpgw->common->phpgw_exit();
		}
?>

