<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: loglist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'log' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$return = ($_GET["return"]) ? $_GET["return"] : $_POST["return"] ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$logfilter = ($_GET["logfilter"]) ? $_GET["logfilter"] : $_POST["logfilter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = urldecode(stripslashes($logfilter)) ;

	$proc = CreateObject('ck-api.process') ;
	$where = $proc->decode_where($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$nm = CreateObject('phpgwapi.nextmatchs') ;
	$t->set_file(array('report' => "${tran}list.tpl", 'detail' => "${tran}list.tpl"));
	$t->set_block('detail','detail_row','detail_section');

//---------------------------- list variable template-declarations -------------------------

	$user = $ckapi[hostsys][username];
	$sql = "SELECT rolecode FROM ${pre}role a, ${pre}employee b " ;
	$sql.= "WHERE b.username='$user' and b.id = a.empid" ;
	$phpgw->db->query($sql);
	$allowaccess = False ;
	while ($phpgw->db->next_record()) {
		$role = $phpgw->db->f('rolecode') ;
		if ($role=='Auditor' or $role=='AudMgr') {$allowaccess=True;	break;}
		}
	if (!$allowaccess) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}

$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
$tr_color2 = $ckapi[hostsys][tr_color2] ;
$t->set_var('lang_title',lang('List of log entries'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('done'));
if (!$return)	$return = "/$app/${tran}filter.php" ;
$t->set_var('add_action',$phpgw->link($return,"filter=$filter"));
$t->set_var('lang_year',lang('Year'));
$t->set_var('lang_month',lang('Month'));
$t->set_var('lang_day',lang('Day'));
$t->set_var('lang_time',lang('Time'));
$t->set_var('lang_view',lang('View'));

$getstr = "return=$return&logid=$logid&logfilter=$logfilter" ;
if (isset($id))	$getstr = "id=$id&filter=$filter&$getstr" ;
$script = "/$app/${tran}list.php" ;
$t->set_var('sort_timestamp',$phpgw->nextmatchs->show_sort_order($sort,'timestamp',$order,$script,lang('Timestamp'),"&$getstr"));
$t->set_var('sort_trans_id',$phpgw->nextmatchs->show_sort_order($sort,'trans_id',$order,$script,lang('Transaction ID'),"&$getstr"));
$t->set_var('sort_app',$phpgw->nextmatchs->show_sort_order($sort,'app',$order,$script,lang('Application'),"&$getstr"));
$t->set_var('sort_op',$phpgw->nextmatchs->show_sort_order($sort,'op',$order,$script,lang('Operation'),"&$getstr"));
$t->set_var('sort_script',$phpgw->nextmatchs->show_sort_order($sort,'script',$order,$script,lang('Script'),"&$getstr"));
$t->set_var('sort_ip',$phpgw->nextmatchs->show_sort_order($sort,'ip',$order,$script,lang('IP'),"&$getstr"));
$t->set_var('sort_userid',$phpgw->nextmatchs->show_sort_order($sort,'userid',$order,$script,lang('User'),"&$getstr"));
$t->set_var('sort_id',$phpgw->nextmatchs->show_sort_order($sort,'id',$order,$script,lang('Log Table Id'), "&$getstr"));
$t->set_var('lang_view',lang('View'));

if (!$order)	$order = "timestamp" ;
if (!$sort)	$sort = "ASC" ;
if ($id)	$where = " trans_id = $id " ;
$sql =  "SELECT * from ${pre}log WHERE $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array('timestamp'	=> lang("No Matching Item Found"),
			'year'	=> "",
			'month'	=> "",
			'day'	=> "",
			'time'	=> "",
			'trans_id'	=> "",
			'app'	=> "",
			'op'	=> "",
			'script'=> "",
			'ip'	=> "",
			'userid'=> "",
			'id'	=> "",
			'view'	=> "",
				 ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',True);
	}
while ($phpgw->db->next_record()) {
	$logid = $phpgw->db->f('id') ;
	$timestamp = $phpgw->db->f('timestamp') ;
	$op = $phpgw->db->f('op') ;
	$getstr = "return=$return&logid=$logid&logfilter=$logfilter" ;
	if (isset($id))	$getstr = "id=$id&filter=$filter&$getstr" ;
	switch ($op) :
		case "new" :	$lang_op = lang("new");		break;
		case "edit" :	$lang_op = lang("edit");	break;
		case "delete" :	$lang_op = lang("delete");	break;
		case "marker" :	$lang_op = lang("marker");	break;
		case "clear" :	$lang_op = lang("clear");	break;
		case "import" :	$lang_op = lang("import");	break;
		case "approve":	$lang_op = lang("approve");	break;
		case "cancel":	$lang_op = lang("cancel");	break;
		case "reject":	$lang_op = lang("reject");	break;
		default:	$lang_op = lang("Error: please inform sysadmin");	break;
		endswitch ;
	$t->set_var(array(	'timestamp'	=> $timestamp,
			'year'	=> date("Y",$timestamp),
			'month'	=> date("m",$timestamp),
			'day'	=> date("d",$timestamp),
			'time'	=> date("H:i:s",$timestamp),
			'trans_id'	=> $phpgw->db->f('trans_id'),
			'app'	=> $phpgw->db->f('app'),
			'op'	=> $lang_op,
			'script'=> $phpgw->db->f('script'),
			'ip'	=> $phpgw->db->f('ip'),
			'userid'=> $phpgw->db->f('userid'),
			'id'	=> $phpgw->db->f('id'),
			'view'	=> $phpgw->link("/$app/${tran}view.php",$getstr),
						)) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','detail','report');
	$phpgw->common->phpgw_footer();

?>
