<?php
 /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: invpayhist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ap' ;
	$tran = 'invoice' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$filter=stripslashes($filter);

	$invoice = CreateObject("$app.$tran") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$ckapi[objects][template] = &$t ;
	$t->set_file('report','invpayhistscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('View Invoice Payment History'));
	$t->set_var('readonly','readonly');
	$t->set_var('disabled','disabled');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

/*------------- Write Invoice to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}ap WHERE id='$id'");
	$phpgw->db->next_record();
	$ckapi[params_post][dt] = $phpgw->db->Record ;
	$duedate = $phpgw->db->f('duedate') ;
	$invamount = $phpgw->db->f('amount') ;
	$netamount = $phpgw->db->f('netamount') ;
	$ckapi[params_post][dt][taxstatus] = ($invamount==$netamount) ? "e" : $phpgw->db->f('taxincluded') ;
	$invoice->invoice_header_write() ;

	$t->set_var('lang_date',lang('Date'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_paymentid',lang('Payment ID<br>/Days Overdue'));
	$t->set_var('lang_payamount',lang('Payment Amount'));
	$t->set_var('lang_samount',lang('Amount Settled<br>against this Invoice'));
	$t->set_var('lang_osamount',lang('Outstanding<br>Invoice Amount'));
	$t->set_var('lang_title_detail',lang('Detail'));

	$t->set_var('date',$duedate);
	$t->set_var('description',"<- ".lang('Due Date')." / ".lang('Invoice Amount')." ->");
	$t->set_var('paymentid','');
	$t->set_var('payamount','');
	$t->set_var('samount','');
	$t->set_var('osamount',$invamount);
	$t->set_var('lang_item',lang('Invoice'));
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	$ifilter = urlencode("${markpri}1a.id${marksec}${id}") ;
	$tran1 = ($invamount==$netamount) ? "invoicent" : "invoicewt" ;
	$item = $phpgw->link("/$app/${tran1}view.php","id=$id&filter=$ifilter");
	$t->set_var('item',$item) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$sql = "SELECT transdate,id,paynumber,amount,s_amount FROM ${pre}payment a, ${pre}p_match b " ;
	$sql.= "WHERE invoiceid='$id' and id=paymentid ORDER BY transdate" ;
	$phpgw->db->query($sql);
	$osamount = $invamount ;
	while ($phpgw->db->next_record()) {
		$t->set_var('date',$phpgw->db->f('transdate'));
		$lang_payno = lang('Pay#/Cheque#') ;
		$t->set_var('description',"$lang_payno:    ".$phpgw->db->f('paynumber'));
		$id = $phpgw->db->f('id');
		$t->set_var('paymentid',$id);
		$t->set_var('payamount',$phpgw->db->f('amount'));
		$samount = $phpgw->db->f('s_amount') ;
		$t->set_var('samount',$samount);
		$osamount -= $samount ;
		$t->set_var('osamount',$osamount);
		$t->set_var('lang_item',lang('Payment'));
		$pfilter = urlencode("${markpri}1a.id${marksec}${id}") ;
		$item = $phpgw->link("/$app/paymentview.php","id=$id&filter=$pfilter");
		$t->set_var('item',$item) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',date("Y-m-d"));
	$t->set_var('description',"<- ".lang('System Date')." / ".lang("Days Overdue")." ->");
	$overdue = (time()-strtotime($duedate))/86400 ;
	$overdue = ($overdue<0 or $osamount<=0) ? lang("N/A") : floor($overdue) ;
	$t->set_var('paymentid',$overdue);
	$t->set_var('payamount','');
	$t->set_var('samount','');
	$t->set_var('osamount','');
	$t->set_var('lang_item','');
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('action',$phpgw->link("/$app/${tran1}list.php","filter=$filter")) ;
	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->set_var('lang_update',lang('Done'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran1}list.php","filter=$filter")) ;
	$t->set_var('lang_done',lang('Done'));
	$msg = lang('Press [done] button at Detail screen to work on detail transaction maintenance');
	$t->set_var('message',$msg);
	$t->pparse('out','report',True);

?>
