<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: receiptfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ar' ;
	$tran = 'receipt' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$msg1 = lang('To search for all items, leave fields blank.') ;
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among posted receipts :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Receipt") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$warning=lang("Make sure you have completed all payment allocation before checking on unallocated payments") ;
	$ckapi[filter][] = array(criteria	=>	lang('Customer') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.customer_selectlist("","") ,
				varname		=>	'customer' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate customer') );

	$ckapi[filter][] = array(criteria	=>	lang('Currency') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.isocode_selectlist("","") ,
				varname		=>	'isocode' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate currency') );

	$ckapi[filter][] = array(criteria	=>	lang('Receipt Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	lang('Receipt Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	lang('Receipt Number') ,
				type		=>	'input' ,
				varname		=>	'rptnumber' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word/number in the receipt number field') );

	$ckapi[filter][] = array(criteria	=>	lang('Remark') ,
				type		=>	'input' ,
				varname		=>	'remark' ,
				defval		=>	"" ,
				note	=>lang('Search for target key word/number in the remark field') );

	$ckapi[filter][] = array(criteria	=>	lang('Unallocated Receipt Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	lang("Click box if only non fully allocated receipts are to be retrieved")."<br><b>".$warning."</b>" );

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
