<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.statement.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class statement {

//---- Statement Item List SQL Formation

    function statement_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_bankac',lang('Bank Account'));
	list($dummy,$chart_id) = explode("'",$where) ;
	$phpgw->db->query("SELECT accno,description FROM ${pre}chart WHERE id='$chart_id'");
	$phpgw->db->next_record() ;
	$bankac = $phpgw->db->f('accno')."--".$phpgw->db->f('description') ;
	$t->set_var('bankac',$bankac);

	$sql =  "SELECT * FROM ${pre}bkr_trans WHERE substring(source,1,2)='SI' $where ORDER BY ".$order." ".$sort ;
	return $sql ;
	}

//---- Statement Item Read

    function statement_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$phpgw->db->query("select * from ${pre}bkr_trans where trans_id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	return $dt ;
	}

//---- Statement Item Detail Validation Checks

    function statement_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	if (!$dt[transdate])			$err=lang("Transaction date missing") ;
	if (!$dt[amount])			$err=lang("Amount missing") ;
	if ($dt[transdate] and input2date($dt[transdate])=="")
						$err=lang("Invalid transaction date");
	if ($dt[amount] and !is_numeric($dt[amount]))	$err=lang("Amount must be numeric");
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Statement Item Detail

    function statement_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID'));
	$t->set_var('lang_chart_id',lang('Bank Account'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_transdate',lang('Transaction Date'));
	$t->set_var('lang_refnumber',lang('Reference#'));
	$t->set_var('lang_source',lang('Source'));
	$t->set_var('lang_cheque',lang('Cheque#'));
	$t->set_var('lang_amount',lang('Amount'));

	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$default = ($dt[chart_id]) ? "$dt[chart_id]" : "" ;
	$chart_id_sl = account_selectlist("WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'",$default);
	$t->set_var('chart_id_selectlist',$chart_id_sl);
	$t->set_var('description',$dt[description]);
	$t->set_var('transdate',$dt[transdate]);
	$t->set_var('refnumber',$dt[refnumber]);
	$source_sl = str_replace("'$dt[source]'","'$dt[source]'"." selected",si_source_selectlist() ) ;
	$t->set_var('source_selectlist',$source_sl);
	$t->set_var('cheque',$dt[cheque]);
	$t->set_var('amount',$dt[amount]);
	$t->parse('out','report',True);
	}


//---- Statement Item Post Initialisation

    function statement_post_init() {
	global $ckapi ;

	$ckapi[params_post][dt][trans_id] = $ckapi[params_post][dt][id] ;
	}

//---- Statement Item Post - PreCommit Routine

    function statement_post_precommit() {
	global $ckapi,$phpgw ;

	$table = $ckapi[params][table] ;
	if ($ckapi[params_post][op]=='new')	$phpgw->db->query("UPDATE $table SET trans_id=id") ;
	}

    }

?>
