<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: statementfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'statement' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$msg1 = lang('To search for all items, leave fields blank.') ;
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'=>lang('Search among Reconciliation Worksheet Statement Items :'),
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Statement Item") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

$bankac_sl = account_selectlist("WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'",'');
	$ckapi[filter][] = array(criteria	=>	lang('Bank Account') ,
				type		=>	'select' ,
				selectlist	=>	$bankac_sl ,
				varname		=>	'chart_id' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate bank account')	) ;

	$ckapi[filter][] = array(criteria	=>	lang('Statement Item Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Statement Item Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Source') ,
				type		=>	'input' ,
				varname		=>	'source' ,
				defval		=>	"" ,
				note		=>lang('Search for target keyword in item source field') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Description') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	"" ,
				note	=>lang('Search for target keyword in item description field') ) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
