<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: importorgprslist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-contact' ;
	$tran = 'importorgprs' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'import',
				'tran'		=> $tran ,
				'table'		=> "${pre}org_person" ,
				'doneexit'	=> "importorgprsbulk.php"		);
				
	$msg1 = lang("Only previously unimported links [relating to imported organizations and persons] will be imported.") ;
	$msg2 = lang("Links that had been overtaken by manually created organization<=>person connections within ck-contact will not be imported.") ;
	$msg3 = lang("It is advisable to save or print a copy of this list for future reference.") ;
	$msg4 = lang("Because of semantic difference, the field [preferred] is not imported.") ;
	$ckapi[phrases] = array('lang_title'	=> lang("List of Contact Organization<=>Person Links to be imported"),
				'lang_add'	=> lang("Start Bulk Import") ,
				'linkmark'	=> "<=>" ,
				'message'	=> "$msg1  $msg2  $msg3  $msg4"		);
	$ckapi[columns] = array('org_id'	=> lang('Org ID [Host System]') ,
				'orgnumber'	=> lang('Organization shortname/#') ,
				'orid'		=> lang('Org ID [ck-contact]') ,
				'pid'		=> lang('Person ID [ck-contact]') ,
				'prsnumber'	=> lang('Person_s shortname/#') ,
				'person_id'	=> lang('Person ID [Host System]') ,
				'title'		=> lang('Title') ,
				'department'	=> lang('Department')			);
	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

	if ($ckapi[params][temp]<>"") {
		$temp = $ckapi[params][temp] ;
		$phpgw->db->query("DROP TABLE $temp");
		}
?>
