<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: employeefilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-hr' ;
	$tran = 'employee' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'employee',
				'tran'		=> $tran ,
				'table'		=> "${pre}employee" 			) ;
	$msg1 = lang('To search for all items, leave fields blank.');
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Employees :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Achievement Code") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$lang_prefix = lang('prefix') ;
	$lang_suffix = lang('suffix') ;
	$t->set_var('prefix_sl',hrcodename_selectlist("WHERE type='$lang_prefix'",$e[prefix],"name","short"));

	$ckapi[filter][] = array(criteria	=>	lang('Prefix') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.hrcodename_selectlist("WHERE type='$lang_prefix'",'',"name","short") ,
				varname		=>	'prefix' ,
				defval		=>	'' ,
				note		=>	lang('Search for target Employee Name Prefix'));

	$ckapi[filter][] = array(criteria	=>	lang('Suffix') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.hrcodename_selectlist("WHERE type='$lang_suffix'",'',"name","short") ,
				varname		=>	'suffix' ,
				defval		=>	'' ,
				note		=>	lang('Search for target Employee Name Suffix')) ;

	$ckapi[filter][] = array(criteria	=>	lang('Employee Name/#') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Employee Name/# Field') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Family Name') ,
				type		=>	'input' ,
				varname		=>	'family' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Employee Family Name Field') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Given Name') ,
				type		=>	'input' ,
				varname		=>	'given' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Employee Given Name Field') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('National ID') ,
				type		=>	'input' ,
				varname		=>	'nationalid' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Employee National ID Field') ) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
