<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: employeelist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-hr' ;
	$tran = 'employee' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'employee',
				'tran'		=> $tran ,
				'table'		=> "${pre}employee" 			);
	$msg1 = lang("EC - Emergency Contact; PR - Performance Review") ;
	$ckapi[phrases] = array('lang_title'	=> lang("Employee List") ,
				'lang_auxiinfo'	=> lang('Edit Auxillary Employee Information') ,
				'lang_add'	=> lang("Add New Employee") ,
				'message'	=> $msg1				);
	$ckapi[columns] = array('name'		=> lang('Employee Name/#') ,
				'family'	=> lang('Family Name') ,
				'given'		=> lang('Given Name') ,
				'id'		=> lang('Audit ID') 			);
	$ckapi[links] = array(	'view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'photo'		=> "/$app/photoedit.php" ,
				'address'	=> "/$app/addressedit.php" ,
				'phone'		=> "/$app/phoneedit.php" ,
				'email'		=> "/$app/emailedit.php" ,
				'ec'		=> "/$app/ecedit.php" ,
				'dates'		=> "/$app/datesedit.php" ,
				'leave'		=> "/$app/leaveedit.php" ,
				'pr'		=> "/$app/predit.php" ,
				'role'		=> "/$app/roleedit.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_photo'	=> lang("Photo") ,
				'lang_address'	=> lang("Address") ,
				'lang_phone'	=> lang("Phone") ,
				'lang_email'	=> lang("Email") ,
				'lang_ec'	=> lang("EC") ,
				'lang_dates'	=> lang("Dates") ,
				'lang_leave'	=> lang("Leave") ,
				'lang_pr'	=> lang("PR") ,
				'lang_role'	=> lang("Role") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")		) ;
	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

?>
