<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.achieve.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class achieve {

//---- Achievement Code Detail Validation Checks

    function achieve_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	if ($dt[name]=="")		$err=lang('Achievement Code Name Missing');
	if ($dt[description]=="")	$err=lang('Achievement description Missing');
	if (!is_numeric($dt[min]))	$err=lang('Min Level must be numeric');
	if (!is_numeric($dt[max]))	$err=lang('Max Level must be numeric');
	if (!is_numeric($dt[rate]))	$err=lang('Rate must be numeric');
	if (isset($dt[min]) and isset($dt[max]) and $dt[min]>$dt[max])
					$err=lang('Min Level > Max Level') ;
	if ($dt[name]<>$dt[oldname]) {
		$phpgw->db->query("SELECT * from ${pre}achievement where name='$dt[name]'");
		if ($phpgw->db->num_rows()>0)	$err = lang("Achievement Name already exists") ;
		}
	if ($err)			$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Achievement Code Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$errmsg1 = lang("This achievement is in use within an existing") ;
	$timesheet = lang("timesheet") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}ts_trans where achieve='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $timesheet id#".$phpgw->db->f('trans_id') ;
		}
	if ($dt[name]=='not_applicable')
		$err = lang("Achievement 'not_applicable' should not be deleted") ;
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Achievement Code Detail

    function achieve_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_name',lang('Achievement Code Name'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_min',lang('Minimum Level'));
	$t->set_var('lang_max',lang('Maximum Level'));
	$t->set_var('lang_rate',lang('Pay Rate'));
	$id = $dt[id] ;
	$t->set_var('id',$id);
	$t->set_var('control',$dt[control]);
	$t->set_var('name',$dt[name]);
	$t->set_var('oldname',$dt[oldname]);
	$t->set_var('description',$dt[description]);
	$t->set_var('min',$dt[min]);
	$t->set_var('max',$dt[max]);
	$t->set_var('rate',$dt[rate]);
	$t->parse('out','report',True);
	}

    }

?>
