<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-hr' ;
	$tran = 'report' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$msg1 = lang('Generation of Human Resources report requires lengthy processing time.') ;
	$msg2 = lang('You should initiate report generation only during off-peak hours.') ;
	$title = lang("Choose Report to Generate and to set Report Parameters :") ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> lang("Reporting Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Report Generation") ,
				'lang_add'	=> lang("Return to Index Page") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$eventmsg = lang('Event notification date falling within (from/to) period will be listed.') ;
	$lang_date = lang('date') ;
	$event_selectlist = "<OPTION value=''></OPTION>" ;
	$event_selectlist.= hrcodename_selectlist("WHERE type='$lang_date'",'',"long") ;
	$note1 = lang("If wrong report chosen, click [Report] to restart.") ;
	$note1a = lang("Press [Start Report Generation] one more time to start.") ;
	$dateformat = lang('Format: YYYY-MM-DD') ;

	$ckapi[filter][] = array(criteria	=>	lang('Which Report') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	$note1				) ;

	$ckapi[filter][] = array(criteria	=>	lang('Which Event') ,
				type		=>	'select' ,
				selectlist	=>	$event_selectlist ,
				varname		=>	'event' ,
				defval		=>	'' ,
				note		=>	lang('Select the target event against which notification is to be issued') 									) ;

	$ckapi[filter][] = array(criteria	=>	lang('Notification Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$eventmsg  $dateformat"		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Notification Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$eventmsg  $dateformat"		) ;

	$lang_reserved = lang('Reserved') ;
	$report1 = lang('Human Resources Notification List') ;
	$report5 = lang('Human Resources Audit Control Report') ;
	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>1 -- $report1</OPTION>",
						2=>	"<OPTION value='2'>2 -- $lang_reserved</OPTION>",
						3=>	"<OPTION value='3'>3 -- $lang_reserved</OPTION>",
						4=>	"<OPTION value='4'>4 -- $lang_reserved</OPTION>",
						5=>	"<OPTION value='5'>5 -- $report5</OPTION>"	) ;
	$ckapi[filter][actstring] = array(	"0",	/* initial entry	*/
						"0123",	/* report 1	*/
						"0",	/* report 2	*/
						"0",	/* report 3	*/
						"0",	/* report 4	*/
						"0"	/* report 5	*/			) ;
	if ($_POST[actnum]<>"")	$ckapi[filter][0][note] = $note1a ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;

?>
