<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: timesheetfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-hr' ;
	$tran = 'timesheet' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'timesheet',
				'tran'		=> $tran ,
				'table'		=> "${pre}timesheet" 			) ;
	$msg1 = lang('To search for all items, leave fields blank.');
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Timesheets :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Timesheet") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$allopt = "<OPTION value='ALL'></OPTION>" ;
	$nullopt = "<OPTION value=''></OPTION>" ;
	$tsmsg = lang('Timesheets falling within (from/to) period will be listed.') ;

	$ckapi[filter][] = array(criteria	=>	lang('Year') ,
				type		=>	'select' ,
				selectlist	=>	$allopt.year_selectlist('','') ,
				varname		=>	'year' ,
				defval		=>	'' ,
				note		=>	lang('Search for Timesheets of the target Year'));

	$ckapi[filter][] = array(criteria	=>	lang('Week From') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.week_selectlist('','') ,
				varname		=>	'weekfrom' ,
				defval		=>	'' ,
				note		=>	$tsmsg					) ;

	$ckapi[filter][] = array(criteria	=>	lang('Week To') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.week_selectlist('','') ,
				varname		=>	'weekto' ,
				defval		=>	'' ,
				note		=>	$tsmsg					) ;

	$ckapi[filter][] = array(criteria	=>	lang('Employee Name/#') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Employee Name Field'));

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
