<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: assemblyfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-inv' ;
	$tran = 'assembly' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$msg1 = lang('To search for all items, leave fields blank.') ;
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Assembly Parts :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Assembly") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$ckapi[filter][] = array(criteria	=>	lang('Name/Number') ,
				type		=>	'input' ,
				varname		=>	'partnumber' ,
				defval		=>	"" ,
				note		=>	lang('Search for target character/numeric combination in the Assembly Part Name/# field') );

	$ckapi[filter][] = array(criteria	=>	lang('Description') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word in the Assembly Part Description field') ) ;

	$ckapi[filter][] = array(criteria	=>	lang('Notes') ,
				type		=>	'input' ,
				varname		=>	'notes' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word in the Assembly Part Notes field') ) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
