<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: iafilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-inv' ;
	$tran = 'ia' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> 'il'			) ;
	$msg1 = lang('To search for all items, leave fields blank.') ;
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among posted Inventory Adjustments (IA) :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Inventory Adjustment") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);
	$datenote = lang('Must be a valid date (format: YYYY-MM-DD)') ;
	$ckapi[filter][] = array(criteria	=>	lang('Inventory Adjustment Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	$datenote			) ;

	$ckapi[filter][] = array(criteria	=>	lang('Inventory Adjustment Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	$datenote			) ;

	$ckapi[filter][] = array(criteria	=>	lang('Source') ,
				type		=>	'input' ,
				varname		=>	'source' ,
				defval		=>	"" ,
				note		=>lang('Search for target key word in the IA source field')) ;

	$ckapi[filter][] = array(criteria	=>	lang('Description') ,
				type		=>	'input' ,
				varname		=>	'description' ,
				defval		=>	"" ,
				note	=>lang('Search for target key word in the IA description field')) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
