<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: accounthist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ledger' ;
	$tran = 'account' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$end = ($_GET["end"]) ? $_GET["end"] : $_POST["end"] ;
	$attrib1 = ($_GET["attrib1"]) ? $_GET["attrib1"] : $_POST["attrib1"] ;
	$attrib2 = ($_GET["attrib2"]) ? $_GET["attrib2"] : $_POST["attrib2"] ;
	$attrib3 = ($_GET["attrib3"]) ? $_GET["attrib3"] : $_POST["attrib3"] ;
	$filter=stripslashes($filter);

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report','accounthist.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_var('lang_title',lang('View Account Journal History'));
	$t->set_var('lang_notes',lang('Press (done) button at View Detail screen to go on to transaction maintenance'));
	$t->set_var('message','') ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

/*------------- Validate History Start and End Date ----------------------------*/

	$err=""; $error = lang('Error') ;
	if (isset($start))	if (input2date($start)=="")	$err=lang("Invalid History Start Date");
	if (isset($end))	if (input2date($end)=="")	$err=lang("Invalid History End Date");

	$end = (!$end) ? date("Y-m-d") : $end ;
	$start = (!$start) ?date("Y-m-d",mktime(0,0,0,substr($end,5,2)-1,1,intval(substr($end,0,4)))) :$start;
	if ($start>$end)			$err=lang("History Start later than End Date");

	$phpgw->db->query("SELECT * FROM ${pre}chart WHERE id='$id'");
	$phpgw->db->next_record();
	$type = $phpgw->db->f('charttype') ;
	$desc = $phpgw->db->f('accno')." -- ".$phpgw->db->f('description') ;

	if ($type<>"A")				$err=lang("No history for non-posting A/C") ;
	if ($err)	$err="<b>$error:  $err</b>" ;

/*------------- Write Header to Screen Display ----------------------------*/

	$t->set_var('lang_account',lang('Account'));
	$t->set_var('lang_start',lang('Start Date'));
	$t->set_var('lang_end',lang('End Date'));
	$t->set_var('lang_id',lang('Audit ID'));

	$t->set_var('desc',$desc);
	$t->set_var('id',$id) ;
	$t->set_var('start',$start);
	$t->set_var('end',$end) ;

	if ($attrib1<>'' or $attrib2<>'' or $attrib3<>'') {
		$phpgw->db->query("Select * from ${pre}defaults");
		$phpgw->db->next_record();
		$a1cap = $phpgw->db->f('attrib1cap');	$a1tbl = $phpgw->db->f('attrib1tbl');	$a1ldf = $phpgw->db->f('attrib1ldesc');
		$a2cap = $phpgw->db->f('attrib2cap');	$a2tbl = $phpgw->db->f('attrib2tbl');	$a2ldf = $phpgw->db->f('attrib2ldesc');
		$a3cap = $phpgw->db->f('attrib3cap');	$a3tbl = $phpgw->db->f('attrib3tbl');	$a3ldf = $phpgw->db->f('attrib3ldesc');

		if ($attrib1<>'') {
			$phpgw->db->query("Select * from ${pre}$a1tbl where id=$attrib1");
			$phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a1ldf") ;
			$t->set_var('attrib1line',"$a1cap:  $ldesc");
			}
		   else $t->set_var('attrib1line',"");
		if ($attrib2<>'') {
			$phpgw->db->query("Select * from ${pre}$a2tbl where id=$attrib2");
			$phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a2ldf") ;
			$t->set_var('attrib2line',"$a2cap:  $ldesc");
			}
		   else $t->set_var('attrib2line',"");
		if ($attrib3<>'') {
			$phpgw->db->query("Select * from ${pre}$a3tbl where id=$attrib3");
			$phpgw->db->next_record();
			$ldesc = $phpgw->db->f("$a3ldf") ;
			$t->set_var('attrib3line',"$a3cap:  $ldesc");
			}
		   else $t->set_var('attrib3line',"");
		}
	   else {
		$t->set_var('attrib1line',"");
		$t->set_var('attrib2line',"");
		$t->set_var('attrib3line',"");
		}

/*------------- Write History to Screen Display ----------------------------*/

	$t->set_var('lang_date',lang('Date'));
	$t->set_var('lang_description',lang('Journal Description'));
	$t->set_var('lang_trans_id',lang('Audit ID'));
	$t->set_var('lang_dr',lang('Debit'));
	$t->set_var('lang_cr',lang('Credit'));
	$t->set_var('lang_bal',lang('Balance (dr/cr)'));
	$t->set_var('lang_viewdetail',lang('View Detail'));
	$lang_dr = lang('dr') ;

if ($err=="") {

	$sql =	"SELECT sum(amount) as amount FROM ${pre}acc_trans " ;
	$sql.=	"WHERE chart_id='$id' and transdate<'$start'" ;
	if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
	if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
	if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record() ;
	$bal =	$phpgw->db->f('amount') ;
	$t->set_var('date',$start);
	$t->set_var('description',lang('Balance Brought Forward'));
	$t->set_var('trans_id','');
	$t->set_var('dr','');
	$t->set_var('cr','');
	$balance = $bal>= 0 ? sprintf("%01.2f",$bal) : sprintf("%01.2f",-$bal)." [$lang_dr]" ;
	$t->set_var('bal',$balance);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);

	$sql = "SELECT a.transdate,trans_id,substring(source,1,4) as transcode,description,amount " ;
	$sql.= "FROM ${pre}acc_trans a, ${pre}gl b " ;
	$sql.= "WHERE chart_id='$id' and a.trans_id=b.id and a.transdate>='$start' and a.transdate<='$end' " ;
	if ($attrib1<>'')	$sql .= " and attrib1=$attrib1 " ;
	if ($attrib2<>'')	$sql .= " and attrib2=$attrib2 " ;
	if ($attrib3<>'')	$sql .= " and attrib3=$attrib3 " ;
	$sql.= "ORDER BY a.transdate" ;
	$phpgw->db->query($sql);
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	while ($phpgw->db->next_record()) {
		$t->set_var('date',$phpgw->db->f('transdate'));
		$t->set_var('description',$phpgw->db->f('description'));
		$trans_id = $phpgw->db->f('trans_id') ;
		$transcode = $phpgw->db->f('transcode') ;
		$amount = $phpgw->db->f('amount') ;
		$dr = $amount>=0 ? "." : sprintf("%01.2f",-$amount) ;
		$cr = $amount>=0 ? sprintf("%01.2f",$amount) : "." ;
		$bal += $amount ;
		$t->set_var('trans_id',$trans_id);
		$t->set_var('dr',$dr);
		$t->set_var('cr',$cr);
		$balance = $bal>= 0 ? sprintf("%01.2f",$bal) : sprintf("%01.2f",-$bal)." [$lang_dr]" ;
		$t->set_var('bal',$balance);
		$jfilter = urlencode("${markpri}01=1${markpri}1id${marksec}$trans_id") ;
		$sfilter = urlencode("${markpri}1a.id${marksec}$trans_id") ;
		$t->set_var('journal',$phpgw->link("/$app/journalview.php","id=$trans_id&filter=$jfilter"));
		$t->set_var('lang_journal',lang("Journal"));
		switch ($transcode) :
			case "GLJL" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			case "APNT" :	$script = "/ck-ap/invoicentview.php" ;			break ;
			case "APWT" :	$script = "/ck-ap/invoicewtview.php" ;			break ;
			case "APPY" :	$script = "/ck-ap/paymentview.php" ;			break ;
			case "ARNT" :	$script = "/ck-ar/invoicentview.php" ;			break ;
			case "ARWT" :	$script = "/ck-ar/invoicewtview.php" ;			break ;
			case "ARRT" :	$script = "/ck-ar/receiptview.php" ;			break ;
			case "CSNT" :	$script = "/ck-pos-c/csntview.php" ;			break ;
			case "CSWT" :	$script = "/ck-pos-c/cswtview.php" ;			break ;
			case "CBTR" :	$script = "/ck-pos-m/cbtranview.php" ;			break ;
			case "PYRO" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			case "PYPY" :	$script = "/$app/journalview.php" ; $sfilter=$jfilter ;	break ;
			default : 	$script = "error" ;					break ;
			endswitch ;
		$t->set_var('origin',$phpgw->link("$script","id=$trans_id&filter=$sfilter"));
		$t->set_var('lang_origin',lang("Origin"));
		if ($script=="error")	{
			$t->set_var('origin',"");
			$t->set_var('lang_origin',"<b>".lang("Error")."</b>");
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('date',$end);
	$t->set_var('description',lang('Balance Carried Forward'));
	$t->set_var('trans_id','');
	$t->set_var('dr','');
	$t->set_var('cr','');
	$balance = $bal>= 0 ? sprintf("%01.2f",$bal) : sprintf("%01.2f",-$bal)." [$lang_dr]" ;
	$t->set_var('bal',$balance);
	$t->set_var('lang_journal',"");
	$t->set_var('journal',"");
	$t->set_var('lang_origin',"");
	$t->set_var('origin',"");
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail', True);
	}
else {
 	$t->set_var('message',$err);
	$t->set_var('detail_section',"") ;
	}

/*--------------------Write bottom Section------------------------------------------*/

	$getstr = "id=$id&filter=$filter&attrib1=$attrib1&attrib2=$attrib2&attrib3=$attrib3" ;
	$t->set_var('action',$phpgw->link("/$app/${tran}hist.php",$getstr)) ;
	$t->set_var('lang_regenerate',lang('Regenerate (after changing start/end date)'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php","filter=$filter")) ;
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);

?>
