<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: attriblist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ledger' ;
	$tran = 'attrib' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$attrib = ($_GET["attrib"]) ? $_GET["attrib"] : $_POST["attrib"] ;
	$caption = ($_GET["caption"]) ? $_GET["caption"] : $_POST["caption"] ;
	$table = ($_GET["table"]) ? $_GET["table"] : $_POST["table"] ;
	$sdfld = ($_GET["sdfld"]) ? $_GET["sdfld"] : $_POST["sdfld"] ;
	$ldfld = ($_GET["ldfld"]) ? $_GET["ldfld"] : $_POST["ldfld"] ;
	$qfield = ($_GET["qfield"]) ? $_GET["qfield"] : $_POST["qfield"] ;
	$filter = urldecode(stripslashes($filter)) ;
	$where = decode_where($filter,$table,$attrib) ;
	$filter = urlencode($filter) ;

	$attrib = isset($attrib) ? $attrib : $qfield ;
	$qfield = $attrib ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('report'=>"${tran}list.tpl", 'detail'=>"${tran}list.tpl"));
	$t->set_block('detail','detail_row','detail_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$msg1 = lang("This is for illustrative purpose only.") ;
	$msg2.= lang("Other modules will provide better facility to process these data.") ;
	$t->set_var('message',"$msg1  $msg2");

//---------------------------- list variable template-declarations -------------------------

$phpgw->db->query("Select * from ${pre}defaults");
$phpgw->db->next_record() ;
switch ($attrib) :
	case "1" :	$sdfld=$phpgw->db->f('attrib1sdesc');
			$ldfld=$phpgw->db->f('attrib1ldesc');
			$caption=$phpgw->db->f('attrib1cap'); break ;
	case "2" :	$sdfld=$phpgw->db->f('attrib2sdesc');
			$ldfld=$phpgw->db->f('attrib2ldesc');
			$caption=$phpgw->db->f('attrib2cap'); break ;
	case "3" :	$sdfld=$phpgw->db->f('attrib3sdesc');
			$ldfld=$phpgw->db->f('attrib3ldesc');
			$caption=$phpgw->db->f('attrib3cap'); break ;
	endswitch ;
$t->set_var('lang_title',lang("List of %1",$caption));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('sort_sdesc',$phpgw->nextmatchs->show_sort_order($sort,"$sdfld",$order,"/$app/${tran}list.php",$sdfld,$filter));
$t->set_var('sort_ldesc',$phpgw->nextmatchs->show_sort_order($sort,"$ldfld",$order,"/$app/${tran}list.php",$ldfld,$filter));
$t->set_var('sort_id',$phpgw->nextmatchs->show_sort_order($sort,'id',$order,"/$app/${tran}list.php",lang('Audit Id'),$filter));

if (!$order) $order = $sdfld ;
if (!$sort)  $sort = "ASC" ;
$sql =  "SELECT * from $table WHERE 1=1 $where order by ".$order." ".$sort ;
$phpgw->db->query($sql);

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'sdesc'		=> lang("No Matching Item Found"),
				'ldesc'		=> "",
				'id'		=> "",
				'lang_view'	=> "",
				'lang_edit'	=> "",
				'lang_copy'	=> "",
				'lang_delete'	=> "",
				'lang_log'	=> "" ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$getstr = "id=$id&attrib=$attrib&caption=$caption&" ;
	$getstr.= "table=$table&sdfld=$sdfld&ldfld=$ldfld&filter=$filter" ;
	$loggetstr = "return=/$app/${tran}list.php&$getstr" ;
	$t->set_var(array(	'sdesc'		=> $phpgw->db->f("$sdfld"),
				'ldesc'		=> $phpgw->db->f("$ldfld"),
				'id'		=> $id,
				'view'	=> $phpgw->link("/$app/${tran}view.php",$getstr),
				'edit'	=> $phpgw->link("/$app/${tran}edit.php",$getstr),
				'copy'	=> $phpgw->link("/$app/${tran}copy.php",$getstr),
				'delete'=> $phpgw->link("/$app/${tran}delete.php",$getstr),
				'log'	=> $phpgw->link('/ck-admin/loglist.php',$loggetstr)  ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_section','detail_row',true);
	}

// ---------------------------- end list records -----------------------------------------

	$t->set_var('lang_add',lang("Add New %1",$caption));
	$t->set_var('add_action',$phpgw->link("/$app/${tran}add.php",$getstr));
	$t->set_var('lang_edit',lang('Edit'));
	$t->set_var('lang_view',lang('View'));
	$t->set_var('lang_copy',lang('Copy/Modify'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_log',lang('Log'));
	$t->pparse('out','detail','report');



//---- Decode 'where' filter string

    function decode_where($filter,&$table,&$attrib) {
	global $ckapi,$phpgw ;

	if (trim($filter)<>"") {
		$markpri = "zzAnDzz" ;
		$marksec = "z2z1z3z" ;
		$pieces = explode($markpri,$filter) ;
		foreach ($pieces as $piece) {
			list($str1,$str2) = explode($marksec,$piece) ;
			$type = substr($str1,0,1) ;
			$str1 = substr($str1,1) ;
			if (strlen($str1)>15 or strlen($str2)>15) {
				echo "Please inform System Admin: Possible injected SQL attack -$piece==<br>";
				exit() ;
				}
			switch ($type) :
				case "x" :	$$str1 = $str2 ;			break ;
				case "0" :	$where .= "$str1 $str2" ;		break ;
				case "1" :	$where .= " AND $str1 = '$str2' " ;	break ;
				case "2" :	$where .= " AND $str1 >= '$str2' ";	break ;
				case "3" :	$where .= " AND $str1 > '$str2' ";	break ;
				case "4" :	$where .= " AND $str1 <= '$str2' ";	break ;
				case "5" :	$where .= " AND $str1 < '$str2' ";	break ;
				case "6" :	$where .= " AND lower($str1) like lower('%$str2%') ";  break;
				case "7" :	$where .= " AND OPEN " ;		break ;
//				case "8" :						break ;
				endswitch ;
			}
		}
	return $where ;
	}

?>
