<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.payjournal.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class payjournal {

//---- PayJournal List SQL Formation

    function payjournal_list_sql() {
	global $ckapi,$phpgw ;
	
	$pre = $ckapi[params][pre] ;
	$sortkey = $ckapi[params][sortkey] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$lang_from = lang('from') ;
	$lang_to = lang('to') ;
	$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
	$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
	$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
	$topos = "position('$tomarker' in description)+$tomarkerlen" ;
	$descdatefrom = "substring(description,$frompos,10)" ;
	$descdateto = "substring(description,$topos,10)" ;

	if (substr_count($where,"b.empid")>0) {
		list($dummy,$empidstr) = explode("b.empid",$where) ;
		list($dummy,$empid) = explode("'",$empidstr) ;
		}
	if (substr_count($where,"datefrom")>0) {
		list($dummy,$datestr) = explode("datefrom",$where) ;
		list($dummy,$datefrom) = explode("'",$datestr) ;
		}
	if (substr_count($where,"dateto")>0) {
		list($dummy,$datestr) = explode("dateto",$where) ;
		list($dummy,$dateto) = explode("'",$datestr) ;
		}
	$where = "" ;
	if ($empid)	$where .= " AND b.empid='$empid' ";
	if ($datefrom)	$where .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
	if ($dateto)	$where .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";

	if (!$order)	{if ($sortkey<>"")	$order=$sortkey;	else $order=$field1;}
	if (!$sort)	$sort = "ASC" ;
	$sql =	"SELECT b.empid,name,bankacname,bankac," ;
	$sql.=	"$descdatefrom as datefrom,$descdateto as dateto,amount,a.id as bpyroid,codeid as id " ;
	$sql.=	"FROM ${pre}gl a, ${pre}pyrohist b, ${pre}employee c, ${pre}payroll d " ;
	$sql.=	"WHERE 1=1 $where and source='PYRO' and trans_id=a.id and type='NETP' " ;
	$sql.=	"and b.empid=c.id and b.empid=d.empid " ;
	$sql.=	"order by $order $sort" ;

	return $sql ;
	}

//---- PayJournal List Link Adjustement

    function payjournal_list_adjust() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)		$$key = $value ;
	foreach ($ckapi[params_list][dt] as $key => $value)	$$key = $value ;
	$filter = $ckapi[params_list][filter] ;
	$t = &$ckapi[objects][template] ;
	if ($id==0) {
		$ckapi[params_list][dt][id]=='' ;
		$getstr = "empid=$empid&bpyroid=$bpyroid&datefrom=$datefrom&dateto=$dateto&filter=$filter" ;
		$t->set_var(array(	'id'		=> '' ,
					'lang_view'	=> '' ,
					'lang_delete'	=> '' ,
					'lang_log'	=> '' ,
					'view'		=> '' ,
					'genpj'		=> $phpgw->link("/$app/${tran}gen.php",$getstr) ,
					'delete'	=> '' ,
					'loge'		=> ''	)) ;
		}
	  else	$t->set_var(array(	'lang_genpj'	=> '',
					'genpj'		=> ''	)) ;
	$url = $ckapi[links][cheque] ;
	$empid = $ckapi[params_list][dt][empid] ;
	$amount = $ckapi[params_list][dt][amount] ;
	$getstr = "empid=$empid&amount=$amount&filter=$filter" ;
	$t->set_var('cheque',$phpgw->link($url,$getstr)) ;
	$ckapi[params_list][total] += $ckapi[params_list][dt][amount] ;
	$t->set_var('total',$ckapi[params_list][total]) ;
	}

//---- PayJournal Read

    function payjournal_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("SELECT * FROM ${pre}gl WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	list($dummy,$partdesc) = explode("-",$dt[description]) ;
	list($dt[refno],$partdesc) = explode(" ",$partdesc) ;

	$sql = "SELECT chart_id,attrib1,attrib2,attrib3,amount " ;
	$sql.= "FROM ${pre}acc_trans a, ${pre}chart b " ;
	$sql.= "WHERE trans_id='$id'and a.chart_id=b.id ORDER BY a.id" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['accno'.$i]		=	$phpgw->db->f('chart_id') ;
		$dt['attrib1'.$i]	=	$phpgw->db->f('attrib1') ;
		$dt['attrib2'.$i]	=	$phpgw->db->f('attrib2') ;
		$dt['attrib3'.$i]	=	$phpgw->db->f('attrib3') ;
		$cr			=	sprintf("%01.2f",$phpgw->db->f('amount'));
		$dr			=	sprintf("%01.2f",-$cr) ;
		if ($cr>0)	$dr='';		else $cr='';
		$dt['dr'.$i]		=	$dr ;
		$dt['cr'.$i]		=	$cr ;
		}
	return $dt ;
	}

//---- PayJournal Add Initialisation

    function payjournal_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	foreach ($ckapi[gen] as $key => $value)		$dt[$key] = $$key = $value ;

	$dt[source] = "PYPY" ;
	$sql = "SELECT * FROM ${pre}pyrohist " ;
	$sql.= "WHERE trans_id='$bpyroid' and empid='$empid' and type='NETP'" ;
	$phpgw->db->query($sql) ;
	$phpgw->db->next_record();
	$dt[transdate]	= date("Y-m-d") ;
	$dt[accno1]	= $phpgw->db->Record[chart_id] ;
	$dt[dr1]	= $phpgw->db->Record[amount] ;
	$dt[cr1]	= '' ;
	$dt[accno2]	= '' ;
	$dt[dr2]	= '' ;
	$dt[cr2]	= $phpgw->db->Record[amount] ;
	}

//---- PayJournal Validation Checks

    function payjournal_validate() {
	global $ckapi,$phpgw ;

	$pre = &$ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$date=input2date( $dt[transdate] ) ;
	if ($date=="")				$err=lang("Invalid Salary Payment Journal Date");
	if ($dt["refno"]=="")			$err=lang("Cheque/Reference number Missing");
	$user = $ckapi[hostsys][username];
	$where = "WHERE resource='payjournalgen'" ;
	$phpgw->db->query("SELECT * FROM ${pre}resourcelock $where");
	$phpgw->db->next_record() ;
	$used_by = $phpgw->db->Record['used_by'] ;
	if ($used_by=="")	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' $where");
		else		$err=lang("Salary Payment Journal Generation is being accessed by")." $used_by";

	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write PayJournal Header

    function payjournal_header_write() {
	global $ckapi,$phpgw ;

	$uniwhere = $ckapi[params][uniwhere] ;
	$dt = &$ckapi[params_post][dt] ;
	$op = &$ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_refno',lang('Cheque/Ref# :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('lang_attrib1',$a1cap);
	$t->set_var('lang_attrib2',$a2cap);
	$t->set_var('lang_attrib3',$a3cap);
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('source',$dt[source]) ;

	if ($op=="new") {
		$lang_refno = lang('SalaryCheque/Ref#') ;
		$lang_empid = lang('empid') ;
		$lang_period = lang('period') ;
		$lang_from = lang('from') ;
		$lang_to = lang('to') ;
		$refno = $dt[refno] ;
		$empid = $dt[empid] ;
		$datefrom = $dt[datefrom] ;
		$dateto = $dt[dateto] ;
		$dt[description] = "$lang_refno-$refno $lang_empid-$empid " ;
		$dt[description].= "$lang_period $lang_from/$datefrom $lang_to/$dateto" ;
		}
	$t->set_var('description',$dt[description]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('refno',$dt[refno]) ;
	$t->set_var('empid',$empid) ;
	$t->set_var('bpyroid',$dt[bpyroid]) ;
	$t->set_var('datefrom',$datefrom) ;
	$t->set_var('dateto',$dateto) ;

	$t->set_var('lang_replicate',lang('Replicate Attribute Values from Caption :'));
	$t->set_var('lang_nonbs',lang('Done'));
	$t->set_var('lang_all',lang('Done'));
//	$t->set_var('lang_post',lang('Done'));
	$t->set_var('lang_newrow',lang('Done'));
	$t->parse('out','report',True);
	}

//---- Write PayJournal Detail

    function payjournal_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$row_ = lang("Row")." " ;

	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_accno',lang('Account Number'));
	$t->set_var('lang_attrib1',lang("Attribute").":<br>$a1cap");
	$t->set_var('lang_attrib2',lang("Attribute"),":<br>$a2cap");
	$t->set_var('lang_attrib3',lang("Attribute").":<br>$a3cap");
	$at1cap = $dt[attrib1_cap] ;
	$at2cap = $dt[attrib2_cap] ;
	$at3cap = $dt[attrib3_cap] ;
	$t->set_var('attrib1cap_selectlist',str_replace("'$at1cap'","'$at1cap'"." selected",$a1slist)) ;
	$t->set_var('attrib2cap_selectlist',str_replace("'$at2cap'","'$at2cap'"." selected",$a2slist)) ;
	$t->set_var('attrib3cap_selectlist',str_replace("'$at3cap'","'$at3cap'"." selected",$a3slist)) ;
	$t->set_var('lang_dr',lang('Debit'));
	$t->set_var('lang_cr',lang('Credit'));
	$t->set_var('lang_delete',lang('Delete'));
	$total_dr = 0;
	$total_cr = 0;
	$acc_list = account_selectlist("WHERE charttype='A'",'') ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['accno'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('accno_fld','accno'.$i) ;
			$t->set_var('attrib1_fld','attrib1'.$i) ;
			$t->set_var('attrib2_fld','attrib2'.$i) ;
			$t->set_var('attrib3_fld','attrib3'.$i) ;
			$t->set_var('dr_fld','dr'.$i);
			$t->set_var('cr_fld','cr'.$i);
			$t->set_var('account_selectlist',$acc_list);
			$t->set_var('attrib1_selectlist',$a1slist) ;
			$t->set_var('attrib2_selectlist',$a2slist) ;
			$t->set_var('attrib3_selectlist',$a3slist) ;
			$t->set_var('dr',"") ;
			$t->set_var('cr',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$chart_id	=	$dt['accno'.$i] ;
		$attrib1	=	$dt['attrib1'.$i] ;
		$attrib2	=	$dt['attrib2'.$i] ;
		$attrib3	=	$dt['attrib3'.$i] ;
		$dr		=	$dt['dr'.$i];
		$cr		=	$dt['cr'.$i];
		$total_dr	+=	$dr ;
		$total_cr	+=	$cr ;
		$accno_fld	=	'accno'.$j ;
		$attrib1_fld	=	'attrib1'.$j ;
		$attrib2_fld	=	'attrib2'.$j ;
		$attrib3_fld	=	'attrib3'.$j ;
		$dr_fld		=	'dr'.$j ;
		$cr_fld		=	'cr'.$j ;
		$t->set_var('accno_fld',$accno_fld) ;
		$t->set_var('attrib1_fld',$attrib1_fld) ;
		$t->set_var('attrib2_fld',$attrib2_fld) ;
		$t->set_var('attrib3_fld',$attrib3_fld) ;
		$t->set_var('dr_fld',$dr_fld);
		$t->set_var('cr_fld',$cr_fld);
		$t->set_var('account_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$acc_list)) ;
		$t->set_var('attrib1_selectlist',str_replace("'$attrib1'","'$attrib1'"." selected",$a1slist)) ;
		$t->set_var('attrib2_selectlist',str_replace("'$attrib2'","'$attrib2'"." selected",$a2slist)) ;
		$t->set_var('attrib3_selectlist',str_replace("'$attrib3'","'$attrib3'"." selected",$a3slist)) ;
		$t->set_var('dr',$dr) ;
		$t->set_var('cr',$cr) ;
		if ($posted)	$t->set_var('insrowno',lang("Done"));	else $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',lang("Done"));	else $t->set_var('delrowno',$row_.$j);
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('accno_fld','accno'.$i) ;
		$t->set_var('attrib1_fld','attrib1'.$i) ;
		$t->set_var('attrib2_fld','attrib2'.$i) ;
		$t->set_var('attrib3_fld','attrib3'.$i) ;
		$t->set_var('dr_fld','dr'.$i);
		$t->set_var('cr_fld','cr'.$i);
		$t->set_var('account_selectlist',$acc_list);
		$t->set_var('attrib1_selectlist',$a1slist) ;
		$t->set_var('attrib2_selectlist',$a2slist) ;
		$t->set_var('attrib3_selectlist',$a3slist) ;
		$t->set_var('dr',"") ;
		$t->set_var('cr',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('total_dr',sprintf("%01.2f",$total_dr)) ;
	$t->set_var('total_cr',sprintf("%01.2f",$total_cr)) ;

	$t->parse('out','report',True);
	}

//---- PayJournal Post - PreCommit Routine

    function payjournal_post_precommit() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op=='delete') {
		$phpgw->db->query("DELETE from ${pre}acc_trans where trans_id='$id'");
		$phpgw->db->query("UPDATE ${pre}pyrohist SET codeid=0 WHERE codeid='$id'");
		}
	if ($op=='new') {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$chart_id	= 	$dt['accno'.$i];
			$attrib1	=	$dt['attrib1'.$i] ;
			$attrib2	=	$dt['attrib2'.$i] ;
			$attrib3	=	$dt['attrib3'.$i] ;
			$dr		=	$dt['dr'.$i] ;
			$cr		=	$dt['cr'.$i] ;
			if ($dr==0) $amount=$cr; else $amount=-$dr;
			$attrib1 = ($attrib1=="") ? 0 : $attrib1 ;
			$attrib2 = ($attrib2=="") ? 0 : $attrib2 ;
			$attrib3 = ($attrib3=="") ? 0 : $attrib3 ;
			$sql = "INSERT INTO ${pre}acc_trans (trans_id,chart_id," ;
			$sql.= "attrib1,attrib2,attrib3,amount,transdate)" ;
			$sql.= "VALUES ('$id','$chart_id'," ;
			$sql.= "'$attrib1','$attrib2','$attrib3','$amount','$dt[transdate]')" ;
			$phpgw->db->query($sql);
			}
		$sql = "UPDATE ${pre}pyrohist SET codeid='$id' " ;
		$sql.= "WHERE trans_id='$dt[bpyroid]' and empid='$dt[empid]' and type='NETP'" ;
		$phpgw->db->query($sql);
		}
	}

//---- PayJournal Post - PostCommit Routine

    function payjournal_post_postcommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='payjournalgen'");
	}

    }

?>
