<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reductncopy.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'reductn' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'reductn',
				'tran'		=> $tran ,
				'table'		=> "${pre}reductn" ,
				'uniqueflds'	=> array("name") ,
				'uniwhere'	=> " "				);
	$msg1 = lang("Reduction Amount = (PayrollTotal-ExemptItem-Floor) * Rate(Row i) - Subtract") ;
	$msg2 = lang("Rate(Row i) requires Step(Row i) < (PayrollTotal-ExemptItem-Floor) <= Step(Row i+1)") ;
	$msg3 = lang("It follows that Step values have to be arranged in strictly ascending order") ;
	$ckapi[phrases] = array('lang_title'	=> lang("Copy Summary Level Reduction") ,
				'lang_post'	=> lang("Post Summary Level Reduction") ,
				'lang_exnewrow'	=> lang('Add New ExemptItem Row') ,
				'lang_rtnewrow'	=> lang('Add New Rate Table Row') ,
				'lang_tran'	=> lang("Summary Level Reduction") ,
				'message'	=> "$msg1<br>$msg2<br>$msg3"	) ;
	$ckapi[tables][parents] = array("${pre}reductn"	=> ""		);
	$ckapi[tables]["children"] = array(	"${pre}rdtnexem"=> "rdtnid" ,
						"${pre}rdtnrate"=> "rdtnid"	);
	$ckapi[buttons] = array('insert'	=> "" ,
				'delete'	=> "" ,
				'newrow'	=> "" ,
				'post'		=> ""				) ;
	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_copy() ;

?>
