<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pontoff.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-po' ;
	$tran = 'pont' ;
	$noheader = $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$shipto = ($_GET["shipto"]) ? $_GET["shipto"] : $_POST["shipto"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=stripslashes($filter);

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('report'	=> "${tran}off.tpl",
				'items'	=> "${tran}off.tpl"));
	$t->set_block('items','item_row','item_section');

	$thank = lang('Thank you for being our preferred supplier') ;
	$t->set_var('lang_notes',$notes);
	$charset = lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('logo_url',$phpgw->link('/ck-admin/logo.png')) ;

/*------------- Write Payment to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$shipto = (!$shipto) ? $phpgw->db->f('company') : $shipto ;
	$shiptoaddr1 = $phpgw->db->f('addr1') ;
	$shiptoaddr2 = $phpgw->db->f('addr2') ;
	$shiptoaddr3 = $phpgw->db->f('addr3') ;
	$shiptoaddr4 = $phpgw->db->f('addr4') ;
	$comemail = $phpgw->db->f('email') ;
	$po_rmkid = $phpgw->db->f('po_rmkid') ;
	$phpgw->db->query("SELECT * FROM ${pre}remark where id='$po_rmkid'");
	$phpgw->db->next_record();
	$remark = $phpgw->db->f('description') ;

	$phpgw->db->query("SELECT * FROM ${pre}po WHERE id='$id'");
	$phpgw->db->next_record();
	$vendor = $phpgw->db->f('vendor') ;
	$transdate = $phpgw->db->f('transdate') ;
	$duedate = $phpgw->db->f('duedate') ;
	$ponumber = $phpgw->db->f('ponumber') ;
	$currency = $phpgw->db->f('isocode') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;
	$duedate = date("Y-m-d",strtotime($duedate)) ;

	$phpgw->db->query("SELECT * FROM ${pre}vendor WHERE id='$vendor'");
	$phpgw->db->next_record();
	$name = $phpgw->db->f('name') ;
	$contact = $phpgw->db->f('contact') ;
	$vendoremail = $phpgw->db->f('email') ;
	$addr1 = $phpgw->db->f('addr1') ;
	$addr2 = $phpgw->db->f('addr2') ;
	$addr3 = $phpgw->db->f('addr3') ;
	$addr4 = $phpgw->db->f('addr4') ;
	$terms = $phpgw->db->f('terms') ;

	$t->set_var('lang_po',lang('OFFICIAL PURCHASE ORDER'));
	$t->set_var('lang_transdate',lang('PO Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_ponumber',lang('Number'));
	$t->set_var('lang_vendor',lang('Vendor:'));
	$t->set_var('lang_shipto',lang('Ship To:'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('ponumber',$ponumber) ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$addr1) ;
	$t->set_var('addr2',$addr2) ;
	$t->set_var('addr3',$addr3) ;
	$t->set_var('addr4',$addr4) ;
	$t->set_var('shipto',$shipto) ;
	$t->set_var('shiptoaddr1',$shiptoaddr1) ;
	$t->set_var('shiptoaddr2',$shiptoaddr2) ;
	$t->set_var('shiptoaddr3',$shiptoaddr3) ;
	$t->set_var('shiptoaddr4',$shiptoaddr4) ;

// ---------------------------- Begin list items -----------------------------------------

	$phpgw->db->query("SELECT * FROM ${pre}oitem WHERE trans_id='$id'");
	$total = 0 ;
	while ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$description = $phpgw->db->f('description') ;
		$qty = $phpgw->db->f('qty') ;
		$price = $phpgw->db->f('cost') ;
		$discount = $phpgw->db->f('discount') ;
		$amount = $qty * $price - $discount ;
		$t->set_var(array(	'itemid'	=> $itemid,
					'description'	=> $description,
					'qty'		=> $qty,
      		      	    		'price'		=> $price,
        	    	    		'discount'	=> $discount ,
         		   	    	'amount'	=> $amount ));
		$t->parse('item_section','item_row',true);
		$total+= $amount ;
		}
	$t->set_var('lang_total',lang("PO Total")) ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('lang_term',lang("Terms Net")." $terms ".lang("days")) ;
	$t->set_var('lang_currency',lang("All prices are in")." $currency") ;
	$t->set_var('lang_thank',$thank) ;
	$t->set_var('lang_remark',$remark) ;

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=lang('Purchase Order Image (Use browser print function to output the PO shown above)');
	$t->set_var('lang_title',$title);
	$note1=lang('[This is a sample subject to tailoring per individual printer & invoice format]');
	$note1.=lang('<br>For email function to work, your email/DNS environment must be properly setup.');
	$t->set_var('lang_note1',$note1);
	$note2=lang('To generate PO with a different ship to contact, modify the field below, then press regenerate.');
	$t->set_var('lang_note2',$note2);

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('regenerate_action',$phpgw->link("/$app/${tran}off.php","id=$id&filter=$filter")) ;
	$t->set_var('lang_regenerate',lang('Regenerate Purchase Order'));
	$t->set_var('lang_email',lang('Email Purchase Order'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php","filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	if ($email)	{
		$err = "" ; $error=lang("Error") ; $noemail=lang("No email sent") ;
		$vendmsg = lang("Vendor") ;	$pomsg = lang("PO") ;
		$successmsg = lang("Email successfully queued for despatch to") ;
		$failuremsg = lang("Email fails to deliver to") ;

		if (!$vendoremail)				$err = lang("Vendor email missing") ;
		if ($vendoremail and strpos($vendoremail,'@')=='')	$err = lang("Invalid vendor email") ;
		if (!$comemail)					$err = lang("Company return email missing");
		if ($comemail and strpos($comemail,'@')=='')	$err = lang("Invalid company return email");
		if ($err) {
			$note1 = "$vendmsg/$name -- $pomsg/$id -- $noemail -- $error: $err" ;
			$t->set_var('lang_note1',$note1) ;
			}
		   else {
			$recipient = "$contact < $vendoremail >" ;
			$subject = lang("PO#: %1 dated %2",$ponumber,$transdate) ;
			$message = $t->parse('out','items',report) ;
			$message = substr($message,0,strpos($message,'<!-- BEGIN done -->')) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Bcc: $company < $comemail >\n" ;
			$headers.= "Content-Type: text/html; charset=$charset\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$result = mail($recipient,$subject,$message,$headers) ;
			if ($result)	$note1 = "$vendmsg/$name -- $pomsg/$id -- $successmsg $vendoremail" ;
				else	$note1 = "$vendmsg/$name -- $pomsg/$id -- $failuremsg $vendoremail" ;
			$t->set_var('lang_note1',$note1);
			}
		}
	$t->pparse('out','items',report);

?>
