<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: addonlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'addon' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}addon" 			) ;
	$ckapi[phrases] = array('lang_title'	=> lang("List of Add-On Charge/Reduction") ,
				'lang_add'	=> lang("Add New AddOn Charge/Reduction") ,
				'lang_note'	=> lang('Factor: based on Cash Sale Total; Basis: g-gross sale, n-net sale') ,
				'lang_addon'	=> lang('AddOn Charge/Reduction') ,
				'lang_count'	=> lang('Count per Transaction') ,
				'lang_sale'	=> lang('Sales per Transaction') ,
				'lang_splan'	=> lang('Sales Plan') ,
				'lang_date'	=> lang('Date')				) ;
	$ckapi[columns] = array('name'		=> lang('Name') ,
				'factor'	=> lang('Factor') ,
				'basis'		=> lang('Basis') ,
				'mincount'	=> lang('Min') ,
				'maxcount'	=> lang('Max') ,
				'minsale'	=> lang('Min') ,
				'maxsale'	=> lang('Max') ,
				'splan_id'	=> lang('ID') ,
				'start'		=> lang('Valid from') ,
				'endd'		=> lang('Valid to') ,
				'id'		=> lang('Audit ID') 			) ;
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_list() ;

?>
