<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cbtranfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'cbtran' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$msg1 = lang('To search for all items, leave fields blank.');
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'=> lang("Search among posted Cash Box Transactions :"),
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Cash Box Transaction") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);
	$morning = lang('Morning') ;
	$afternoon = lang('Afternoon') ;
	$overnight = lang('Overnight') ;
	$shift_sl = "<OPTION value='ALL'></OPTION>" ;
	$shift_sl.= "<OPTION value='1'>1 - $morning</OPTION>" ;
	$shift_sl.= "<OPTION value='2'>2 - $afternoon</OPTION>" ;
	$shift_sl.= "<OPTION value='3'>3 - $overnight</OPTION>" ;
	$ckapi[filter][] = array(criteria	=>	lang('Shift') ,
				type		=>	'select' ,
				selectlist	=>	$shift_sl ,
				varname		=>	'shift' ,
				defval		=>	"ALL" ,
				note		=>	lang('Select the appropriate shift'));

	$ckapi[filter][] = array(criteria	=>	lang('Manager') ,
				type		=>	'input' ,
				varname		=>	'manager' ,
				defval		=>	"" ,
				note		=>lang('Search for target key word in the manager field'));

	$ckapi[filter][] = array(criteria	=>	lang('Cashier') ,
				type		=>	'input' ,
				varname		=>	'cashier' ,
				defval		=>	"" ,
				note		=>lang('Search for target key word in the cashier field'));

	$ckapi[filter][] = array(criteria	=>	lang('Cash Box Name') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	"" ,
				note	=>lang('Search for target key word in the cash box name field'));

	$ckapi[filter][] = array(criteria	=>	lang('Cash Sale Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date [format: YYYY-MM-DD]'));

	$ckapi[filter][] = array(criteria	=>	lang('Cash Sale Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date [format: YYYY-MM-DD]'));

	$ckapi[filter][] = array(criteria	=>	lang('Cash Box Transaction Number') ,
				type		=>	'input' ,
				varname		=>	'cbtnumber' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word/number in the cashbox transaction number field'));

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
