<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.cashbox.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class cashbox {

//---- Cash Box Detail Validation Checks

    function cashbox_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err="";  $error = lang("Error") ;
	if (!$dt[name] or $dt[name]=="")	$err=lang('Cash Box Name missing');
		else	{
			$phpgw->db->query("SELECT * from ${pre}cashbox WHERE name='$dt[name]'") ;
			if ($phpgw->db->num_rows()<>0 and $dt[name]<>$dt[oldname])
				$err=lang('Cash Box name already in use');
			}
	if (!$dt[cashier] or $dt[cashier]=="")	$err=lang('Cashier missing');
		else	{
			$phpgw->db->query("SELECT * from ${pre}cashbox WHERE cashier='$dt[cashier]'") ;
			if ($phpgw->db->num_rows()<>0 and $dt[cashier]<>$dt[oldcashier])
				$err=lang('Cashier already assigned to other cashbox');
			}
	if ($dt[maxcash] and !is_numeric($dt[maxcash]))	$err=lang('Cash Warning Level must be numeric');
	$admin = False ;
	$user = $ckapi[hostsys][username];
	$groups = ExecMethod('phpgwapi.accounts.membership',$user) ;
	while (list($key,$value)=each($groups))
		if ($groups["$key"]['account_name']=="Admins")	$admin = True ;
	if (!$admin)	$err=lang('Action not allowed for non [Admins] group users');

	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Qcash Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$cashsale = lang('cash sale') ; $cbtran = lang('CashBox Transaction') ;
	$errmsg1 = lang("This cashbox is in use within an existing") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}pos WHERE cboxid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $cashsale id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}cbtran WHERE cboxid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $cbtran id#".$phpgw->db->f('id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Cash Box Detail

    function cashbox_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");

	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_cashier',lang('Cashier for Current Shift'));
	$t->set_var('lang_remark',lang('[to assign this cashier to a different cashbox, enter N/A here]'));
	$t->set_var('lang_location',lang('Location'));
	$t->set_var('lang_shift',lang('Current Shift'));
	$t->set_var('lang_maxcash',lang('Cash Full Warning Level'));
	$t->set_var('lang_notes',lang('Notes'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('name',$dt[name]);
	$t->set_var('cashier',$dt[cashier]);
	$t->set_var('shift',$dt[shift]);
	$t->set_var('shift_sl',shift_selectlist("",$dt[shift]));
	$t->set_var('location',$dt[location]);
	$t->set_var('maxcash',$dt[maxcash]);
	$t->set_var('notes',$dt[notes]);
	$t->parse('out','report',True);
	}

    }

?>
