<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: repballist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'repballist' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$where = urldecode(stripslashes($filter)) ;
	$filter = urlencode($where) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$nm = $phpgw->nextmatchs ;
	$t->set_file(array('report'=>"$tran.tpl", 'repbal'=>"$tran.tpl"));
	$t->set_block('repbal','repbal_row','repbal_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$db_type = $ckapi[hostsys][dbtype] ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Shift End (Completed) Cash Balances'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_add',lang('Done'));
$t->set_var('add_action',$phpgw->link("/$app/reportfilter.php"));
$t->set_var('lang_note1',lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight'));
$t->set_var('lang_view', lang('View Detail'));
$script = "/$app/${tran}.php" ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,$script,lang('Date'),$filter));
$t->set_var('sort_shift',$nm->show_sort_order($sort,'shift',$order,$script,lang('Shift'),$filter));
$t->set_var('sort_cashbox',$nm->show_sort_order($sort,'cashbox',$order,$script,lang('Cashbox'),$filter));
$t->set_var('sort_cashier',$nm->show_sort_order($sort,'cashier',$order,$script,lang('Cashier'),$filter));
$t->set_var('sort_cashamt',$nm->show_sort_order($sort,'cashamt',$order,$script,lang('Cash Tendered<br>by Customer'),$filter));
$t->set_var('sort_changeamt',$nm->show_sort_order($sort,'changeamt',$order,$script,lang('Cash Returned<br>to Customer'),$filter));
$t->set_var('sort_cbtamt',$nm->show_sort_order($sort,'cbtamt',$order,$script,lang('Bulk Cash<br>Transferred in/out'),$filter));
$t->set_var('sort_balance',$nm->show_sort_order($sort,'balance',$order,$script,lang('Cash Shortfall (+ve)<br>Cash Surplus (-ve)'),$filter));

$user = $ckapi[hostsys][username];
$temp1 = "${pre}repbal1".$user.time() ;
$temp2 = "${pre}repbal2".$user.time() ;
$temp3 = "${pre}repbal3".$user.time() ;
$temp4 = "${pre}repbal4".$user.time() ;
$lang_cash = lang('Cash') ;

$sql =	"CREATE TABLE $temp1 AS " ;
$sql.=  "SELECT a.cboxid as cboxid,a.transdate as transdate,a.shift as shift " ;
$sql.=	"FROM ${pre}cbtran a,${pre}cashbox b $where and a.cboxid=b.id and trantype='e'" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp2 AS " ;
$sql.=	"SELECT d.cboxid as cboxid,d.transdate as transdate,d.shift as shift,sum(qty*a.value) as cashamt " ;
$sql.=	"FROM ${pre}positem a,${pre}pos b,${pre}qcash c,$temp1 d " ;
$sql.=	"WHERE b.cboxid=d.cboxid and b.transdate=d.transdate and b.shift=d.shift and " ;
$sql.=		"name='$lang_cash' and a.trans_id=b.id and a.itemid=c.id " ;
$sql.=	"GROUP BY d.transdate,d.shift,d.cboxid,itemid" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp3 AS " ;
$sql.=	"SELECT c.cboxid as cboxid,c.transdate as transdate,c.shift as shift,cashamt, " ;
$sql.=		"sum(qty*value) as changeamt FROM ${pre}positem a,${pre}pos b,$temp2 c " ;
$sql.=	"WHERE b.cboxid=c.cboxid and b.transdate=c.transdate and b.shift=c.shift and " ;
$sql.=		"itemtype='c' and a.trans_id=b.id " ;
$sql.=	"GROUP BY c.transdate,c.shift,c.cboxid,itemid,cashamt" ;
$phpgw->db->query($sql);
$sql =	"CREATE TABLE $temp4 AS " ;
$sql.=	"SELECT a.cboxid as cboxid,a.transdate as transdate,a.shift as shift,name,b.cashier as cashier," ;
$sql.=		"cashamt,changeamt,sum(amount) as cbtamt, 0.00 as balance " ;
$sql.=	"FROM $temp3 a, ${pre}cbtran b, ${pre}cashbox c " ;
$sql.=	"WHERE a.cboxid=b.cboxid and a.transdate=b.transdate and a.shift=b.shift and a.cboxid=c.id " ;
$sql.=	"GROUP BY a.transdate,a.shift,a.cboxid,name,b.cashier,cashamt,changeamt " ;
$phpgw->db->query($sql) ;
$phpgw->db->query("UPDATE $temp4 SET balance=cashamt+changeamt+cbtamt") ;

if (!$order) {$order = "transdate" ; }
if (!$sort)  {$sort = "ASC" ; }
$phpgw->db->query("SELECT * FROM $temp4 order by $order $sort") ;

// -------------------------------- end declaration -----------------------------------------

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'shift'		=> "",
				'cashbox'	=> "",
				'cashier'	=> "",
				'cashamt'	=> "",
				'changeamt'	=> "",
				'cbtamt'	=> "",
				'balance'	=> "",
				'lang_item'	=> ""	)) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('repbal_section','repbal_row',True);
	}
while ($phpgw->db->next_record()) {
	$transdate = $phpgw->db->f('transdate') ;
	$shift = $phpgw->db->f('shift') ;
	$cboxid = $phpgw->db->f('cboxid') ;
	$t->set_var(array(	'transdate'	=> $transdate,
				'shift'		=> $shift,
				'cashbox'	=> $phpgw->db->f('name'),
				'cashier'	=> $phpgw->db->f('cashier'),
				'cashamt'	=> number_format($phpgw->db->f('cashamt'),2,".",''),
				'changeamt'	=> number_format($phpgw->db->f('changeamt'),2,".",''),
				'cbtamt'	=> number_format($phpgw->db->f('cbtamt'),2,".",''),
				'balance'	=> $phpgw->db->f('balance') ,
				'lang_item'	=> lang('View Detail')	)) ;
	$markpri = "zzAnDzz" ;  $marksec = "z2z1z3z" ;
	$ifilter = "${markpri}01=1" ;
	$ifilter.= "${markpri}1shift${marksec}${shift}" ;
	$ifilter.= "${markpri}1transdate${marksec}${transdate}" ;
	$ifilter.= "${markpri}1cboxid${marksec}${cboxid}";
	$ifilter =urlencode($ifilter) ;
	$item = $phpgw->link("/$app/cashballist.php","filter=$ifilter");
	$t->set_var('item',$item);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('repbal_section','repbal_row',true);
	}

$phpgw->db->query("DROP TABLE $temp1") ;
$phpgw->db->query("DROP TABLE $temp2") ;
$phpgw->db->query("DROP TABLE $temp3") ;
$phpgw->db->query("DROP TABLE $temp4") ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','repbal','report');

?>
