<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: quotentlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-quote' ;
	$tran = 'quotent' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'quote' ,
				'tran'		=> $tran ,
				'table'		=> "${pre}quote" 		);
	$ckapi[phrases] = array('lang_title'	=> lang("List of Quotations [no Tax]") ,
				'lang_add'	=> lang("Add New Quotation [no Tax]") ,	);
	$ckapi[columns] = array('transdate'	=> lang('Quotation Date') ,
				'duedate'	=> lang('Due Date') ,
				'name'		=> lang('Customer') ,
				'quotenumber'	=> lang('Quotation#') ,
				'isocode'	=> lang('Currency') ,
				'amount'	=> lang('Amount') ,
				'id'		=> lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'offquo'	=> "/$app/${tran}off.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'edit_addtax'	=> "/$app/quotewtedit.php" , /* dummy */
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_offquo'	=> lang('Official Quotation') ,
				'lang_bulk'	=> lang("Bulk Despatch") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_edit_addtax'=>lang('Edit (Add Tax)') ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

	$temp1 = $ckapi[params_sql][temp1];
	$temp2 = $ckapi[params_sql][temp2];
	if ($temp1<>"")	$phpgw->db->query("DROP TABLE $temp1");
	if ($temp2<>"")	$phpgw->db->query("DROP TABLE $temp2");

?>
