<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: quotentoff.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-quote' ;
	$tran = 'quotent' ;
	$noheader = $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$email = ($_GET["email"]) ? $_GET["email"] : $_POST["email"] ;
	$filter=stripslashes($filter);

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file(array('report'	=> "${tran}off.tpl",
				'items'	=> "${tran}off.tpl"));
	$t->set_block('items','item_row','item_section');

	$rows = "<br><br><br><br><br>" ;
	$rows = $rows.$rows.$rows.$rows.$rows.$rows.$rows.$rows ;
	$t->set_var('rows',$rows);
	$title=lang('Quotation Image (Use browser print function to output the quotation shown above)');
	$t->set_var('lang_title',$title);
	$caption = lang("We are pleased to quote the following items to meet your purchasing needs.") ;
	$t->set_var('lang_caption',$caption);
	$note1=lang('[This is a sample subject to tailoring per individual printer & quotation format]');
	$note2=lang('For email function to work, your email/SMTP/DNS environment must be properly setup.');
	$t->set_var('lang_notes',"$note1<br>$note2");
	$charset = lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('logo_url',$phpgw->link('/ck-admin/logo.png')) ;

/*------------- Write Payment to Screen Display ----------------------------*/

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$quo_rmkid = $phpgw->db->f('quo_rmkid') ;
	$phpgw->db->query("SELECT * FROM ${pre}remark where id='$quo_rmkid'");
	$phpgw->db->next_record();
	$remark = $phpgw->db->f('description') ;

	$phpgw->db->query("SELECT * FROM ${pre}quote WHERE id='$id'");
	$phpgw->db->next_record();
	$customer = $phpgw->db->f('customer') ;
	$transdate = $phpgw->db->f('transdate') ;
	$duedate = $phpgw->db->f('duedate') ;
	$quotenumber = $phpgw->db->f('quotenumber') ;
	$currency = $phpgw->db->f('isocode') ;
	$transdate = date("Y-m-d",strtotime($transdate)) ;
	$duedate = date("Y-m-d",strtotime($duedate)) ;

	$phpgw->db->query("SELECT * FROM ${pre}customer WHERE id='$customer'");
	$phpgw->db->next_record();
	$name = $phpgw->db->f('name') ;
	$contact = $phpgw->db->f('contact') ;
	$custemail = $phpgw->db->f('email') ;
	$addr1 = $phpgw->db->f('addr1') ;
	$addr2 = $phpgw->db->f('addr2') ;
	$addr3 = $phpgw->db->f('addr3') ;
	$addr4 = $phpgw->db->f('addr4') ;
	$terms = $phpgw->db->f('terms') ;
	$shiptoname = $phpgw->db->f('shiptoname') ;
	$shiptoaddr1 = $phpgw->db->f('shiptoaddr1') ;
	$shiptoaddr2 = $phpgw->db->f('shiptoaddr2') ;
	$shiptoaddr3 = $phpgw->db->f('shiptoaddr3') ;
	$shiptoaddr4 = $phpgw->db->f('shiptoaddr4') ;

	$t->set_var('lang_quote',lang('QUOTATION'));
	$t->set_var('lang_transdate',lang('Quotation Date'));
	$t->set_var('lang_duedate',lang('Valid Until'));
	$t->set_var('lang_quotenumber',lang('Number'));
	$t->set_var('lang_billto',lang('Bill To:'));
	$t->set_var('lang_shipto',lang('Ship To:'));
	$t->set_var('lang_itemid',lang('Item ID'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_qty',lang('Qty'));
	$t->set_var('lang_price',lang('Price'));
	$t->set_var('lang_discount',lang('Discount'));
	$t->set_var('lang_amount',lang('Amount'));

	$t->set_var('transdate',$transdate) ;
	$t->set_var('duedate',$duedate) ;
	$t->set_var('quotenumber',$quotenumber) ;
	$t->set_var('name',$name) ;
	$t->set_var('addr1',$addr1) ;
	$t->set_var('addr2',$addr2) ;
	$t->set_var('addr3',$addr3) ;
	$t->set_var('addr4',$addr4) ;
	$t->set_var('shiptoname',$shiptoname) ;
	$t->set_var('shiptoaddr1',$shiptoaddr1) ;
	$t->set_var('shiptoaddr2',$shiptoaddr2) ;
	$t->set_var('shiptoaddr3',$shiptoaddr3) ;
	$t->set_var('shiptoaddr4',$shiptoaddr4) ;

// ---------------------------- Begin list items -----------------------------------------

	$phpgw->db->query("SELECT * FROM ${pre}oitem WHERE trans_id='$id'");
	$total = 0 ;
	while ($phpgw->db->next_record()) {
		$itemid = $phpgw->db->f('itemid') ;
		$description = $phpgw->db->f('description') ;
		$qty = $phpgw->db->f('qty') ;
		$price = $phpgw->db->f('price') ;
		$discount = $phpgw->db->f('discount') ;
		$amount = $qty * $price - $discount ;
		$t->set_var(array('itemid'	=> $itemid,
				'description'	=> $description,
				'qty'		=> $qty,
				'price'		=> $price,
				'discount'	=> $discount ,
				'amount'	=> $amount ));
		$t->parse('item_section','item_row',true);
		$total+= $amount ;
		}
	$t->set_var('lang_total',lang("Quotation Total")) ;
	$t->set_var('total_amount',$total) ;
	$t->set_var('lang_term',lang("Terms Net")." $terms ".lang("days")) ;
	$t->set_var('lang_currency',lang("All prices are in")." $currency") ;
	$t->set_var('lang_thank',lang("Thank you for your valued business!")) ;
	$t->set_var('lang_remark',$remark) ;

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('email_action',$phpgw->link("/$app/${tran}off.php","id=$id&filter=$filter")) ;
	$t->set_var('lang_email',lang('Email Quotation'));
	$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php","filter=$filter"));
	$t->set_var('lang_done',lang('Done'));
	if ($email)	{
		$err = "" ; $error=lang("Error") ; $noemail=lang("No email sent") ;
		$custmsg = lang("Customer") ;	$quotemsg = lang("Quotation") ;
		$successmsg = lang("Email successfully queued for despatch to") ;
		$failuremsg = lang("Email fails to deliver to") ;

		if (!$custemail)				$err = lang("Customer email missing") ;
		if ($custemail and strpos($custemail,'@')=='')	$err = lang("Invalid customer email") ;
		if (!$comemail)					$err = lang("Company return email missing");
		if ($comemail and strpos($comemail,'@')=='')	$err = lang("Invalid company return email");
		if ($err) {
			$notes = "$custmsg/$name -- $quotemsg/$id -- $noemail -- $error: $err" ;
			$t->set_var('lang_notes',$notes) ;
			}
		   else {
			$recipient = "$contact < $custemail >" ;
			$subject = lang("Quotation#: %1 dated %2",$quotenumber,$transdate) ;
			$message = $t->parse('out','items',report) ;
			$message = substr($message,0,strpos($message,'<!-- BEGIN done -->')) ;
			$headers = "From: $company < $comemail >\n" ;
			$headers.= "Bcc: $company < $comemail >\n" ;
			$headers.= "Content-Type: text/html; charset=$charset\n" ;
			$headers.= "Return-Path: $company < $comemail >\n" ;
			$result = mail($recipient,$subject,$message,$headers) ;
			if ($result)	$notes = "$custmsg/$name -- $quotemsg/$id -- $successmsg $custemail" ;
				else	$notes = "$custmsg/$name -- $quotemsg/$id -- $failuremsg $custemail" ;
			$t->set_var('lang_notes',$notes);
			}
		}
	$t->pparse('out','items',report);

?>

