<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: sowtfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-so' ;
	$tran = 'sowt' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'so' ,
				'tran'		=> $tran			) ;
		
	$msg1 = lang('If during data entry/maintenance, all taxes are deleted') ;
	$msg2 = lang('the resultant sales order will be moved to the no tax list');
	$msg3 = lang('To ensure accurate record on outstanding Quotation') ;
	$msg4 = lang('Use as far as possible, [Convert Quotation to SO] to create new SO');
	$msg5 = lang('To search for all items, leave fields blank');
	$msg6 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among posted sales orders [with Tax] :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Sales Order [with Tax]") ,
			'lang_search_message'	=> "$msg1,<br>$msg2;<br>$msg3,<br>$msg4;<br>$msg5.<br>$msg6" ,
				'message'	=> ""				);
	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$warning = lang("Make sure you have completed all Invoice/SO Matching before checking on unbilled SOs") ;
	$ckapi[filter][] = array(criteria	=>	lang('Customer') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.customer_selectlist("","") ,
				varname		=>	'customer' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate customer') );

	$ckapi[filter][] = array(criteria	=>	lang('Currency') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.isocode_selectlist("","") ,
				varname		=>	'isocode' ,
				defval		=>	"" ,
				note		=>	lang('Select the appropriate currency') );

	$ckapi[filter][] = array(criteria	=>	lang('Sales Order Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	lang('Sales Order Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	"" ,
				note		=>	lang('Must be a valid date; format: YYYY-MM-DD') );

	$ckapi[filter][] = array(criteria	=>	lang('Sales Order Number') ,
				type		=>	'input' ,
				varname		=>	'sonumber' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word/number in the sales order # field') );

	$ckapi[filter][] = array(criteria	=>	lang('Unbilled SO Only') ,
				type		=>	'checkbox' ,
				varname		=>	'opentran' ,
				defval		=>	"" ,
				note		=>	lang("Click box if only non fully billed SOs are to be retrieved")."<br><b>$warning</b>" );

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
