<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: sqmatchlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-so' ;
	$tran = 'sqmatch' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}sqmatch" ,
				'doneexit'	=> "${tran}filter.php"			) ;
	$ckapi[phrases] = array('lang_title'	=> lang("List of Sales Orders [w and w/o Quotation matched]"),
				'lang_add'	=> lang("Done")			);
	$ckapi[columns] = array('transdate'	=> lang('SO Date') ,
				'name'		=> lang('Customer') ,
				'sonumber'	=> lang('SO#') ,
				'isocode'	=> lang('Currency') ,
				'amount'	=> lang('Amount') ,
				'id'		=> lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'clear'		=> "/$app/${tran}clear.php"	) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_clear'	=> lang("Clear SO/Quotation Matching") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

	$temp1 = $ckapi[params_sql][temp1];
	$temp2 = $ckapi[params_sql][temp2];
	if ($temp1<>"")	$phpgw->db->query("DROP TABLE $temp1");
	if ($temp2<>"")	$phpgw->db->query("DROP TABLE $temp2");

?>
