<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: expenseapplist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-sss' ;
	$tran = 'expenseapp' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> 'pynr_trans'				) ;
	$msg1 = lang('Approved Expense/Allowance Claims cannot be edited nor deleted.') ;
	$msg2 = lang('To allow auto email requesting various approvals, email/dns environment must be correctly setup.') ;
	$msg3 = lang('Even if Expense/Allowance Claim is approved, you still need to forward all original supporting documents to Accounts Department.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("List of Expense/Allowance Claims") ,
				'lang_add'	=> lang("Add New Expense/Allowance Claims") ,
				'message'	=> "$msg1  $msg2<br>$msg3"		);
	$ckapi[columns] = array('empname'	=> lang('Employee Name') ,
				'pyrname'	=> lang('E/A Name') ,
				'description'	=> lang('Expense/Allowance Description') ,
				'qty'		=> lang('Quantity') ,
				'unit'		=> lang('Unit') ,
				'unitamt'	=> lang('Unit Amount') ,
				'rate'		=> lang('Pay Rate') ,
				'amount'	=> lang('Amount') ,
				'comment'	=> lang('Comment') ,
				'approved_by'	=> lang('Approved By') ,
				'id'		=> lang('Audit ID') 			);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")		) ;
	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

?>
