<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.address.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class address {

//---- Address Read

    function address_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM ${pre}employee WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$phpgw->db->query("SELECT * FROM ${pre}address where contactid='$id' order by addresscode");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['line1'.$i]		=	$phpgw->db->f('line1') ;
		$dt['line2'.$i]		=	$phpgw->db->f('line2') ;
		$dt['line3'.$i]		=	$phpgw->db->f('line3') ;
		$dt['line4'.$i]		=	$phpgw->db->f('line4') ;
		$dt['addresscode'.$i]	=	$phpgw->db->f('addresscode') ;
		$dt['region'.$i]	=	$phpgw->db->f('region') ;
		$dt['country'.$i]	=	$phpgw->db->f('country') ;
		$dt['zip'.$i]		=	$phpgw->db->f('zip') ;
		}
	return $dt;
	}

//---- Address Validation Checks

    function address_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error = lang("Error") ;
	$lang_address = strtolower(lang('address')) ;
	$hd=$hi=$pa=$po = "" ;
	$row = lang("Row") ;
	For ($i=1;isset($dt['addresscode'.$i]);$i++) {
		if ($dt['line1'.$i]=='' and $dt['line2'.$i]=='' and $dt['line3'.$i]=='' and $dt['line4'.$i]=='')
						$err="[$row $i]".lang("Blank address") ;
		$addresscode = $dt['addresscode'.$i] ;
		$sql = "SELECT name FROM ${pre}hrcode where lower(type)='$lang_address' and name='$addresscode'";
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		switch ($phpgw->db->f('name')) :
			case "HD": if ($hd<>"") $err="[$row $i]".lang("Duplicate HD address"); $hd="HD";break;
			case "HI": if ($hi<>"") $err="[$row $i]".lang("Duplicate HI address"); $hi="HI";break;
			case "PA": if ($pa<>"") $err="[$row $i]".lang("Duplicate PA address"); $pa="PA";break;
			case "PO": if ($po<>"") $err="[$row $i]".lang("Duplicate PO address"); $po="PO";break;
			endswitch ;
		}
	if ($i>1 and $hd=="")			$err = lang("HD address missing") ;
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Address Header

    function address_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT username FROM ${pre}employee WHERE id='$dt[id]'");
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('disabled','');
	$t->parse('out','report',True);
	}

//---- Write Address Detail

    function address_detail_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_address',lang('Address (Addr) Line1, Line2, Line3, Line4'));
	$t->set_var('lang_codetype',lang("Type of Code") );
	$t->set_var('lang_codedesc',lang("Code -- Description") );
	$t->set_var('lang_addresscode',lang('AddrType:'));
	$t->set_var('lang_region',lang('Region:'));
	$t->set_var('lang_country',lang('Country:'));
	$t->set_var('lang_zip',lang('Zip:'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_reserved',lang('Reserved Space'));
	$lang_address = strtolower(lang('address')) ;
	$lang_region = strtolower(lang('region')) ;
	$lang_country = strtolower(lang('country')) ;
	$lang_zip = strtolower(lang('zip')) ;

	$blankopt = "<OPTION value=''></OPTION>" ;
	$addresscode_sl = hrcodename_selectlist("WHERE lower(type)='$lang_address'",'',"long") ;
	$region_sl = "<OPTION value=''></OPTION>".hrcodename_selectlist("WHERE lower(type)='$lang_region'",'',"long") ;
	$country_sl = hrcodename_selectlist("WHERE lower(type)='$lang_country'",'',"long") ;
	$zip_sl = "<OPTION value=''></OPTION>".hrcodename_selectlist("WHERE lower(type)='$lang_zip'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['addresscode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('line1_fld','line1'.$i);
			$t->set_var('line2_fld','line2'.$i);
			$t->set_var('line3_fld','line3'.$i);
			$t->set_var('line4_fld','line4'.$i);
			$t->set_var('addresscode_fld','addresscode'.$i) ;
			$t->set_var('region_fld','region'.$i) ;
			$t->set_var('country_fld','country'.$i) ;
			$t->set_var('zip_fld','zip'.$i) ;
			$t->set_var('line1','') ;
			$t->set_var('line2','') ;
			$t->set_var('line3','') ;
			$t->set_var('line4','') ;
			$t->set_var('addresscode_selectlist',$addresscode_sl) ;
			$t->set_var('region_selectlist',$region_sl) ;
			$t->set_var('country_selectlist',$country_sl) ;
			$t->set_var('zip_selectlist',$zip_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$addresscode	= $dt['addresscode'.$i] ;
		$region		= $dt['region'.$i] ;
		$country	= $dt['country'.$i] ;
		$zip		= $dt['zip'.$i] ;
		$t->set_var('line1_fld','line1'.$j);
		$t->set_var('line2_fld','line2'.$j);
		$t->set_var('line3_fld','line3'.$j);
		$t->set_var('line4_fld','line4'.$j);
		$t->set_var('addresscode_fld','addresscode'.$j) ;
		$t->set_var('region_fld','region'.$j) ;
		$t->set_var('country_fld','country'.$j) ;
		$t->set_var('zip_fld','zip'.$j) ;

		$t->set_var('line1',$dt['line1'.$i]) ;
		$t->set_var('line2',$dt['line2'.$i]) ;
		$t->set_var('line3',$dt['line3'.$i]) ;
		$t->set_var('line4',$dt['line4'.$i]) ;
		$t->set_var('addresscode_selectlist',str_replace("'$addresscode'","'$addresscode' selected",$addresscode_sl)) ;
		$t->set_var('region_selectlist',str_replace("'$region'","'$region' selected",$region_sl)) ;
		$t->set_var('country_selectlist',str_replace("'$country'","'$country' selected",$country_sl)) ;
		$t->set_var('zip_selectlist',str_replace("'$zip'","'$zip' selected",$zip_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('line1_fld','line1'.$i);
		$t->set_var('line2_fld','line2'.$i);
		$t->set_var('line3_fld','line3'.$i);
		$t->set_var('line4_fld','line4'.$i);
		$t->set_var('addresscode_fld','addresscode'.$i) ;
		$t->set_var('region_fld','region'.$i) ;
		$t->set_var('country_fld','country'.$i) ;
		$t->set_var('zip_fld','zip'.$i) ;
		$t->set_var('line1','') ;
		$t->set_var('line2','') ;
		$t->set_var('line3','') ;
		$t->set_var('line4','') ;
		$t->set_var('addresscode_selectlist',$addresscode_sl) ;
		$t->set_var('region_selectlist',$region_sl) ;
		$t->set_var('country_selectlist',$country_sl) ;
		$t->set_var('zip_selectlist',$zip_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Address Post - PreCommit Routine

    function address_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')	$phpgw->db->query("DELETE from ${pre}address where contactid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['addresscode'.$i]);$i++) {
			$line1 = $dt['line1'.$i] ;
			$line2 = $dt['line2'.$i] ;
			$line3 = $dt['line3'.$i] ;
			$line4 = $dt['line4'.$i] ;
			$addresscode = $dt['addresscode'.$i] ;
			$region = $dt['region'.$i] ;
			$country = $dt['country'.$i] ;
			$zip = $dt['zip'.$i] ;
			$sql = "INSERT INTO ${pre}address(contactid,line1,line2,line3,line4," ;
			$sql.= "addresscode,region,country,zip) " ;
			$sql.= "VALUES('$id','$line1','$line2','$line3','$line4'," ;
			$sql.= "'$addresscode','$region','$country','$zip')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>

