<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.attend.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class attend {

//---- Attendance List SQL Formation

    function attend_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$user = $ckapi[hostsys][username];
	$sql ="SELECT b.name,d.description as dept,transdate,time,a.type,c.description as reason,a.id as id ";
	$sql.=  "FROM ${pre}attendance a, ${pre}employee b, ${pre}hrcode c, ${pre}department d " ;
	$sql.=  "WHERE 1=1 $where and username='$user' and empid=b.id and b.dept=d.id " ;
	$sql.=  "and a.type=c.type and a.reason=c.name " ;
	$sql.=  "ORDER BY $order $sort" ;
	return $sql ;
	}

//---- Attendance Read (for Sign-in and Sign-out)

    function attend_add_init() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;

	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT * FROM ${pre}employee WHERE username = '$user'");
	$phpgw->db->next_record();
	$ckapi[params_post][dt][name] = $phpgw->db->f('name');
	$ckapi[params_post][dt][empid] = $phpgw->db->f('id');
	return ;
	}

//---- Attendance Detail Validation Checks

    function attend_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$err="";  $error = lang("Error:") ;
	if ($dt[type]==lang('sign-in') and $dt[signin]=='')	$err=lang("Sign in Reason Missing") ;
	if ($dt[type]==lang('sign-out') and $dt[signout]=='')	$err=lang("Sign out Reason Missing") ;
	if ($dt[signin]<>'' and $dt[signout]<>'')	$err=lang("Both Sign In & Out Reasons are active") ;
	if ($err)					$err = "<b>$error $err</b>" ;
	return $err ;
	}

//---- Write Attendance Detail

    function attend_write() {
	global $ckapi,$phpgw ;

//	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$blankopt = "<OPTION value=''></OPTION>" ;
	$type_sl = "<OPTION value='$lang_si'>$lang_si</OPTION>" ;
	$type_sl.= "<OPTION value='$lang_so'>$lang_so</OPTION>";
	$t->set_var('lang_type',lang('Action'));
	$t->set_var('lang_name',lang('Employee Name/#'));
	$t->set_var('lang_signin',lang('Sign In Reason'));
	$t->set_var('lang_signout',lang('Sign Out Reason'));
	$lang_signin = lang('sign-in') ;
	$lang_signout = lang('sign-out') ;

	$type_sl = str_replace("'$dt[type]'","'$dt[type]' selected",$type_sl) ;
	$t->set_var('type_selectlist',$type_sl);
	$t->set_var('name',$dt[name]);
	$t->set_var('empid',$dt[empid]);
	$signin_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_signin'",'','long') ;
	$signin_sl = str_replace("'$dt[signin]'","'$dt[signin]' selected",$signin_sl) ;
	$t->set_var('signin_selectlist',$signin_sl);
	$signout_sl = $blankopt.hrcodename_selectlist("WHERE type='$lang_signout'",'','long') ;
	$signout_sl = str_replace("'$dt[signout]'","'$dt[signout]' selected",$signout_sl) ;
	$t->set_var('signout_selectlist',$signout_sl);

	$t->parse('out','report',True);
	}

//---- Attendance Post Initialisation (Sign-in or Sign-out)

    function attend_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;

	$lang_si = lang('sign-in') ;
	$lang_so = lang('sign-out') ;
	$dt[reason] = ($dt[type]==$lang_si) ? $dt[signin] : $dt[signout] ;
	$dt[transdate] = date("Y-m-d") ;
	$dt[time] = date("H:i:s") ;

	}

//---- Attendance Post - PostCommit Routine

    function attend_post_postcommit() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;

	$ckapi[phrases]["reminder"] = "<br>$dt[name] $dt[type] - $dt[transdate]/$dt[time]" ;
	}

    }

?>
