<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.email.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class email {

//---- Email Read

    function email_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;
	$phpgw->db->query("SELECT * FROM ${pre}employee WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$phpgw->db->query("SELECT * FROM ${pre}email where empid='$id' order by emailcode");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['prefix'.$i]	=	$phpgw->db->f('prefix') ;
		$dt['suffix'.$i]	=	$phpgw->db->f('suffix') ;
		$dt['emailcode'.$i]	=	$phpgw->db->f('emailcode') ;
		}
	return $dt ;
	}

//---- Email Validation Checks

    function email_validate() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=lang("Error") ;
	$row = lang("Row") ;
	$busi=$priv=$proj= "" ;
	For ($i=1;isset($dt['emailcode'.$i]);$i++) {
		$prefix = $dt['prefix'.$i] ;
		$suffix = $dt['suffix'.$i] ;
		if ($prefix=="")	$err="[$row $i]".lang("email prefix missing");
		if ($suffix=="")	$err="[$row $i]".lang("email suffix missing");
		switch ($dt['emailcode'.$i]) :
			case "BUSI" :	$busi = "BUSI" ;	break ;
			case "PRIV" :	$priv = "PRIV" ;	break ;
			case "PROJ" :	$proj = "PROJ" ;	break ;
			endswitch ;
		}
	if ($i>1) {
		if ($busi=="")		$err = lang("BUSI email missing") ;
		if ($priv=="")		$err = lang("PRIV email missing") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Email Header

    function email_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$dt[name]) ;
	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT username FROM ${pre}employee WHERE id='$dt[id]'");
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('disabled','');
	$t->parse('out','report',True);
	}

//---- Write Email Detail

    function email_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$row_ = lang('Row')." " ;
	$lang_email = strtolower(lang('email')) ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_prefix',lang("Prefix"));
	$t->set_var('lang_act',"@");
	$t->set_var('lang_suffix',lang("Suffix"));
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_emailcode',lang("Email Code -- Description") );
	$t->set_var('lang_delete',lang('Delete'));

	$emailcode_sl = hrcodename_selectlist("WHERE lower(type)='$lang_email'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['emailcode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('prefix_fld','prefix'.$i) ;
			$t->set_var('suffix_fld','suffix'.$i) ;
			$t->set_var('emailcode_fld','emailcode'.$i) ;
			$t->set_var('prefix','') ;
			$t->set_var('suffix','') ;
			$t->set_var('emailcode_selectlist',$emailcode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$emailcode	=	$dt['emailcode'.$i] ;

		$t->set_var('prefix_fld','prefix'.$j) ;
		$t->set_var('suffix_fld','suffix'.$j) ;
		$t->set_var('emailcode_fld','emailcode'.$j) ;

		$t->set_var('prefix',$dt['prefix'.$i]) ;
		$t->set_var('suffix',$dt['suffix'.$i]) ;
		$t->set_var('emailcode_selectlist',str_replace("'$emailcode'","'$emailcode' selected",$emailcode_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ;
			else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ;
			else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('prefix_fld','prefix'.$i) ;
		$t->set_var('suffix_fld','suffix'.$i) ;
		$t->set_var('emailcode_fld','emailcode'.$i) ;
		$t->set_var('prefix','') ;
		$t->set_var('suffix','') ;
		$t->set_var('emailcode_selectlist',$emailcode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Email Post - PreCommit Routine

    function email_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;
	if ($op<>'new')		$phpgw->db->query("DELETE FROM ${pre}email where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['emailcode'.$i]);$i++) {
			$prefix = $dt['prefix'.$i] ;
			$suffix = $dt['suffix'.$i] ;
			$emailcode = $dt['emailcode'.$i] ;
			$sql = "INSERT INTO ${pre}email(empid,prefix,suffix,emailcode) " ;
			$sql.= "VALUES('$id','$prefix','$suffix','$emailcode')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>
