<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.employee.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

	class employee {  

//---- Employee List SQL Formation

    function employee_list_sql() {
	global $ckapi,$phpgw ;

	$table = $ckapi[params][table] ;
	$order = $ckapi[params_sql][order] ;
	$sort = $ckapi[params_sql][sort] ;
	$user = $ckapi[hostsys][username];
	$sql = "SELECT * from $table WHERE username='$user' order by $order $sort" ;
	return $sql ;
	}

//---- Employee List Link Adjustement

    function employee_list_adjust() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record() ;
	$photoyn = $phpgw->db->f('photoyn') ;
	$addressyn = $phpgw->db->f('addressyn') ;
	$phoneyn = $phpgw->db->f('phoneyn') ;
	$emailyn = $phpgw->db->f('emailyn') ;
	$ecyn = $phpgw->db->f('ecyn') ;

	$t = &$ckapi[objects][template] ;
	if ($photoyn=='no')	$t->set_var( array('lang_photo'=>'','photo'=>'') ) ;
	if ($addressyn=='no')	$t->set_var( array('lang_address'=>'','address'=>'') ) ;
	if ($phoneyn=='no')	$t->set_var( array('lang_phone'=>'','phone'=>'') ) ;
	if ($emailyn=='no')	$t->set_var( array('lang_email'=>'','email'=>'') ) ;
	if ($ecyn=='no')	$t->set_var( array('lang_ec'=>'','ec'=>'') ) ;
	}

//---- Write Employee Detail

    function employee_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$app = $ckapi[params][app] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('lang_name',lang("Employee Name/#"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_personal',lang("Personal Information :"));
	$t->set_var('lang_prefix',lang("Prefix"));
	$t->set_var('lang_family',lang("Family Name"));
	$t->set_var('lang_given',lang("Given Name"));
	$t->set_var('lang_suffix',lang("Suffix"));
	$t->set_var('lang_nationalid',lang("National ID"));
	$t->set_var('lang_username',lang("Host System User Name"));
	$t->set_var('lang_corporate',lang("Corporate Information :"));
	$t->set_var('lang_ctitle',lang("Corporate Title"));
	$t->set_var('lang_dept',lang("Department"));
	$t->set_var('lang_grade',lang("Staff Grade"));
	$t->set_var('lang_supervisor',lang("Supervisor"));
	$t->set_var('lang_subtitle',lang("Auxillary Information [click righthand links to view (readonly) details]:"));
	$t->set_var('lang_address',lang("Address"));
	$t->set_var('lang_phone',lang("Phone"));
	$t->set_var('lang_email',lang("Email"));
	$t->set_var('lang_ec',lang("Emergency Contact"));
	$t->set_var('lang_dates',lang("Important Dates"));
	$t->set_var('lang_leave',lang("Leave Record"));
	$t->set_var('lang_perform',lang("Performance Review"));
	$t->set_var('lang_role',lang("Role"));

	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT username FROM ${pre}employee WHERE id='$dt[id]'");
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$blankopt = "<OPTION value=''></OPTION>" ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('name',$dt[name]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$lang_prefix = lang('prefix') ;
	$t->set_var('prefix_sl',hrcodename_selectlist("WHERE type='$lang_prefix'",$dt[prefix],"short"));
	$t->set_var('family',$dt[family]);
	$t->set_var('given',$dt[given]);
	$lang_suffix = lang('suffix') ;
	$t->set_var('suffix_sl',$blankopt.hrcodename_selectlist("WHERE type='$lang_suffix'",$dt[suffix],"short"));
	$t->set_var('nationalid',$dt[nationalid]);
	$t->set_var('username',$dt[username]);
	$t->set_var('title',$dt[title]);
	$t->set_var('dept_sl',dept_selectlist('',$dt[dept]));
	$lang_grade = lang('grade') ;
	$t->set_var('grade_sl',hrcodename_selectlist("WHERE type='$lang_grade'",$dt[grade],"long"));
	$t->set_var('supervisor_sl',employee_selectlist('',$dt[supervisor]));
	$getstr = "id=$dt[id]" ;
	$t->set_var('address',$phpgw->link("/$app/addressview.php",$getstr));
	$t->set_var('phone',$phpgw->link("/$app/phoneview.php",$getstr));
	$t->set_var('email',$phpgw->link("/$app/emailview.php",$getstr));
	$t->set_var('ec',$phpgw->link("/$app/ecview.php",$getstr));
	$t->set_var('dates',$phpgw->link("/$app/datesview.php",$getstr));
	$t->set_var('leave',$phpgw->link("/$app/leaveview.php",$getstr));
	$t->set_var('perform',$phpgw->link("/$app/prview.php",$getstr));
	$t->set_var('role',$phpgw->link("/$app/roleview.php",$getstr));
	$t->set_var('message','');

	$img = $ckapi[hostsys][dataarea]."/images/$dt[id].png" ;
	$t->set_var('image',$phpgw->link("/ck-hr/employeeview_image.php","imgfile=$img"));

	$t->parse('out','report',True);
	}

    }

?>

