<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.phone.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class phone {

//---- Phone Read

    function phone_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM ${pre}employee WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$phpgw->db->query("SELECT * from ${pre}phone where empid='$id' order by phonecode");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['prefix'.$i]	=	$phpgw->db->f('prefix') ;
		$dt['phone'.$i]		=	$phpgw->db->f('phone') ;
		$dt['suffix'.$i]	=	$phpgw->db->f('suffix') ;
		$dt['phonecode'.$i]	=	$phpgw->db->f('phonecode') ;
		}
	return $dt ;
	}

//---- Phone Validation Checks

    function phone_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = lang("Error") ;
	$row = lang("Row") ;
	$p1pd=$p2ph=$p3mo=$p4pa=$p5ph=$p6fb=$p7fh=$p8pi=$p9pv = "" ;
	For ($i=1;isset($dt['phonecode'.$i]);$i++) {
		$prefix = $dt['prefix'.$i] ;
		$phone = $dt['phone'.$i] ;
		$suffix = $dt['suffix'.$i] ;
		if ($phone=="")
				$err="[$row $i]".lang("Phone# Missing");
		if ($prefix<>"" and !is_numeric($prefix))
				$err="[$row $i]".lang("Phone prefix must be numeric");
		if ($phone<>"" and !is_numeric($phone))
				$err="[$row $i]".lang("Phone# must be numeric");
		if ($suffix<>"" and !is_numeric($suffix))
				$err="[$row $i]".lang("Phone suffix must be numeric");
		switch ($dt['phonecode'.$i]) :
			case "P1PD" :	if ($p1pd<>"") $err="[$row $i]".lang("Duplicate P1PD phone") ;	$p1pd = "P1PD" ;	break ;
			case "P2PM" :	if ($p2pm<>"") $err="[$row $i]".lang("Duplicate P2PM phone") ;	$p2pm = "P2PM" ;	break ;
			case "P3MO" :	if ($p3mo<>"") $err="[$row $i]".lang("Duplicate P3MO phone") ;	$p3mo = "P3MO" ;	break ;
			case "P4PA" :	if ($p4pa<>"") $err="[$row $i]".lang("Duplicate P4PA phone") ;	$p4pa = "P4PA" ;	break ;
			case "P5PH" :	if ($p5ph<>"") $err="[$row $i]".lang("Duplicate P5PH phone") ;	$p5ph = "P5PH" ;	break ;
			case "P6FB" :	if ($p6fb<>"") $err="[$row $i]".lang("Duplicate P6FB phone") ;	$p6fb = "P6FB" ;	break ;
			case "P7FH" :	if ($p7fh<>"") $err="[$row $i]".lang("Duplicate P7FH phone") ;	$p7fh = "P7FH" ;	break ;
			case "P8PI" :	if ($p8pi<>"") $err="[$row $i]".lang("Duplicate P8PI phone") ;	$p8pi = "P8PI" ;	break ;
			case "P9PV" :	if ($p9pv<>"") $err="[$row $i]".lang("Duplicate P9PV phone") ;	$p9pv = "P9PV" ;	break ;
			endswitch ;
		}
	if ($i>1) {
		if ($p2pm==""	)	$err = lang("Phone (Business - Message) missing") ;
		if ($p3mo=="" and $p5ph=="")
			$err = lang("Mobile/Home phone missing, ie no off-hour contact") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Phone Header

    function phone_header_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$user = $ckapi[hostsys][username];
	$phpgw->db->query("SELECT username FROM ${pre}employee WHERE id='$dt[id]'");
	$phpgw->db->next_record();
	if ($user<>$phpgw->db->f('username')) {
		echo lang("You are not authorised to access the requested information.") ;
		exit() ;
		}
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('disabled','');
	$t->parse('out','report',True);
	}

//---- Write Phone Detail

    function phone_detail_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = lang('Row')." " ;
	$lang_phone = strtolower(lang('phone')) ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_prefix',lang("Prefix - Country code..."));
	$t->set_var('lang_phone',lang("Phone Number"));
	$t->set_var('lang_suffix',lang("Suffix - extension..."));
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_phonecode',lang("Phone Code -- Description") );
	$t->set_var('lang_delete',lang('Delete'));

	$phonecode_sl = hrcodename_selectlist("WHERE lower(type)='$lang_phone'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['phonecode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('prefix_fld','prefix'.$i) ;
			$t->set_var('phone_fld','phone'.$i) ;
			$t->set_var('suffix_fld','suffix'.$i) ;
			$t->set_var('phonecode_fld','phonecode'.$i) ;
			$t->set_var('prefix','') ;
			$t->set_var('phone','') ;
			$t->set_var('suffix','') ;
			$t->set_var('phonecode_selectlist',$phonecode_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$phonecode	=	$dt['phonecode'.$i] ;

		$t->set_var('prefix_fld','prefix'.$j) ;
		$t->set_var('phone_fld','phone'.$j) ;
		$t->set_var('suffix_fld','suffix'.$j) ;
		$t->set_var('phonecode_fld','phonecode'.$j) ;
		$t->set_var('prefix',$dt['prefix'.$i]) ;
		$t->set_var('phone',$dt['phone'.$i]) ;
		$t->set_var('suffix',$dt['suffix'.$i]) ;
		$t->set_var('phonecode_selectlist',str_replace("'$phonecode'","'$phonecode' selected",$phonecode_sl)) ;
		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('prefix_fld','prefix'.$i) ;
		$t->set_var('phone_fld','phone'.$i) ;
		$t->set_var('suffix_fld','suffix'.$i) ;
		$t->set_var('phonecode_fld','phonecode'.$i) ;
		$t->set_var('prefix','') ;
		$t->set_var('phone','') ;
		$t->set_var('suffix','') ;
		$t->set_var('phonecode_selectlist',$phonecode_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Phone Post - PreCommit Routine

    function phone_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$phpgw->db->query("DELETE from ${pre}phone where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['phonecode'.$i]);$i++) {
			$prefix = $dt['prefix'.$i] ;
			$phone = $dt['phone'.$i] ;
			$suffix = $dt['suffix'.$i] ;
			$phonecode = $dt['phonecode'.$i] ;
			$sql = "INSERT INTO ${pre}phone(empid,prefix,phone,suffix,phonecode) " ;
			$sql.= "VALUES('$id','$prefix','$phone','$suffix','$phonecode')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>
