<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: leavefilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-sss' ;
	$tran = 'leave' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$msg1 = lang('To search for all items, leave fields blank.');
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Leave Record :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);
	$lang_leave = lang('leave') ;
	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$type_sl = hrcodename_selectlist("WHERE type='$lang_leave'","",'long') ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$msg = lang('Leave Records falling within (from/to) date will be listed.') ;
	$ckapi[filter][] = array(criteria	=>	lang('Leave Type') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.$type_sl ,
				varname		=>	'type' ,
				defval		=>	'' ,
				note		=>	lang('Search for target Leave Type'));

	$ckapi[filter][] = array(criteria	=>	lang('Period From') ,
				type		=>	'input' ,
				varname		=>	'datefrom' ,
				defval		=>	'' ,
				note		=>	"$msg  $dateformat"		);

	$ckapi[filter][] = array(criteria	=>	lang('Period To') ,
				type		=>	'input' ,
				varname		=>	'dateto' ,
				defval		=>	'' ,
				note		=>	"$msg  $dateformat"		) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
