<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: adminfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'admin' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$ckapi[phrases] = array('lang_title'	=> lang("Choose Admin Action to Perform :") ,
				'lang_criteria'	=> lang("Admin Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Action") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$chartlist1 = lang('1 -- Default Chart of Accounts') ;
	$chartlist2 = lang('2 -- Chart of Accounts for Non-profit Org (School Band)') ;
	$chartlist3 = lang('3 -- Chart of Accounts for Property Management Org') ;
	$chartlist =	"<OPTION value='1'>$chartlist1</OPTION>" ;
	$chartlist.=	"<OPTION value='2'>$chartlist2</OPTION>" ;
	$chartlist.=	"<OPTION value='3'>$chartlist3</OPTION>" ;
	$note5a = lang('Insert dummy test data') ;
	$note5b = lang('These test data is only compatible with the default Chart of Accounts') ;
	$note5c = lang('These test data should be deleted before the system goes into actual production') ;
	$note7a = lang('Be sure you understand all implications of this action.') ;
	$note7b = lang('To abandon action, press [Done].') ;
	$note7c = lang('To continue, press [Start Action].') ;
	$note8 = lang('To continue, press [Start Action].') ;
	$note_chart1 = lang("Generate chosen Chart of Accounts, tax and other essential data.") ;
	$note_chart2 = lang("It is most likely that you will have to adjust these master data to meet your local requirements.");

	$ckapi[filter][] = array(criteria	=>	lang('Which Action') ,
				type		=>	'select' ,
				selectlist	=>	"" ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note	=>lang('If wrong action chosen, click [Admin/Setup] to restart'));

	$ckapi[filter][] = array(criteria	=>	lang('Which Chart') ,
				type		=>	'select' ,
				selectlist	=>	$chartlist ,
				varname		=>	'chart' ,
				defval		=>	"" ,
				note		=>lang('Select the target Chart of Account to install'));

	$ckapi[filter][] = array(criteria	=>	lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	lang("Create all Data Tables.")		);

	$ckapi[filter][] = array(criteria	=>	lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"$note_chart1  $note_chart2" );

	$ckapi[filter][] = array(criteria	=>	lang ('Explanatory Message') ,
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"$note5a.  $note5b.  $note5c."		) ;

	$ckapi[filter][] = array(criteria	=>	lang("Explanatory Message") ,
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
		note	=>"<b>".lang("This action is non-reversible and DELETES ALL..ALL..ALL DATA")."</b>");

	$ckapi[filter][] = array(criteria	=>	lang ('Explanatory Message') ,
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"<b>$note7a  $note7b  $note7c</b>"	) ;

	$ckapi[filter][] = array(criteria	=>	lang ('Explanatory Message') ,
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>lang("These checksums are used to ensure no script alteration post installation"));

	$act1 = "1 -- ".lang('Setup Data Tables') ;
	$act2 = "2 -- ".lang('Build Chart of Accounts and other Master Data') ;
	$act3 = "3 -- ".lang('Create Test Data') ;
	$act4 = "4 -- ".lang('Delete all Data and Data Tables') ;
	$act5 = "5 -- ".lang('Generate MD5 Script checksum') ;
	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>$act1</OPTION>",
						2=>	"<OPTION value='2'>$act2</OPTION>",
						3=>	"<OPTION value='3'>$act3</OPTION>",
						4=>	"<OPTION value='4'>$act4</OPTION>",
						5=>	"<OPTION value='5'>$act5</OPTION>"	);

	$ckapi[filter][actstring] = array(	"0",		/* first entry	*/
						"026",		/* Action 1	*/
						"0136",		/* Action 2	*/
						"046",		/* Action 3	*/
						"056",		/* Action 4	*/
						"067"		/* Action 5	*/		) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;
?>
