<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: logfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'log' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> 'index.php'			) ;
	$msg1 = lang("Because of the immense size of the log table") ;
	$msg2 = lang("parameter should be added to shrink the volume of search result to a small number of records") ;
	$msg3 = lang('To search for all items, leave fields blank.') ;
	$msg4 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang('Search and view selected log entries :') ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "$msg1,<br>$msg2.<br>$msg3  $msg4" ,
				'message'	=> ""				);

	$oplistnew = lang('new -- new record inserted') ;
	$oplistedit = lang('edit -- old record edited') ;
	$oplistdelete = lang('delete -- old record deleted') ;
	$oplistclear = lang('clear -- old record cleared') ;
	$opliststart = lang('start -- start of log') ;
	$oplist =	"<OPTION value='ALL'></OPTION>".
			"<OPTION value='new'>$oplistnew</OPTION>" .
			"<OPTION value='edit'>$oplistedit</OPTION>" .
			"<OPTION value='delete'>$oplistdelete</OPTION>" .
			"<OPTION value='clear'>$oplistclear</OPTION>" .
			"<OPTION value='start'>$opliststart</OPTION>" ;
	$dateformat = lang('Must be a valid date; format: YYYY-MM-DD') ;

	$ckapi[filter][] = array(criteria	=>	lang('Operation') ,
				type		=>	'select' ,
				selectlist	=>	$oplist ,
				varname		=>	'op' ,
				defval		=>	"" ,
				note		=>	lang('Select records of specific operation'));

	$ckapi[filter][] = array(criteria	=>	lang('Date (from)') ,
				type		=>	'input' ,
				varname		=>	'from_date' ,
				defval		=>	"" ,
				note		=>	$dateformat				) ;

	$ckapi[filter][] = array(criteria	=>	lang('Date (to)') ,
				type		=>	'input' ,
				varname		=>	'to_date' ,
				defval		=>	"" ,
				note		=>	$dateformat				) ;

	$ckapi[filter][] = array(criteria	=>	lang('Transaction ID (from)') ,
				type		=>	'input' ,
				varname		=>	'from_id' ,
				defval		=>	"" ,
				note		=>	lang('Search for record with transaction id starting from'));

	$ckapi[filter][] = array(criteria	=>	lang('Transaction ID (to)') ,
				type		=>	'input' ,
				varname		=>	'to_id' ,
				defval		=>	"" ,
				note		=>	lang('Search for record with transaction id ending at')) ;

	$ckapi[filter][] = array(criteria	=>	lang('Script') ,
				type		=>	'input' ,
				varname		=>	'script' ,
				defval		=>	"" ,
				note		=>	lang('Search for target keyword in the script name field'));

	$ckapi[filter][] = array(criteria	=>	lang('IP Address') ,
				type		=>	'input' ,
				varname		=>	'ip' ,
				defval		=>	"" ,
				note		=>	lang('Search for target keyword in the IP address field'));

	$ckapi[filter][] = array(criteria	=>	lang('User ID') ,
				type		=>	'input' ,
				varname		=>	'userid' ,
				defval		=>	"" ,
				note		=>	lang('Search for target keyword/# in the User ID field'));

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
