<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: restore.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-admin' ;
	$tran = 'restore' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$search = ($_GET["search"]) ? $_GET["search"] : $_POST["search"] ;
	$attrib = ($_GET["attrib"]) ? $_GET["attrib"] : $_POST["attrib"] ;
	$file = ($_GET["file"]) ? $_GET["file"] : $_POST["file"] ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report','selectfilter.tpl') ;
	$t->set_block('report','detail','detail_section');
	$t->set_block('report','select','select_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$title = lang('Choose Which Backup File to Restore :') ;
	$message1 = lang("Currently, automatic restoration only works with PostgreSQL and MySQL databases.") ;
	$message2 = lang("However, for other DBMS, restoration from the same backup files may be possible via command line action.") ;
	$message3 = lang("Attribute tables should be further backuped/restored independently if they affect other phpgw modules.") ;
	$message4 = lang("If different attribute tables were choosen after backup file was produced, restoration will not be effective.") ;
	$t->set_var('lang_title',$title);
	$t->set_var('lang_search_message',"$message1  $message2  $message3  $message4");

/* ------------- Read and Write Journal Detail --------------------------- */

	$t->set_var('lang_criteria',lang('Action'));
	$t->set_var('lang_value',lang('Backup Files'));
	$t->set_var('lang_note',lang('Note'));

	$db_type =	$ckapi[hostsys][dbtype] ;
	$database =	$phpgw_info["server"]["db_name"] ;
	$dbuser	=	$phpgw_info["server"]["db_user"] ;
	$dir	=	$ckapi[hostsys][dataarea] ;
	$selectlist = "" ;
	$handle = opendir($dir) ;
	while ($fl = readdir($handle)) {
		if (substr($fl,0,strlen($database))==$database and strpos($fl,".$db_type.restore.sql")<>'') {
			$filename = $dir."/".$fl ;
			$selectlist .= "<OPTION value='$filename'>$filename</OPTION>" ;
			}
		}
	$nochoice = lang("No - Do not Restore") ;
	$yeschoice = lang("Yes - Restore") ;
	$attrib_selectlist = "<OPTION value='no'>$nochoice</OPTION><OPTION value='yes'>$yeschoice</OPTION>" ;

	$filter = array (	cond1		=>	lang('Which file to restore') ,
				condvar1	=>	'file' ,
				conddefault1	=>	'' ,
				condnote1	=>	lang('Pick the appropriate file to restore data from') ,
				cond2		=>	lang('Restore Attribute Tables ?') ,
				condvar2	=>	'attrib' ,
				conddefault2	=>	'no' ,
				condnote2	=>	lang('Choose whether to restore Attribute Tables and then click Start Restoration')
														 ) ;

	$t->set_var('condition',$filter[cond1]) ;
	$t->set_var('var',$filter[condvar1]) ;
	$t->set_var('note',$filter[condnote1]);
	$t->set_var('selectlist',$selectlist);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('select_section','select', True);
	$t->set_var('detail_section',"");
	$t->set_var('condition',$filter[cond2]) ;
	$t->set_var('var',$filter[condvar2]) ;
	$t->set_var('note',$filter[condnote2]);
	$t->set_var('selectlist',$attrib_selectlist);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('select_section','select', True);
	$t->set_var('detail_section',"");
	If ($search) {
		$fd = fopen($file,"r");
		while (!feof($fd)) {
			$line = fgets($fd,65536);
			$first2 = substr($line,0,2) ;
			if ($first2=="--")			continue ;
			if ($first2=="**" and $attrib=="no")	continue ;
			if ($first2=="**" and $attrib=="yes")	$phpgw->db->query(substr($line,2,-1)) ;
				else				$phpgw->db->query(substr($line,0,-1)) ;
			}
		fclose($fd) ;
		$complete = lang("Database Restoration Complete") ;
		echo "<br><font size='+2'>$complete</font>" ;
		echo lang("<br>Source File:")." $file<br>" ;
		echo lang("Please remember to restore additionally the (images) folder within your phpgw files area")."<br>" ;
		}

	$t->parse('out','report',True);

/*--------------------Write bottom Section------------------------------------------*/

	if (!$search) {
		$t->set_var('search_action',$phpgw->link("/$app/restore.php")) ;
		$t->set_var('lang_search',lang('Start Database Restoration'));
		}
	    else {
		$t->set_var('search_action',$phpgw->link("/$app/index.php")) ;
		$t->set_var('lang_search',lang('Done'));
		}
	$t->set_var('add_action',$phpgw->link("/$app/index.php")) ;
	$t->set_var('lang_add',lang('Done'));

	$t->pparse('out','report',True);

?>
