<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: vendorfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ap' ;
	$tran = 'vendor' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran			) ;
	$msg1 = lang('To search for all items, leave fields blank.') ;
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Vendors :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Vendor") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$ckapi[filter][] = array(criteria	=>	lang('Vendor Name') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word in the Vendor Company Name field') );

	$ckapi[filter][] = array(criteria	=>	lang('Contact') ,
				type		=>	'input' ,
				varname		=>	'contact' ,
				defval		=>	"" ,
				note		=>	lang('Search for target key word in the Vendor Contact field') );

	$ckapi[filter][] = array(criteria	=>	lang('Phone') ,
				type		=>	'input' ,
				varname		=>	'phone' ,
				defval		=>	"" ,
				note		=>	lang('Search for target numeric combination in the Contact Phone field') );

	$ckapi[filter][] = array(criteria	=>	lang('Fax') ,
				type		=>	'input' ,
				varname		=>	'fax' ,
				defval		=>	"" ,
				note		=>	lang('Search for target numeric combination in the Contact Fax field') );

	$ckapi[filter][] = array(criteria	=>	lang('E-mail') ,
				type		=>	'input' ,
				varname		=>	'email' ,
				defval		=>	"" ,
				note		=>	lang('Search for target char combination in the Contact Email field') );

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
