<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.process3.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class process3 {

//---- Process acctran

    function process3_acctran() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $val)
		$ckapi[buttons][$key] = $$key = ($_GET[$key]) ? $_GET[$key] : $_POST[$key] ;
	$dt = &$ckapi[params_post][dt] ;

	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$filter=stripslashes($filter);

	$tranobj = CreateObject("$app.$class") ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-api'));
	$t->set_file('report','acctranscreen.tpl') ;
	$t->set_block('report','detail','detail_section');
	foreach ($ckapi[phrases] as $key => $value)	$t->set_var($key,$value) ;
	$t->set_var('readonly','');
	$t->set_var('disabled','');

	/*------------- Write Journal to Screen Display ----------------------------*/
	$ckapi[params_post][id] = $id ;
	$ckapi[params_post][firstime] = True ;
	foreach ($ckapi[buttons] as $key => $val)	if ($val<>"")	$ckapi[params_post][firstime]=False;
	if ($ckapi[params_post][firstime])		$dt = $this->acctran_read() ;
		else					$dt = $_POST ;

	if (isset($reload))	{
		$temp = array(	'transdate'	=>	$dt[transdate] ,
				'source'	=>	$dt[source] ,
				'total'		=>	$dt[total] ,
				'description'	=>	$dt[description] ,
				'id'		=>	$dt[id] ,
				'control'	=>	$dt[control]		) ;
		$func="${class}_reload";
		$dt=$tranobj->$func();
		foreach ($temp as $key => $val)		$dt[$key] = $val ;
		}
	if (isset($repl_all)) {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$dt["attrib1$i"]	=	$dt['attrib1_cap'];
			$dt["attrib2$i"]	=	$dt['attrib2_cap'];
			$dt["attrib3$i"]	=	$dt['attrib3_cap'];
			}
		}
	if (isset($repl_nonbs)) {
		For ($i=1;isset($dt['accno'.$i]);$i++) {
			$accid = $dt['accno'.$i] ;
			$phpgw->db->query("SELECT category FROM ${pre}chart WHERE id='$accid'") ;
			$phpgw->db->next_record();
			$cat = $phpgw->db->f('category') ;
			if ($cat=="I" or $cat=="E") {
				$dt['attrib1'.$i]	=	$dt['attrib1_cap'] ;
				$dt['attrib2'.$i]	=	$dt['attrib2_cap'] ;
				$dt['attrib3'.$i]	=	$dt['attrib3_cap'] ;
				}
			}
		}
	$ckapi[objects][template] = &$t ;
	$ckapi[params_post][dt] = $dt ;
	$this->acctran_header_write() ;
	$func="${class}_accmask";	if (method_exists($tranobj,$func))	$tranobj->$func();
	$this->acctran_detail_write() ;

	$t->parse('out','report',True);

	/*-------------- Post Invoice Accounting Entries ----------------------------------------------*/
	if (isset($post)) {
		$err = $this->acctran_validate() ;
		$t->set_var('message',$err);
		if ($err=='') {
			$proc1 = CreateObject('ck-api.process1') ;
			$ckapi[params_post][op] = 'edit' ;
			$ckapi[objects][tranobj] = &$tranobj ;
			$err = $proc1->process1_post();
			$type = lang("Old") ;
			$actioned = lang("updated") ;
			$lang_tran = $ckapi[phrases][lang_tran] ;
			$msg = "<b>$type $lang_tran [id#$id] $actioned</b>" ;
			if ($err<>"")	$t->set_var('message',$err) ;
				else	{$t->set_var('message',$msg) ;  $posted = True ;}
			}
		}

	/*--------------------Write bottom Section------------------------------------------*/
	$getstr = "filter=$filter" ;
	$return = ($return<>"") ? $return : "/$app/${tran}list.php" ;
	if ($posted) {
		$t->set_var('action',$phpgw->link($return,$getstr));
		foreach ($ckapi[buttons] as $key => $val)	$t->set_var("lang_$key",lang("Done"));
		$t->set_var('readonly',"readonly") ;
		$t->set_var('disabled',"disabled") ;
		}
	    else {
		$script = $ckapi[params_post][script] ;
		$t->set_var('action',$phpgw->link("/$app/$script.php","return=$return&$getstr")) ;
		foreach ($ckapi[buttons] as $key => $val)
			if (isset($ckapi[phrases]["lang_$key"]))
				$t->set_var("lang_$key",$ckapi[phrases]["lang_$key"]);
		$t->set_var('readonly',"") ;
		$t->set_var('disabled',"") ;
		}
	$t->set_var('done_action',$phpgw->link($return,$getstr));
	$t->set_var('lang_done',lang('Done'));
	$t->pparse('out','report',True);
	}

//---- Acctran Read

    function acctran_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM ${pre}gl WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$sql = "SELECT sum(amount) as total FROM ${pre}acc_trans WHERE trans_id='$id' and amount>0" ;
	$phpgw->db->query($sql);
	$phpgw->db->next_record();
	$dt[total] = $phpgw->db->f('total') ;

	$sql = "SELECT chart_id,amount,attrib1,attrib2,attrib3 FROM ${pre}acc_trans a,${pre}chart b ";
	$sql.= "WHERE trans_id='$id'and a.chart_id=b.id ORDER BY a.id" ;
	$phpgw->db->query($sql);
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['accno'.$i]	=	$phpgw->db->f('chart_id') ;
		$dt['attrib1'.$i]	=	$phpgw->db->f('attrib1') ;
		$dt['attrib2'.$i]	=	$phpgw->db->f('attrib2') ;
		$dt['attrib3'.$i]	=	$phpgw->db->f('attrib3') ;
		$cr			=	sprintf("%01.2f",$phpgw->db->f('amount'));
		$dr			=	sprintf("%01.2f",-$cr) ;
		if ($cr>0)	$dr='';		else $cr='';
		$dt['dr'.$i]		= 	$dr ;
		$dt['cr'.$i]		= 	$cr ;
		}
	return $dt ;
	}

//---- Acctran Validation Checks

    function acctran_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	$date=input2date( $dt[transdate] ) ;
	if ($date=="")					$err=lang("Invalid Date");
	if ($dt["description"]=="")			$err=lang("Description Missing");
	$total_dr=''; $total_cr='';
	For ($i=1;isset($dt['accno'.$i]);$i++) {
		$dr			=	$dt['dr'.$i];
		$cr			=	$dt['cr'.$i];
		$total_dr		+=	$dr ;
		$total_cr		+=	$cr	;
		$row = lang("Row") ; $rowi = "[$row $i]" ;
		if (!ereg('^[0-9]*\\.?[0-9]{0,2}$',$dr) or $dr<0) $err=$rowi.lang("Invalid Dr");
		if (!ereg('^[0-9]*\\.?[0-9]{0,2}$',$cr) or $cr<0) $err=$rowi.lang("Invalid Cr");
		if ($dr==0 and $cr==0)	$err=$rowi.lang("Both Dr&Cr=0 (delete row if needed)");
		if ($dr>0 and $cr>0)	$err=$rowi.lang("Dr and Cr cannot both have value!");
		}
	if (sprintf("%01.2f",$total_dr)<>sprintf("%01.2f",$total_cr))	$err=lang("Total Dr <> Cr");
	if (sprintf("%01.2f",$total_cr)<>sprintf("%01.2f",$dt[total]))
			$err=lang("should not change Original total Dr/Cr amt of ").$dt[total];

	$phpgw->db->query("SELECT attrib1cnval,attrib2cnval,attrib3cnval FROM ${pre}defaults");
	$phpgw->db->next_record();
	if ($phpgw->db->f('attrib1cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib11'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib1'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = lang("Attrib1 value not constant") ;
		}
	if ($phpgw->db->f('attrib2cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib21'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib2'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = lang("Attrib2 value not constant") ;
		}
	if ($phpgw->db->f('attrib3cnval')=="yes") {
		$cnval = True ;
		$atval = $dt['attrib31'] ;
		For ($i=2;isset($dt['accno'.$i]);$i++)
			if ($dt['attrib3'.$i]<>$atval)	$cnval = False ;
		if (!$cnval)			$err = lang("Attrib3 value not constant") ;
		}

	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Write Acctran Header to Screen

    function acctran_header_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_date',lang('Date :'));
	$t->set_var('lang_source',lang('Source :'));
	$t->set_var('lang_description',lang('Description :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('transdate',$dt[transdate]) ;
	$t->set_var('source',$dt[source]) ;
	$t->set_var('description',$dt[description]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('total',$dt[total]) ;
	$t->parse('out','report',True);
	}

//---- Write Acctran Detail to Screen

    function acctran_detail_write() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;
	$accmask = $ckapi[params_post][accmask] ;
	$dt = &$ckapi[params_post][dt] ;
	$id = &$ckapi[params_post][id] ;
	$t = &$ckapi[objects][template] ;
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

	$row_ = lang('Row')." " ;
	$phpgw->db->query("Select * from ${pre}defaults");
	$phpgw->db->next_record();
	$a1cap = $phpgw->db->f('attrib1cap') ;
	$a1tbl = $phpgw->db->f('attrib1tbl') ;
	$a1sdf = $phpgw->db->f('attrib1sdesc') ;
	$a2cap = $phpgw->db->f('attrib2cap') ;
	$a2tbl = $phpgw->db->f('attrib2tbl') ;
	$a2sdf = $phpgw->db->f('attrib2sdesc') ;
	$a3cap = $phpgw->db->f('attrib3cap') ;
	$a3tbl = $phpgw->db->f('attrib3tbl') ;
	$a3sdf = $phpgw->db->f('attrib3sdesc') ;
	$a1slist = $this->attrib_selectlist($a1tbl,$a1sdf,'','') ;
	$a2slist = $this->attrib_selectlist($a2tbl,$a2sdf,'','') ;
	$a3slist = $this->attrib_selectlist($a3tbl,$a3sdf,'','') ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_accno',lang('Account Number'));
	$t->set_var('lang_attrib1',lang("Attribute").":<br>$a1cap");
	$t->set_var('lang_attrib2',lang("Attribute").":<br>$a2cap");
	$t->set_var('lang_attrib3',lang("Attribute").":<br>$a3cap");
	$at1cap = $dt[attrib1_cap] ;
	$at2cap = $dt[attrib2_cap] ;
	$at3cap = $dt[attrib3_cap] ;
	$t->set_var('attrib1cap_selectlist',str_replace("'$at1cap'","'$at1cap'"." selected",$a1slist)) ;
	$t->set_var('attrib2cap_selectlist',str_replace("'$at2cap'","'$at2cap'"." selected",$a2slist)) ;
	$t->set_var('attrib3cap_selectlist',str_replace("'$at3cap'","'$at3cap'"." selected",$a3slist)) ;
	$t->set_var('lang_dr',lang('Debit'));
	$t->set_var('lang_cr',lang('Credit'));
	$t->set_var('lang_delete',lang('Delete'));
	$total_dr = 0;
	$total_cr = 0;
	$acc_list = account_selectlist("WHERE charttype='A'","") ;

	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['accno'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('accno_fld','accno'.$i) ;
			$t->set_var('attrib1_fld','attrib1'.$i) ;
			$t->set_var('attrib2_fld','attrib2'.$i) ;
			$t->set_var('attrib3_fld','attrib3'.$i) ;
			$t->set_var('dr_fld','dr'.$i);
			$t->set_var('cr_fld','cr'.$i);
			$t->set_var('account_selectlist',$acc_list);
			$t->set_var('attrib1_selectlist',$a1slist) ;
			$t->set_var('attrib2_selectlist',$a2slist) ;
			$t->set_var('attrib3_selectlist',$a3slist) ;
			$t->set_var('dr',"") ;
			$t->set_var('cr',"") ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('linedisabled',"") ;
			$t->set_var('linereadonly',"") ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;
		$chart_id	=	$dt['accno'.$i] ;
		$attrib1	=	$dt['attrib1'.$i] ;
		$attrib2	=	$dt['attrib2'.$i] ;
		$attrib3	=	$dt['attrib3'.$i] ;
		$dr	=	$dt['dr'.$i] ;
		$cr	=	$dt['cr'.$i] ;
		$total_dr	+=	$dr ;
		$total_cr	+=	$cr ;
		$accno_fld	=	'accno'.$j ;
		$attrib1_fld	=	'attrib1'.$j ;
		$attrib2_fld	=	'attrib2'.$j ;
		$attrib3_fld	=	'attrib3'.$j ;
		$dr_fld		=	'dr'.$j ;
		$cr_fld		=	'cr'.$j ;
		$t->set_var('accno_fld',$accno_fld) ;
		$t->set_var('attrib1_fld',$attrib1_fld) ;
		$t->set_var('attrib2_fld',$attrib2_fld) ;
		$t->set_var('attrib3_fld',$attrib3_fld) ;
		$t->set_var('dr_fld',$dr_fld);
		$t->set_var('cr_fld',$cr_fld);
		$t->set_var('account_selectlist',str_replace("'$chart_id'","'$chart_id' selected",$acc_list));
		$t->set_var('attrib1_selectlist',str_replace("'$attrib1'","'$attrib1'"." selected",$a1slist));
		$t->set_var('attrib2_selectlist',str_replace("'$attrib2'","'$attrib2'"." selected",$a2slist));
		$t->set_var('attrib3_selectlist',str_replace("'$attrib3'","'$attrib3'"." selected",$a3slist));
		$t->set_var('dr',$dr) ;
		$t->set_var('cr',$cr) ;
		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		$t->set_var('linedisabled',"") ;
		$t->set_var('linereadonly',"") ;
		if (substr_count($accmask,$chart_id)>0)	{
			$t->set_var('account_selectlist',account_selectlist("WHERE id='$chart_id'",""));
			$t->set_var('linedisabled',"disabled") ;
			$t->set_var('linereadonly',"readonly") ;
			}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==2 and $delrowno==1)	{$i=1;$newrow=True;}
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('accno_fld','accno'.$i) ;
		$t->set_var('attrib1_fld','attrib1'.$i) ;
		$t->set_var('attrib2_fld','attrib2'.$i) ;
		$t->set_var('attrib3_fld','attrib3'.$i) ;
		$t->set_var('dr_fld','dr'.$i);
		$t->set_var('cr_fld','cr'.$i);
		$t->set_var('account_selectlist',$acc_list);
		$t->set_var('attrib1_selectlist',$a1slist) ;
		$t->set_var('attrib2_selectlist',$a2slist) ;
		$t->set_var('attrib3_selectlist',$a3slist) ;
		$t->set_var('dr',"") ;
		$t->set_var('cr',"") ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('linedisabled',"") ;
		$t->set_var('linereadonly',"") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->set_var('lang_total',lang('Total'));
	$t->set_var('total_dr',sprintf("%01.2f",$total_dr)) ;
	$t->set_var('total_cr',sprintf("%01.2f",$total_cr)) ;

	$t->parse('out','report',True);
	}

//---- Set Up Attribute Select Option List

    function attrib_selectlist($table,$sdfld,$filter,$default) {
	global $phpgw,$pre ;

	$sql="SELECT id, $sdfld FROM $table $filter ORDER BY $sdfld" ;
	$phpgw->db->query($sql);
	$selectlist="<OPTION value=''></OPTION>";
	While ($phpgw->db->next_record()) {
		$id = $phpgw->db->f('id') ;
		$sdesc = substr($phpgw->db->f($sdfld),0,10);
		$selectlist .= "<OPTION value='$id'>$sdesc</OPTION>" ;
		}
	$selectlist = str_replace("'$default'","'$default'"." selected",$selectlist) ;
	return $selectlist ;
	}

    }

?>
