<?php
 /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: customerbulkemail.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-ar' ;
	$tran = 'customer' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	$start = ($_GET["start"]) ? $_GET["start"] : $_POST["start"] ;
	$end = ($_GET["end"]) ? $_GET["end"] : $_POST["end"] ;
	$sdate = ($_GET["sdate"]) ? $_GET["sdate"] : $_POST["sdate"] ;
	$filter = urldecode(stripslashes($filter)) ;
	$proc1 = CreateObject('ck-api.process1') ;
	$where = $proc1->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('screen','confirm.tpl') ;
	$t->set_file('report',"${tran}statement.tpl") ;
	$t->set_block('report','item_row','item_section');
	$t->set_block('report','done','done_section');
	$t->set_var('done_section',"") ;
	$charset = lang('charset') ;
	$t->set_var('charset',$charset);
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('logo_url',$phpgw->link('/ck-admin/logo.png')) ;
	echo "<br><br>",lang("<b>Statement Email Despatch Log</b>"),"<br><br>" ;

/*------------- Setup Statement Caption/Legend Details ----------------------------*/

	$t->set_var('lang_statement',lang('STATEMENT'));
	$t->set_var('lang_start',lang('Statement Start'));
	$t->set_var('start',$start) ;
	$t->set_var('lang_end',lang('Statement End'));
	$t->set_var('end',$end) ;
	$t->set_var('lang_sdate',lang('Statement Date'));
	$t->set_var('sdate',$sdate) ;
	$t->set_var('lang_customer',lang('Customer:'));

	$t->set_var('lang_transdate',lang('Date'));
	$t->set_var('lang_duedate',lang('Due Date'));
	$t->set_var('lang_description',lang('Description'));
	$t->set_var('lang_isocode',lang('Currency'));
	$t->set_var('lang_invoice_amount',lang('Invoice<br>Amount'));
	$t->set_var('lang_payment_received',lang('Payment<br>Received'));
	$t->set_var('lang_balance',lang('Balance'));
	$t->set_var('lang_remark',lang('Remark'));

	$phpgw->db->query("SELECT * FROM ${pre}defaults");
	$phpgw->db->next_record();
	$company = $phpgw->db->f('company') ;
	$comemail = $phpgw->db->f('email') ;
	$inv_rmkid = $phpgw->db->f('inv_rmkid') ;

	$phpgw->db->query("SELECT * FROM ${pre}remark WHERE id='$inv_rmkid'");
	$phpgw->db->next_record();
	$footer = $phpgw->db->f('detail') ;

	if (!$order) {$order = "name" ; }
	if (!$sort)  {$sort = "ASC" ; }
	$sql =  "SELECT * from ${pre}customer WHERE $where order by ".$order." ".$sort ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()==0)	echo lang("No customer statement selected for despatch") ;
		else	For ($i=1;$phpgw->db->next_record();$i++) $senditem[$i]=$phpgw->db->Record ;

For ($i=1;isset($senditem[$i]);$i++) {
	$t->set_var('item_section',"");
	$id = $senditem[$i]['id'] ;
	$phpgw->db->query("SELECT * FROM ${pre}customer WHERE id='$id'");
	$phpgw->db->next_record();
	$custname = $phpgw->db->f('name') ;
	$contact = $phpgw->db->f('contact') ;
	$custemail = $phpgw->db->f('email') ;
	$custfax = $phpgw->db->f('fax') ;
	$t->set_var('name',$custname) ;
	$t->set_var('addr1',$phpgw->db->f('addr1')) ;
	$t->set_var('addr2',$phpgw->db->f('addr2')) ;
	$t->set_var('addr3',$phpgw->db->f('addr3')) ;
	$t->set_var('addr4',$phpgw->db->f('addr4')) ;
	$t->set_var('comment1',"") ;
	$t->set_var('comment2',"") ;
	$t->set_var('comment3',"") ;
	$t->set_var('comment4',lang("For Credit Balance, there is no need to pay/remit")) ;

	/*---------------------------------------------------------------------------------*/

	$user = $ckapi[hostsys][username];
	$temp0 = "${pre}arst0".$user.time() ;
	$temp1 = "${pre}arst1".$user.time() ;
	$temp2 = "${pre}arst2".$user.time() ;

	/*------------Collect all transactions related to this customer ($temp1)------------------*/

	$sql =	"CREATE TABLE $temp1 AS " ;
	$sql.=	"SELECT 'i' as flag,transdate,duedate,isocode,amount,invnumber as description " ;
	$sql.=	"FROM ${pre}ar WHERE customer=$id and transdate<='$end'" ;
	$phpgw->db->query($sql);
	$sql =	"INSERT INTO $temp1 (flag,transdate,isocode,amount,description) " ;
	$sql.=	"SELECT 'r',transdate, isocode, -amount, rptnumber FROM ${pre}receipt " ;
	$sql.=	"WHERE customer=$id and transdate<='$end'" ;
	$phpgw->db->query($sql);

	/*------------Create intra period detail transactions ($temp2)----------------------------*/

	$sql =	"CREATE TABLE $temp2 AS SELECT * FROM $temp1 WHERE " .
		"transdate>='$start' and transdate<='$end'" ;
	$phpgw->db->query($sql);

	/*------------Calculate and Print beginning balance-----------------------------------------*/

	$where = "WHERE customer=$id and transdate<'$start'" ;
	$sql =	"CREATE TABLE $temp0 AS SELECT isocode,amount FROM ${pre}ar $where" ;
	$phpgw->db->query($sql);
	$sql =	"INSERT INTO $temp0 (isocode,amount) SELECT isocode, -amount FROM ${pre}receipt $where" ;
	$phpgw->db->query($sql);
	$phpgw->db->query("SELECT isocode,sum(amount) as amount from $temp0 GROUP BY isocode");

	if ($phpgw->db->num_rows()==0) {
		$t->set_var(array(	'transdate'	=> $start,
				'duedate'	=> "",
				'description'=> lang("Bal. Brought Forward"),
				'isocode'	=> "" ,
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> 0 ,
	      	    		'remark'	=> "" ));
		$t->parse('item_section','item_row',true);
		}
	while ($phpgw->db->next_record()) {
		$amount = $phpgw->db->f('amount') ;
		$remark = ($amount<0) ? lang('[CR]') : "" ;
		$t->set_var(array(	'transdate'	=> $start,
				'duedate'	=> "",
				'description'=> lang("Bal. Brought Forward"),
				'isocode'	=> $phpgw->db->f('isocode') ,
				'invamt'	=> "",
				'payamt'	=> "",
				'balance'	=> $amount ,
	      	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}
	$t->set_var(array(	'transdate'	=> "",
			'duedate'	=> "",
			'description'=> "",
			'isocode'	=> "" ,
			'invamt'	=> "",
			'payamt'	=> "",
			'balance'	=> "" ,
      	    		'remark'	=> "" ));
	$t->parse('item_section','item_row',true);

	/*------------Obtain and Print Intra-Period Transactions-----------------------------------------*/

	$phpgw->db->query("SELECT * FROM $temp2 ORDER BY transdate");
	while ($phpgw->db->next_record()) {
		$remark = "" ;
		$flag = $phpgw->db->f('flag') ;
		$transdate = $phpgw->db->f('transdate') ;
		$duedate = ($flag=="i") ? $phpgw->db->f('duedate') : "" ;
		$description = $phpgw->db->f('description') ;
		$isocode = $phpgw->db->f('isocode') ;
		$age = $phpgw->db->f('age') ;
		$invamt = ($flag=="i") ? $phpgw->db->f('amount') : "" ;
		$rptamt = ($flag=="r") ? -$phpgw->db->f('amount') : "" ;
		$remark = ($flag=="r") ? lang("THANK YOU") : $remark ;
		$t->set_var(array(	'transdate'	=> $transdate,
					'duedate'	=> $duedate,
					'description'=> $description,
					'isocode'	=> $isocode,
					'invamt'	=> $invamt,
					'rptamt'	=> $rptamt,
					'balance'	=> "",
	     	 	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}
	$t->set_var(array(	'transdate'	=> "",
			'duedate'	=> "",
			'description'=> "",
			'isocode'	=> "" ,
			'invamt'	=> "",
			'rptamt'	=> "",
			'balance'	=> "" ,
      	    		'remark'	=> "" ));
	$t->parse('item_section','item_row',true);

	/*------------Calculate and Print Ending balance-----------------------------------------*/

	$phpgw->db->query("DROP TABLE $temp0");
	$phpgw->db->query("CREATE TABLE $temp0 AS SELECT isocode,amount FROM $temp1");
	$phpgw->db->query("SELECT isocode,sum(amount) as amount from $temp0 GROUP BY isocode");
	if ($phpgw->db->num_rows()==0) {
		$t->set_var(array(	'transdate'	=> $end,
				'duedate'	=> "",
				'description'=> lang("Bal. Carried Forward"),
				'isocode'	=> "" ,
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> 0 ,
	      	    		'remark'	=> "" ));
		$t->parse('item_section','item_row',true);
		}
	while ($phpgw->db->next_record()) {
		$amount = $phpgw->db->f('amount') ;
		$remark = ($amount<0) ? lang('[CR]') : "" ;
		$t->set_var(array(	'transdate'	=> $end,
				'duedate'	=> "",
				'description'=> lang("Bal. Carried Forward"),
				'isocode'	=> $phpgw->db->f('isocode') ,
				'invamt'	=> "",
				'rptamt'	=> "",
				'balance'	=> $amount ,
	      	    		'remark'	=> $remark ));
		$t->parse('item_section','item_row',true);
		}

	/*-------------Print Others --------------------------------------------*/

	$t->set_var('lang_thank',lang("Thank you for your continuous patronage")) ;
	$t->set_var('lang_footer',$footer) ;

	$phpgw->db->query("DROP TABLE $temp0");
	$phpgw->db->query("DROP TABLE $temp1");
	$phpgw->db->query("DROP TABLE $temp2");

	$err = "" ; $error=lang("Error") ; $noemail=lang("No email sent") ;
	$custmsg = lang("Customer") ;	$statmsg = lang("Statement for customer") ;
	$successmsg = lang("Email successfully queued for despatch to") ;
	$failuremsg = lang("Email fails to deliver to") ;
	if (!$custemail)				$err = lang("Customer email address missing") ;
	if ($custemail and strpos($custemail,'@')=='')	$err = lang("Invalid customer email address") ;
	if (!$comemail)					$err = lang("Self return email address missing");
	if ($comemail and strpos($comemail,'@')=='')	$err = lang("Invalid self return email address");
	
	if ($err)	echo "$statmsg, $custname -- $noemail -- $error: $err<br>" ;
	   else {
		$recipient = "$contact < $custemail >" ;
		$subject = lang("Statement of Account from %1 to %2",$start,$end) ;
		$message = $t->parse('out','report',true) ;
		$headers = "From: $company < $comemail >\n" ;
		$headers.= "Bcc: $company < $comemail >\n" ;
		$headers.= "Content-Type: text/html; charset=$charset\n" ;
		$headers.= "Return-Path: $company < $comemail >\n" ;
		$result = mail($recipient,$subject,$message,$headers) ;
		if ($result)	echo "$statmsg, $custname -- $successmsg $custemail<br>" ;
			else	echo "$statmsg, $custname -- $failuremsg $custemail<br>" ;
		}

	}

/*--------------------Write bottom Section------------------------------------------*/

	$t->set_var('lang_confirm',lang("Despatch Completed")) ;
	$t->set_var('lang_yes',lang("Done")) ;
	$t->set_var('lang_no',lang("Done")) ;
$t->set_var('yes_action',$phpgw->link("/$app/${tran}list.php","order=$order&sort=$sort&filter=$filter")) ;
$t->set_var('no_action',$phpgw->link("/$app/${tran}list.php","order=$order&sort=$sort&filter=$filter")) ;
	$t->pparse('out','screen',true);
	$phpgw->common->phpgw_footer();

?>
