<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.tax.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class tax {

//---- Tax Collected List SQL Formation

    function tax_list_sql() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_sql] as $key => $value)	$$key = $value ;

	$sql =  "SELECT transdate,invnumber,isocode,taxincluded,a.id," ;
	$sql.=		"qty*price as itemamt,qty*price-tax1-tax2 as netitemamt," ;
	$sql.=		"itemid,description,tax1,tax2 " ;
	$sql.=	"FROM ${pre}ar a,${pre}invoice b " ;
	$sql.=	"WHERE a.amount<>a.netamount and a.id=b.trans_id $where " ;
	$sql.=	"ORDER BY $order $sort";
	return $sql ;
	}
	
//---- Tax Collected List Link Adjustement

    function tax_list_adjust() {
	global $ckapi,$phpgw ;

	$app = $ckapi[params][app] ;
	$tran = $ckapi[params][tran] ;
	foreach ($ckapi[params_list] as $key => $value)	$$key = $value ;
	$t = &$ckapi[objects][template] ;
	$itemval = ($dt[taxincluded]=='t') ? $dt[netitemamt] : $dt[itemamt] ;
	$t->set_var('itemval',$itemval) ;
	$return = "/$app/${tran}list.php" ;
	$getstr = "id=$dt[id]&filter=$filter&return=$return" ;
	$t->set_var('view',$phpgw->link("/$app/invoicewtview.php",$getstr)) ;
	}

//---- Tax Detail Validation Checks

    function tax_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err="";  $error = lang("Error") ;
	if ($dt[taxnumber]=="")				$err=lang("Tax Name/Number Missing");
	if ($dt[rate] and !is_numeric($dt[rate]))	$err=lang("Tax Rate must be numeric");
	if ($dt[rate]<0 or $dt[rate]>10)		$err=lang("Rate must be 0-10(assumed maximum)");
	if ($dt[taxnumber]<>$dt[oldtaxnumber]) {
		$phpgw->db->query("SELECT * FROM ${pre}tax where taxnumber='$dt[taxnumber]'");
		if ($phpgw->db->num_rows()>0)		$err=lang("Tax Name/# already exists") ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Tax Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$errmsg1 = lang("This tax is still listed as default") ;
	$vendorrec = lang("within vendor record") ;
	$customerrec = lang("within customer record") ;
	$itemrec = lang("within parts/service record") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}vendortax where tax_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $vendorrec id#".$phpgw->db->f('vendor_id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}customertax where tax_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $customerrec id#".$phpgw->db->f('customer_id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}itemtax where tax_id='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $itemrec id#".$phpgw->db->f('item_id') ;
		}
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Tax Detail

    function tax_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_taxnumber',lang('Name/Number'));
	$t->set_var('lang_rate',lang('Rate'));
	$t->set_var('lang_account',lang('Associated Ledger A/C'));
	$t->set_var('lang_notes',lang('Notes'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('taxnumber',$dt[taxnumber]);
	$t->set_var('rate',$dt[rate]);
	$t->set_var('chart_id',$dt[chart_id]);
	$t->set_var('acc_selectlist',account_selectlist("WHERE link like '%AR_tax%'",$dt[chart_id]));
	$t->set_var('notes',$dt[notes]);
	$t->parse('out','report',True);
	}

    }

?>
