<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reportfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-bank' ;
	$tran = 'report' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"				) ;
	$ckapi[phrases] =array('lang_title'=>lang('Choose Report to Generate and to set Report Parameters :'),
				'lang_criteria'	=> lang("Report Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Report Generation") ,
				'lang_add'	=> lang("Done") ,
			'lang_search_message'	=> "" ,
				'message'	=> ""				);

	$note1 = lang("If wrong action chosen, click [Report] to restart.") ;
	$note1a = lang("If all parameters chosen, press [Start Report Generation] one more time to start.") ;
$bankac_sl = account_selectlist("WHERE (link like '%AP_paid%' or link like '%AR_paid%') and category='A'",'');
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$ckapi[filter][] = array(criteria	=>	lang('Which Report') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	"$note1<br>$note1a"			);

	$ckapi[filter][] = array(criteria	=>	lang('Bank Account') ,
				type		=>	'select' ,
				selectlist	=>	$bankac_sl ,
				varname		=>	'chart_id' ,
				defval		=>	'' ,
				note		=>	lang('Select the appropriate bank account')	);

	$ckapi[filter][] = array(criteria	=>	lang('Reconciliation Period from') ,
				type		=>	'input' ,
				varname		=>	'from' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Reconciliation Period to') ,
				type		=>	'input' ,
				varname		=>	'to' ,
				defval		=>	'' ,
				note		=>	$dateformat		) ;

	$ckapi[filter][] = array(criteria	=>	lang('Bank Balance as of BR Date') ,
				type		=>	'input' ,
				varname		=>	'bankbal' ,
				defval		=>	'' ,
				note		=>lang('Enter Bank Statement Balance as of Bank Reconcilation Date.  Must be numeric.')		) ;

	$statement = lang('Bank Reconciliation Statement') ;
	$reserved = lang('Reserved') ;
	$controlreport = lang('Bank Reconciliation Audit Control Report') ;
	$ckapi[filter][actlist] = array (	1=>"<OPTION value='1'>1 -- $statement</OPTION>",
						2=>"<OPTION value='2'>2 -- $reserved</OPTION>",
						3=>"<OPTION value='3'>3 -- $reserved</OPTION>",
						4=>"<OPTION value='4'>4 -- $reserved</OPTION>",
						5=>"<OPTION value='5'>5 -- $controlreport</OPTION>" ) ;
	$ckapi[filter][actstring] = array("0",		/* first entry	*/
					"01234",	/* report 1	*/
					"0",		/* report 2	*/
					"0",		/* report 3	*/
					"0",		/* report 4	*/
					"0123",		/* report 5	*/		) ;
	
	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;

?>
