<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: importfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-contact' ;
	$tran = 'import' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'doneexit'	=> "index.php"			) ;
	$title = lang("Choose Parameters for Contact Data Import :") ;
	$msg1 = lang('Please plan your importing action carefully.') ;
	$msg2 = lang('Inadvertent repeat of the importing process will create duplicate entries.') ;
	$msg3 = lang('After the import, the fields [preferred, person code and organization code] still need to be added back manually.') ;
	$msg4 = lang('The prefix and suffix fields may need to be rectified.') ;
	$msg5 = lang('You should also check for different org/person records that happen to end up with the same shortname/#.');
	$msg6 = lang('Importing of Contact Data requires lengthy processing time.') ;
	$msg7 = lang('You should initiate import only during off-peak hours.') ;
	$ckapi[phrases] = array('lang_title'	=> $title ,
				'lang_criteria'	=> lang("Import Parameters") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Importing Action") ,
				'lang_add'	=> lang("Return to Index Page") ,
			'lang_search_message'	=> "<b>$msg1  $msg2  $msg3  $msg4  $msg5<br></b>$msg6  $msg7" ,
				'message'	=> ""				);

	$note0 = lang("Please follow the strict sequence of Step 1, then Step 2, then Step 3.") ;
	$note1 = lang("If wrong data set chosen, click (Import Contact Data) to restart.") ;
	$note1a = lang("Press (Start Importing Action) one more time to start.") ;
	$dateformat = lang('Format: YYYY-MM-DD') ;
	$noteomask = lang('Import only those items that have an organization name with its 1st character being part of the mask.') ;
	$notefmask = lang('Import only those items that have a Family/Last name with its 1st character being part of the mask.') ;
	$notemask = lang('This is used to sectionalise the data import, if so desired.') ;
	$noteexp1 = lang('This will import Organisation=>Related Person and Person=>Associated Organization linkage information.') ;
	$noteexp2 = lang('Only previously unimported linkages will be imported.') ;
	$noteexp3 = lang('Linkages that had been overtaken by manually created organization<=>person links within ck-contact will not be imported.') ;
	$ckapi[filter][] = array(criteria	=>	lang('Which contact data set to import') ,
				type		=>	'select' ,
				selectlist	=>	'' ,
				varname		=>	'actnum' ,
				defval		=>	'' ,
				note		=>	"$note0<br>$note1"			) ;

	$ckapi[filter][] = array(criteria	=>	lang('Organization Name') ,
				type		=>	'input' ,
				varname		=>	'oname' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Contact Organization Name  field')) ;
	
	$ckapi[filter][] = array(criteria	=>	lang('[char1] Mask for Organization Name') ,
				type		=>	'input' ,
				varname		=>	'omask' ,
				defval		=>	'' ,
				note		=>	"$noteomask  $notemask"		);

	$ckapi[filter][] = array(criteria	=>	lang("Person_s Family/Last Name") ,
				type		=>	'input' ,
				varname		=>	'fname' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Contact Person_s Family/Last Name  field')) ;

	$ckapi[filter][] = array(criteria	=>	lang('[char1] Mask for Family/Last Name') ,
				type		=>	'input' ,
				varname		=>	'fmask' ,
				defval		=>	'' ,
				note		=>	"$notefmask  $notemask") ;

	$ckapi[filter][] = array(criteria	=>	lang('Explanatory Message'),
				type		=>	'input' ,
				varname		=>	'dummy' ,
				defval		=>	lang('[No Input Required]') ,
				note		=>	"$noteexp1  $noteexp2  $noteexp3") ;

	$lang_reserved = lang('Reserved') ;
	$import1 = lang('Step 1 -- Organization Data') ;
	$import2 = lang('Step 2 -- Person Data') ;
	$import3 = lang('Step 3 -- Organization <=> Person Linkage Data') ;

	$ckapi[filter][actlist] = array (	1=>	"<OPTION value='1'>$import1</OPTION>",
						2=>	"<OPTION value='2'>$import2</OPTION>",
						3=>	"<OPTION value='3'>$import3</OPTION>",
						4=>	"<OPTION value='4'>$lang_reserved</OPTION>",
						5=>	"<OPTION value='5'>$lang_reserved</OPTION>"	) ;
	$ckapi[filter][actstring] = array(	"0",	/* initial entry	*/
						"012",	/* import 1	*/
						"034",	/* import 2	*/
						"05",	/* import 3	*/
						"0",	/* import 4	*/
						"0"	/* import 5	*/			) ;
	if ($_POST[actnum]<>"")	$ckapi[filter][0][note] = $note1a ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_filter() ;

?>
