<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: importorgprsbulk.php,v 0.8.1 2004/06/30 C K Wu $ */
	
	$app = 'ck-contact' ;
	$class = 'import' ;
	$tran = 'importorgprs' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)

	$imporgprs = CreateObject("$app.$class") ;
	$ckapi[objects][tranobj] = &$imporgprs ;
	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$ckapi[objects][template] = &$t ;
	$proc1 = CreateObject('ck-api.process1') ;

	$reminder1 = lang("Don't forget to update the relevant Related Person / Assoicated Org Code for the imported links.") ;
	$reminder2 = lang("These information are not available from the host system.") ;
	$t->set_file('question','confirm.tpl');
	$t->set_var('lang_title',lang("Import Organization<=>Person Linkage Items"));
	$t->set_var('message','');
	$t->set_var('readonly',"readonly");
	$t->set_var('disabled',"disabled");

/*------------- Request contactimport lock ----------------------------*/

	$user = $ckapi[hostsys][username];
	$where1 = "WHERE resource='contactimport'" ;
	$phpgw->db->query("SELECT * FROM ${pre}resourcelock $where1");
	$phpgw->db->next_record() ;
	$used_by = $phpgw->db->Record['used_by'] ;
	if ($used_by=="")	
		$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' $where1");
	  else	{
		$error=lang("Error");	$err=lang("Contact Import is being accessed by ").$used_by;
		$t->set_var('lang_confirm',"$error:  $err");
		$t->set_var('lang_yes',lang('done'));
		$t->set_var('lang_no',lang('done'));
		$t->set_var('yes_action',$phpgw->link("/$app/importfilter.php")) ;
		$t->set_var('no_action',$phpgw->link("/$app/importfilter.php")) ;
		$t->pparse('out','question',True);
		exit() ;
		}

/*------------- Build $commcode, $addrcode array ----------------------------*/
	
	$user = $ckapi[hostsys][username];
	$temp = $ckapi[params][temp] = "${pre}importorgprsbulk".$user.time() ;

	$sql =	"CREATE TABLE $temp AS " ;
	$sql.=	"SELECT org_id, a.person_id, b.id as orid, c.id as pid,orgnumber,prsnumber,title,department " ;
	$sql.=	"FROM phpgw_contact_org_person a, ${pre}org b, ${pre}person c, phpgw_contact_person d " ;
	$sql.=	"WHERE org_id=substring(b.note,position('=' in b.note)+1) " ;
	$sql.=	"and a.person_id=substring(c.note,position('=' in c.note)+1) and a.person_id=d.person_id" ;
	$phpgw->db->query($sql);
	$fields = "orid,pid,a.title,a.department,'n' as preferred " ;
	if ($ckapi[hostsys][dbtype]=="mysql") {
		$sql =	"SELECT $fields " ;
		$sql.=	"FROM ($temp a LEFT JOIN ${pre}org_person b ON orid=b.contactid and pid=personid) " ;
		$sql.=		"LEFT JOIN ${pre}person_org c ON pid=c.contactid and orid=orgid " ;
		$sql.=	"WHERE b.personid IS NULL and c.orgid IS NULL " ;
		}
	  else
		{	
		$sql =	"SELECT $fields " ;
		$sql.=	"FROM ($temp a LEFT JOIN ${pre}org_person b ON orid=b.contactid and pid=personid) " ;
		$sql.=		"LEFT JOIN ${pre}person_org c ON pid=c.contactid and orid=orgid " ;
		$sql.=	"EXCEPT " ;
		$sql.=	"SELECT $fields FROM $temp a, ${pre}org_person b, ${pre}person_org c " ;
		$sql.=	"WHERE orid=b.contactid and pid=personid and pid=c.contactid and orid=orgid " ;
		}

	$phpgw->db->query($sql);
	while ($phpgw->db->next_record())	$org_person[] = $phpgw->db->Record;

/*------------- Import Contact Data into CK-ERP tables ---------------------*/

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $class ,
				'tran'		=> $tran ,
				'table'		=> "${pre}org"				) ;
	$ckapi[tables]["parents"] = array("${pre}org"=> "skipskip" 	);
	$ckapi[tables]["children"] = array("${pre}org_person"=> "contactid" 		);
	$ckapi[params_post][op] = "edit" ;

	$i = 0 ;
	foreach ($org_person as $key => $val) {
		$dt[id] = $id = $val[orid] ;
		$phpgw->db->query("SELECT * FROM ${pre}org where id='$id'");
		$phpgw->db->next_record();
		$dt[control] = $phpgw->db->f('control') ;
		$phpgw->db->query("SELECT * FROM ${pre}org_person where contactid='$id' order by personcode");
		For ($j=1;$phpgw->db->next_record();$j++) {
			$dt['preferred'.$j]	=	$phpgw->db->f('preferred') ;
			$dt['personid'.$j]	=	$phpgw->db->f('personid') ;
			$dt['personcode'.$j]	=	$phpgw->db->f('personcode') ;
			$dt['title'.$j]		=	$phpgw->db->f('title') ;
			$dt['department'.$j]	=	$phpgw->db->f('department') ;
			} 
		$dt['preferred'.$j]	=	$val['preferred'] ;
		$dt['personid'.$j]	=	$val['pid'] ;
		$dt['personcode'.$j]	=	"" ;
		$dt['title'.$j]		=	$val['title'] ;
		$dt['department'.$j]	=	$val['department'] ;
		$ckapi[params_post][dt] = $dt ;
		
		$proc1->process1_post() ;
		$i++ ;
		}
		
	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $class ,
				'tran'		=> "importprsorg" ,
				'table'		=> "${pre}person"				) ;
	$ckapi[tables]["parents"] = array("${pre}person"=> "skipskip" 	);
	$ckapi[tables]["children"] = array("${pre}person_org"=> "contactid" 		);
	$ckapi[params_post][op] = "edit" ;

	foreach ($org_person as $key => $val) {
		$dt[id] = $id = $val[pid] ;
		$phpgw->db->query("SELECT * FROM ${pre}person where id='$id'");
		$phpgw->db->next_record();
		$dt[control] = $phpgw->db->f('control') ;
		$phpgw->db->query("SELECT * FROM ${pre}person_org where contactid='$id' order by orgcode");
		For ($j=1;$phpgw->db->next_record();$j++) {
			$dt['preferred'.$j]	=	$phpgw->db->f('preferred') ;
			$dt['orgid'.$j]		=	$phpgw->db->f('orgid') ;
			$dt['orgcode'.$j]	=	$phpgw->db->f('orgcode') ;
			$dt['title'.$j]		=	$phpgw->db->f('title') ;
			$dt['department'.$j]	=	$phpgw->db->f('department') ;
			} 
		$dt['preferred'.$j]	=	$val['preferred'] ;
		$dt['orgid'.$j]		=	$val['orid'] ;
		$dt['orgcode'.$j]	=	"" ;
		$dt['title'.$j]		=	$val['title'] ;
		$dt['department'.$j]	=	$val['department'] ;
		$ckapi[params_post][dt] = $dt ;
		
		$proc1->process1_post() ;
		}


	$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='' WHERE resource='contactimport'");
	
	if ($ckapi[params][temp]<>"") {
		$temp = $ckapi[params][temp] ;
		$phpgw->db->query("DROP TABLE $temp");
		}

/*--------------------Write bottom Section------------------------------------------*/

	$link_confirm = "$i  ".lang('Contact Organization<=>Person Link(s) Imported') ;
	$reminder = lang('Please remember to rectify the org code and the person code for the imported links.');
	$t->set_var('lang_confirm',"$link_confirm<br><br>$reminder");
	$t->set_var('lang_yes',lang('done'));
	$t->set_var('lang_no',lang('done'));
	$t->set_var('yes_action',$phpgw->link("/$app/importfilter.php")) ;
	$t->set_var('no_action',$phpgw->link("/$app/importfilter.php")) ;
	$t->pparse('out','question',True);

?>
