<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: importprsslist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-contact' ;
	$tran = 'importprss' ;
	include('../ck-api/ckapi.inc.php') ;

	$fname = ($_GET["fname"]) ? $_GET["fname"] : $_POST["fname"] ;
	$fmask = ($_GET["fmask"]) ? $_GET["fmask"] : $_POST["fmask"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'import',
				'tran'		=> $tran ,
				'table'		=> "${pre}person" ,
				'doneexit'	=> "importprsbulk.php"			);
	$msg1 = lang("Only Active Persons will be listed and be imported.") ;
	$msg2 = lang("It is advisable to save or print a copy of this list for future reference.") ;
	$msg3 = lang("Because of semantic difference, the fields [title,department,prefix,suffix,sound] are  imported as [others] fields.") ;
	$msg4 = lang("Because of semantic difference, the field [preferred] is not imported.") ;
	$ckapi[phrases] = array('lang_title'	=> lang("List of Contact Persons to be imported") ,
				'lang_add'	=> lang("Start Bulk Import") ,
				'lang_prsnumber'=> lang('Person_s shortname/# after import') ,
				'lang_alter'	=> lang("Display Detail List") ,
				'alter_action'	=> $phpgw->link("/$app/importprsdlist.php"),
				'fname'		=> $fname ,
				'fmask'		=> $fmask ,
				'filter'	=> $filter ,
				'message'	=> "$msg1  $msg2  $msg3  $msg4"			);
	$ckapi[columns] = array('hostsysid'	=> lang('Host System ID') ,
				'username'	=> lang('Host System Username') ,
				'family'	=> lang('Person_s Family/Last Name') ,
				'given'		=> lang('Person_s Given Name') ,
				'birthday'	=> lang('Birthday') ,
				'pubkey'	=> lang('Public Key') ,
				'prsnumber'	=> lang('Person_s shortname/# after import')	);
	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

?>
