<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.address.inc.php,v 0.8.1 2004/06/30 C K Wu $ */

    class address {

//---- Address Read

    function address_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	if ($table=="${pre}org")	$dt[name] = $dt[orgnumber] ;
	if ($table=="${pre}person")	$dt[name] = $dt[prsnumber] ;
	$phpgw->db->query("SELECT * FROM ${pre}address where contactid='$id' order by addresscode");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['line1'.$i]		=	$phpgw->db->f('line1') ;
		$dt['line2'.$i]		=	$phpgw->db->f('line2') ;
		$dt['line3'.$i]		=	$phpgw->db->f('line3') ;
		$dt['line4'.$i]		=	$phpgw->db->f('line4') ;
		$dt['addresscode'.$i]	=	$phpgw->db->f('addresscode') ;
		$dt['region'.$i]	=	$phpgw->db->f('region') ;
		$dt['country'.$i]	=	$phpgw->db->f('country') ;
		$dt['zip'.$i]		=	$phpgw->db->f('zip') ;
		$dt['preferred'.$i]	=	$phpgw->db->f('preferred') ;
		}
	return $dt;
	}

//---- Address Validation Checks

    function address_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error = lang("Error") ;
	$lang_address = lang('address') ;
	$hda=$hia=$pca=$wka=$pra = "" ;
	$row = lang("Row") ;
	For ($i=1;isset($dt['addresscode'.$i]);$i++) {
		if ($dt['line1'.$i]=='' and $dt['line2'.$i]=='' and $dt['line3'.$i]=='' and $dt['line4'.$i]=='')
						$err="[$row $i]".lang("Blank address lines") ;
		$addresscode = $dt['addresscode'.$i] ;
		$sql = "SELECT name FROM ${pre}cttcode where type='$lang_address' and name='$addresscode'";
		$phpgw->db->query($sql);
		$phpgw->db->next_record() ;
		switch ($phpgw->db->f('name')) :
			case "hdomaddr": if ($hda<>"") $err="[$row $i]".lang("More than one [hdomaddr] address"); $hda="1";break;
			case "hintaddr": if ($hia<>"") $err="[$row $i]".lang("More than one [hintaddr] address"); $hia="1";break;
			case "parcaddr": if ($pca<>"") $err="[$row $i]".lang("More than one [parcaddr] address"); $pca="1";break;
			case "workaddr": if ($wka<>"") $err="[$row $i]".lang("More than one [workaddr] address"); $wka="1";break;
			endswitch ;
		if ($dt['preferred'.$i]=='y')
			if ($pra<>"")	$err="[$row $i]".lang("More than one [preferred] address");		else $pra="1";
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Address Header

    function address_header_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('lang_name',lang('Contact Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('table',$ckapi[params][table]) ;
	$t->parse('out','report',True);
	}

//---- Write Address Detail

    function address_detail_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_address',lang('Address (Addr) Line1, Line2, Line3, Line4'));
	$t->set_var('lang_codetype',lang("Type of Code") );
	$t->set_var('lang_codedesc',lang("Code -- Description [or Data Input Field]") );
	$t->set_var('lang_preferred',lang('Preferred Address'));
	$t->set_var('lang_addresscode',lang('Address Type'));
	$t->set_var('lang_region',lang('Region'));
	$t->set_var('lang_country',lang('Country'));
	$t->set_var('lang_zip',lang('Postal Code'));
	$t->set_var('lang_delete',lang('Delete'));
	$t->set_var('lang_reserved',lang('Reserved Space'));
	$blankopt = "<OPTION value=''></OPTION>" ;
	$lang_address = lang('address') ;
	$lang_region = lang('region') ;
	$lang_country = lang('country') ;
	$lang_no = lang("no") ;
	$lang_yes = lang("yes") ;
	$preferred_sl = "<OPTION value='n'>n -- $lang_no</OPTION><OPTION value='y'>y -- $lang_yes</OPTION>" ;
	$addresscode_sl = cttcodename_selectlist("WHERE type='$lang_address'",'',"long") ;
	$region_sl = "<OPTION value=''></OPTION>".cttcodename_selectlist("WHERE type='$lang_region'",'',"long") ;
	$country_sl = "<OPTION value=''></OPTION>".cttcodename_selectlist("WHERE type='$lang_country'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['addresscode'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('line1_fld','line1'.$i);
			$t->set_var('line2_fld','line2'.$i);
			$t->set_var('line3_fld','line3'.$i);
			$t->set_var('line4_fld','line4'.$i);
			$t->set_var('preferred_fld','preferred'.$i) ;
			$t->set_var('addresscode_fld','addresscode'.$i) ;
			$t->set_var('region_fld','region'.$i) ;
			$t->set_var('country_fld','country'.$i) ;
			$t->set_var('zip_fld','zip'.$i) ;
			$t->set_var('line1','') ;
			$t->set_var('line2','') ;
			$t->set_var('line3','') ;
			$t->set_var('line4','') ;
			$t->set_var('zip','') ;
			$t->set_var('preferred_selectlist',$preferred_sl) ;
			$t->set_var('addresscode_selectlist',$addresscode_sl) ;
			$t->set_var('region_selectlist',$region_sl) ;
			$t->set_var('country_selectlist',$country_sl) ;
			$t->set_var('delrowno',$row_.$i) ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$preferred	= $dt['preferred'.$i] ;
		$addresscode	= $dt['addresscode'.$i] ;
		$region		= $dt['region'.$i] ;
		$country	= $dt['country'.$i] ;
		$t->set_var('line1_fld','line1'.$j);
		$t->set_var('line2_fld','line2'.$j);
		$t->set_var('line3_fld','line3'.$j);
		$t->set_var('line4_fld','line4'.$j);
		$t->set_var('preferred_fld','preferred'.$j) ;
		$t->set_var('addresscode_fld','addresscode'.$j) ;
		$t->set_var('region_fld','region'.$j) ;
		$t->set_var('country_fld','country'.$j) ;
		$t->set_var('zip_fld','zip'.$j) ;

		$t->set_var('line1',$dt['line1'.$i]) ;
		$t->set_var('line2',$dt['line2'.$i]) ;
		$t->set_var('line3',$dt['line3'.$i]) ;
		$t->set_var('line4',$dt['line4'.$i]) ;
		$t->set_var('zip',$dt['zip'.$i]) ;
		$t->set_var('preferred_selectlist',str_replace("'$preferred'","'$preferred' selected",$preferred_sl)) ;
		$t->set_var('addresscode_selectlist',str_replace("'$addresscode'","'$addresscode' selected",$addresscode_sl)) ;
		$t->set_var('region_selectlist',str_replace("'$region'","'$region' selected",$region_sl)) ;
		$t->set_var('country_selectlist',str_replace("'$country'","'$country' selected",$country_sl));
		if ($posted)	$t->set_var('insrowno',"done") ;  else  $t->set_var('insrowno',$row_.$j);
		if ($posted)	$t->set_var('delrowno',"done") ;  else  $t->set_var('delrowno',$row_.$j) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('line1_fld','line1'.$i);
		$t->set_var('line2_fld','line2'.$i);
		$t->set_var('line3_fld','line3'.$i);
		$t->set_var('line4_fld','line4'.$i);
		$t->set_var('preferred_fld','preferred'.$i) ;
		$t->set_var('addresscode_fld','addresscode'.$i) ;
		$t->set_var('region_fld','region'.$i) ;
		$t->set_var('country_fld','country'.$i) ;
		$t->set_var('zip_fld','zip'.$i) ;
		$t->set_var('line1','') ;
		$t->set_var('line2','') ;
		$t->set_var('line3','') ;
		$t->set_var('line4','') ;
		$t->set_var('zip','') ;
		$t->set_var('preferred_selectlist',$preferred_sl) ;
		$t->set_var('addresscode_selectlist',$addresscode_sl) ;
		$t->set_var('region_selectlist',$region_sl) ;
		$t->set_var('country_selectlist',$country_sl) ;
		$t->set_var('delrowno',$row_.$i) ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	$t->parse('out','report',True);
	}

//---- Address Post - PreCommit Routine

    function address_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')	$phpgw->db->query("DELETE from ${pre}address where contactid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['addresscode'.$i]);$i++) {
			$line1 = $dt['line1'.$i] ;
			$line2 = $dt['line2'.$i] ;
			$line3 = $dt['line3'.$i] ;
			$line4 = $dt['line4'.$i] ;
			$preferred = $dt['preferred'.$i] ;
			$addresscode = $dt['addresscode'.$i] ;
			$region = $dt['region'.$i] ;
			$country = $dt['country'.$i] ;
			$zip = $dt['zip'.$i] ;
			$sql = "INSERT INTO ${pre}address(contactid,line1,line2,line3,line4," ;
			$sql.= "addresscode,region,country,zip,preferred) " ;
			$sql.= "VALUES('$id','$line1','$line2','$line3','$line4'," ;
			$sql.= "'$addresscode','$region','$country','$zip','$preferred')" ;
			$phpgw->db->query($sql);
			}
		}
	}

    }

?>

