<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.employee.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

	class employee {

//---- Employee Read

    function employee_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;
	$phpgw->db->query("SELECT * FROM $table WHERE id='$id'");
	$phpgw->db->next_record();
	if (!is_array($uniqueflds) or $op<>'edit')    return $phpgw->db->Record;
	  else  {
		$dt = $phpgw->db->Record ;
	  	foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
		return $dt ;
		}
	}

//---- Employee Detail Validation Checks

    function employee_validate() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error = lang("Error") ;
	if ($dt[name]=="")			$err=lang('Employee Name/# Missing');
	if ($dt[family]=="")			$err=lang('Family name missing');
	if ($dt[given]=="")			$err=lang('Given name missing');
	if ($dt[nationalid]=="")		$err=lang('National ID missing');
	if ($dt[title]=="")			$err=lang('Corporate title missing');
	if ($dt[name]<>$dt[oldname]) {
		$phpgw->db->query("SELECT * FROM ${pre}employee where name='$dt[name]'");
		if ($phpgw->db->num_rows()>0)	$err=lang("Employee Name/# already exists") ;
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Employee Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;
	$err=""; $error=lang('Error') ;
	$errmsg1 = lang("This employee is in use within an existing") ;
	$payroll = lang("payroll record") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * FROM ${pre}payroll where empid='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $payroll id#".$phpgw->db->f('id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Employee Detail

    function employee_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$t->set_var('tr_color',$ckapi[hostsys][tr_color2]) ;
	$t->set_var('lang_name',lang("Employee Name/#"));
	$t->set_var('lang_id',lang("Audit Id :"));
	$t->set_var('lang_personal',lang("Personal Information :"));
	$t->set_var('lang_prefix',lang("Prefix"));
	$t->set_var('lang_family',lang("Family Name"));
	$t->set_var('lang_given',lang("Given Name"));
	$t->set_var('lang_suffix',lang("Suffix"));
	$t->set_var('lang_nationalid',lang("National ID"));
	$t->set_var('lang_username',lang("Host System User Name"));
	$t->set_var('lang_corporate',lang("Corporate Information :"));
	$t->set_var('lang_ctitle',lang("Corporate Title"));
	$t->set_var('lang_dept',lang("Department"));
	$t->set_var('lang_grade',lang("Staff Grade"));
	$t->set_var('lang_supervisor',lang("Supervisor"));
	$t->set_var('lang_subtitle',lang("Auxillary Information [click righthand links to view (readonly) details]:"));
	$t->set_var('lang_address',lang("Address"));
	$t->set_var('lang_phone',lang("Phone"));
	$t->set_var('lang_email',lang("Email"));
	$t->set_var('lang_ec',lang("Emergency Contact"));
	$t->set_var('lang_dates',lang("Important Dates"));
	$t->set_var('lang_leave',lang("Leave Record"));
	$t->set_var('lang_perform',lang("Performance Review"));
	$t->set_var('lang_role',lang("Role"));

	$blankopt = "<OPTION value=''></OPTION>" ;
	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('name',$dt[name]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$lang_prefix = lang('prefix') ;
	$t->set_var('prefix_sl',hrcodename_selectlist("WHERE type='$lang_prefix'",$dt[prefix],"short"));
	$t->set_var('family',$dt[family]);
	$t->set_var('given',$dt[given]);
	$lang_suffix = lang('suffix') ;
	$t->set_var('suffix_sl',$blankopt.hrcodename_selectlist("WHERE type='$lang_suffix'",$dt[suffix],"short"));
	$t->set_var('nationalid',$dt[nationalid]);
	$t->set_var('username',$dt[username]);
	$t->set_var('title',$dt[title]);
	$t->set_var('dept_sl',dept_selectlist('',$dt[dept]));
	$lang_grade = lang('grade') ;
	$t->set_var('grade_sl',hrcodename_selectlist("WHERE type='$lang_grade'",$dt[grade],"long"));
	$t->set_var('supervisor_sl',employee_selectlist('',$dt[supervisor]));
	$getstr = "id=$dt[id]" ;
	$t->set_var('address',$phpgw->link('/ck-hr/addressview.php',$getstr));
	$t->set_var('phone',$phpgw->link('/ck-hr/phoneview.php',$getstr));
	$t->set_var('email',$phpgw->link('/ck-hr/emailview.php',$getstr));
	$t->set_var('ec',$phpgw->link('/ck-hr/ecview.php',$getstr));
	$t->set_var('dates',$phpgw->link('/ck-hr/datesview.php',$getstr));
	$t->set_var('leave',$phpgw->link('/ck-hr/leaveview.php',$getstr));
	$t->set_var('perform',$phpgw->link('/ck-hr/prview.php',$getstr));
	$t->set_var('role',$phpgw->link('/ck-hr/roleview.php',$getstr));
	$t->set_var('message','');

	$img = $ckapi[hostsys][dataarea]."/images/$dt[id].png" ;
	$t->set_var('image',$phpgw->link("/ck-hr/employeeview_image.php","imgfile=$img"));

	$t->parse('out','report',True);
	}

//---- Employee Post - PreCommit Routine (* if delete op, erase auxillary info *)

    function employee_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	if ($op=='delete') {
		$phpgw->db->query("DELETE FROM ${pre}address where contactid = '$id'");
		$phpgw->db->query("DELETE FROM ${pre}phone where empid = '$id'");
		$phpgw->db->query("DELETE FROM ${pre}email where empid = '$id'");
		$phpgw->db->query("DELETE FROM ${pre}ec where empid = '$id'");
		$phpgw->db->query("DELETE FROM ${pre}dates where empid = '$id'");
		$phpgw->db->query("DELETE FROM ${pre}leave where empid = '$id'");
		$phpgw->db->query("DELETE FROM ${pre}pr where empid = '$id'");
		$phpgw->db->query("DELETE FROM ${pre}role where empid = '$id'");
		}
	}
    }

?>



