<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.leave.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class leave {

//---- Leave Read

    function leave_read() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$id = $ckapi[params_post][id] ;

	$phpgw->db->query("SELECT * FROM ${pre}employee WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;

	$phpgw->db->query("SELECT * from ${pre}leave where empid='$id' order by leavefrom");
	For ($i=1;$phpgw->db->next_record();$i++) {
		$dt['trans_id'.$i]	=	$phpgw->db->f('trans_id') ;
		$leavefrom		=	$phpgw->db->f('leavefrom') ;
		$dt['fromyear'.$i]	=	substr($leavefrom,0,4) ;
		$dt['frommonth'.$i]	=	substr($leavefrom,5,2) ;
		$dt['fromday'.$i]	=	substr($leavefrom,8,2) ;
		$leaveto		=	$phpgw->db->f('leaveto') ;
		$dt['toyear'.$i]	=	substr($leaveto,0,4) ;
		$dt['tomonth'.$i]	=	substr($leaveto,5,2) ;
		$dt['today'.$i]		=	substr($leaveto,8,2) ;
		$dt['leavecode'.$i]	=	$phpgw->db->f('leavecode') ;
		$dt['duration'.$i]	=	$phpgw->db->f('duration') ;
		}
	return $dt ;
	}

//---- Leave Validation Checks

    function leave_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error = lang("Error") ;
	$row = lang("Row") ;
	if (!isset($dt[fromyear1]))			return $err ;
	$al=$cl=$ji=$js=$ml=$sl=$ua=$ul = "" ;
	For ($i=1;isset($dt['fromyear'.$i]);$i++) {
		$rowi = "[$row $i]" ;
		$fromdate = input2date($dt['fromyear'.$i].'-'.$dt['frommonth'.$i].'-'.$dt['fromday'.$i]) ;
		if ($fromdate=="") {
			$err=$rowi.lang("Invalid From Date");
			$errRow[$i] = True ;
			}
		$todate = input2date($dt['toyear'.$i].'-'.$dt['tomonth'.$i].'-'.$dt['today'.$i]) ;
		if ($todate=="") {
			$err=$rowi.lang("Invalid To Date");
			$errRow[$i] = True ;
			}
		$leavefrom[$i] = strtotime($fromdate) ;
		$leaveto[$i] = strtotime($todate) ;
		if ($fromdate<>"" and $todate<>"" and $leavefrom[$i]>$leaveto[$i]) {
			$err=$rowi.lang("From Date later than To Date") ;
			$errRow[$i] = True ;
			}
		$duration = $dt['duration'.$i] ;
		if ($duration=='' or $duration==0)	$err=$rowi.lang("invalid Workdays figure") ;
		if ($duration*10%5 <>0)		$err=$rowi.lang("Workdays must be whole day or half a day") ;
		if ($fromdate<>"" and $todate<>"" and ($leaveto[$i]-$leavefrom[$i])<(($duration-1)*24*60*60))
						$err=$rowi.lang("Work Days > Period duration") ;
		if ($dt['fromyear'.$i]<>$dt['toyear'.$i])  $err=$rowi.lang("From year must equal To year");
		}
	$size = $i-1 ;
	For ($i=1;$i<$size;$i++) {
		For ($j=$i+1;$j<=$size;$j++) {
			$rowij = "[$row $i/$j]" ;
			if (!$errRow[$i] and !$errRow[$j] and $leavefrom[$j]>=$leavefrom[$i] and $leavefrom[$j]<=$leaveto[$i])
							$err=$rowij.lang("overlapping leave periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $leaveto[$j]>=$leavefrom[$i] and $leaveto[$j]<=$leaveto[$i])
							$err=$rowij.lang("overlapping leave periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $leavefrom[$i]>=$leavefrom[$j] and $leavefrom[$i]<=$leaveto[$j])
							$err=$rowij.lang("overlapping leave periods") ;
			if (!$errRow[$i] and !$errRow[$j] and $leaveto[$i]>=$leavefrom[$j] and $leaveto[$i]<=$leaveto[$j])
							$err=$rowij.lang("overlapping leave periods") ;
			}
		}
	if ($err)	$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Leave Header

    function leave_header_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_name',lang('Employee Name/# :'));
	$t->set_var('lang_id',lang('Audit Id :'));
	$t->set_var('name',$dt[name]) ;
	$t->set_var('id',$dt[id]) ;
	$t->set_var('control',$dt[control]) ;
	$t->set_var('disabled','');
	$t->parse('out','report',True);
	}

//---- Write Leave Detail

    function leave_detail_write() {
	global $ckapi,$phpgw ;

	$dt = $ckapi[params_post][dt] ;
	$op = $ckapi[params_post][op] ;
	$t = &$ckapi[objects][template] ;
	foreach ($ckapi[buttons] as $key => $value)	$$key = $value ;

	$row_ = lang('Row')." " ;
	$id = $dt[id] ;
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;
	$t->set_var('lang_insert',lang('Insert<br>before'));
	$t->set_var('lang_timesheetid',lang('Timesheet<br>Audit ID'));
	$t->set_var('lang_fromyear',lang('From<br>Year'));
	$t->set_var('lang_frommonth',lang('From<br>Month'));
	$t->set_var('lang_fromday',lang('From<br>Day'));
	$t->set_var('lang_hyphen','-');
	$t->set_var('lang_toyear',lang('To<br>Year'));
	$t->set_var('lang_tomonth',lang('To<br>Month'));
	$t->set_var('lang_today',lang('To<br>Day'));
	$t->set_var('lang_pointer',"=>");
	$t->set_var('lang_leavecode',lang('Leave Code -- Description'));
	$t->set_var('lang_duration',lang('Work Days'));
	$t->set_var('lang_delete',lang('Delete'));
	$lang_leave = strtolower(lang('leave')) ;

	$blankopt = "<OPTION value=''></OPTION>" ;
	$year_sl = year_selectlist('','') ;
	$month_sl = month_selectlist('','') ;
	$day_sl = day_selectlist('','') ;
	$def_year = date("Y") ;
	$def_month = date("m") ;
	$def_day = date("d") ;
	$def_year_sl= str_replace("'$def_year'","'$def_year' selected",$year_sl) ;
	$def_month_sl= str_replace("'$def_month'","'$def_month' selected",$month_sl) ;
	$def_day_sl= str_replace("'$def_day'","'$def_day' selected",$day_sl) ;
	$leavecode_sl = hrcodename_selectlist("WHERE lower(type)='$lang_leave'",'',"long") ;
	if (isset($insert))	$insrowno = intval(str_replace($row_,"",$insert));
	if (isset($delete))	$delrowno = intval(str_replace($row_,"",$delete));
	For ($i=1;isset($dt['duration'.$i]);$i++) {
		if ($i==$delrowno) continue;
		if ($i==$insrowno) {
			$t->set_var('insrowno',$row_.$i) ;
			$t->set_var('trans_id_fld','trans_id'.$i) ;
			$t->set_var('fromyear_fld','fromyear'.$i) ;
			$t->set_var('frommonth_fld','frommonth'.$i) ;
			$t->set_var('fromday_fld','fromday'.$i) ;
			$t->set_var('toyear_fld','toyear'.$i) ;
			$t->set_var('tomonth_fld','tomonth'.$i) ;
			$t->set_var('today_fld','today'.$i) ;
			$t->set_var('leavecode_fld','leavecode'.$i) ;
			$t->set_var('duration_fld','duration'.$i);
			$t->set_var('trans_id','') ;
			$t->set_var('fromyear_selectlist',$def_year_sl);
			$t->set_var('frommonth_selectlist',$def_month_sl) ;
			$t->set_var('fromday_selectlist',$def_day_sl) ;
			$t->set_var('toyear_selectlist',$def_year_sl);
			$t->set_var('tomonth_selectlist',$def_month_sl) ;
			$t->set_var('today_selectlist',$def_day_sl) ;
			$t->set_var('leavecode_selectlist',$leavecode_sl) ;
			$t->set_var('duration','') ;
			$t->set_var('delrowno',$row_.$i) ;
			$t->set_var('tsreadonly',"") ;
			$t->set_var('tsdisabled',"") ;
			$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
			$t->set_var('tr_color',$tr_color) ;
			$t->parse('detail_section','detail', True);
			$insrowno = 0;
			$i-- ;
			continue ;
			}
		$j = $i ;
		if (isset($insert) and $i>$insrowno)	$j=$i+1;
		if (isset($delete) and $i>$delrowno)	$j=$i-1;

		$trans_id	=	($dt['trans_id'.$i]<>0) ? $dt['trans_id'.$i] : "" ;
		$fromyear	=	$dt['fromyear'.$i] ;
		if ($op<>'view' and $trans_id<>"")
			$fromyear_sl = "<OPTION value='$fromyear'>$fromyear</OPTION>" ;
		  else	$fromyear_sl = str_replace("'$fromyear'","'$fromyear' selected",$year_sl) ;
		$frommonth	=	$dt['frommonth'.$i] ;
		if ($op<>'view' and $trans_id<>"")
			$frommonth_sl = "<OPTION value='$frommonth'>$frommonth</OPTION>" ;
		  else	$frommonth_sl = str_replace("'$frommonth'","'$frommonth' selected",$month_sl) ;
		$fromday	=	$dt['fromday'.$i] ;
		if ($op<>'view' and $trans_id<>"")
			$fromday_sl = "<OPTION value='$fromday'>$fromday</OPTION>" ;
		  else	$fromday_sl = str_replace("'$fromday'","'$fromday' selected",$day_sl) ;
		$toyear		=	$dt['toyear'.$i] ;
		if ($op<>'view' and $trans_id<>"")
			$toyear_sl = "<OPTION value='$toyear'>$toyear</OPTION>" ;
		  else	$toyear_sl = str_replace("'$toyear'","'$toyear' selected",$year_sl) ;
		$tomonth	=	$dt['tomonth'.$i] ;
		if ($op<>'view' and $trans_id<>"")
			$tomonth_sl = "<OPTION value='$tomonth'>$tomonth</OPTION>" ;
		  else	$tomonth_sl = str_replace("'$tomonth'","'$tomonth' selected",$month_sl) ;
		$today		=	$dt['today'.$i] ;
		if ($op<>'view' and $trans_id<>"")
			$today_sl = "<OPTION value='$today'>$today</OPTION>" ;
		  else	$today_sl = str_replace("'$today'","'$today' selected",$day_sl) ;
		$leavecode	=	$dt['leavecode'.$i] ;
		if ($op<>'view' and $trans_id<>"")
			$leavecodesl = hrcodename_selectlist("WHERE type='$lang_leave' and name='$leavecode'",'',"long") ;
		  else	$leavecodesl = str_replace("'$leavecode'","'$leavecode' selected",$leavecode_sl) ;
		$duration	=	$dt['duration'.$i] ;

		$t->set_var('trans_id_fld','trans_id'.$j) ;
		$t->set_var('fromyear_fld','fromyear'.$j) ;
		$t->set_var('frommonth_fld','frommonth'.$j) ;
		$t->set_var('fromday_fld','fromday'.$j) ;
		$t->set_var('toyear_fld','toyear'.$j) ;
		$t->set_var('tomonth_fld','tomonth'.$j) ;
		$t->set_var('today_fld','today'.$j) ;
		$t->set_var('leavecode_fld','leavecode'.$j) ;
		$t->set_var('duration_fld','duration'.$j);
		$t->set_var('trans_id',$trans_id) ;
		$t->set_var('fromyear_selectlist',$fromyear_sl) ;
		$t->set_var('frommonth_selectlist',$frommonth_sl) ;
		$t->set_var('fromday_selectlist',$fromday_sl) ;
		$t->set_var('toyear_selectlist',$toyear_sl) ;
		$t->set_var('tomonth_selectlist',$tomonth_sl) ;
		$t->set_var('today_selectlist',$today_sl) ;
		$t->set_var('leavecode_selectlist',$leavecodesl) ;
		$t->set_var('duration',$duration) ;
		if ($posted)	$t->set_var('insrowno',"done") ; else	$t->set_var('insrowno',$row_.$j) ;
		if ($posted)	$t->set_var('delrowno',"done") ; else	$t->set_var('delrowno',$row_.$j) ;
		if ($op=='view' or $trans_id=="") {$t->set_var('tsreadonly',"");$t->set_var('tsdisabled',"");}
		  else	{$t->set_var('tsreadonly',"readonly"); $t->set_var('tsdisabled',"disabled");}
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}
	if ($i==1)			$t->set_var('detail_section','') ;
	if ($i==2 and $delrowno==1)	$t->set_var('detail_section','') ;
	if ($newrow) {
		$t->set_var('insrowno',$row_.$i) ;
		$t->set_var('trans_id_fld','trans_id'.$i) ;
		$t->set_var('fromyear_fld','fromyear'.$i) ;
		$t->set_var('frommonth_fld','frommonth'.$i) ;
		$t->set_var('fromday_fld','fromday'.$i) ;
		$t->set_var('toyear_fld','toyear'.$i) ;
		$t->set_var('tomonth_fld','tomonth'.$i) ;
		$t->set_var('today_fld','today'.$i) ;
		$t->set_var('leavecode_fld','leavecode'.$i) ;
		$t->set_var('duration_fld','duration'.$i);
		$t->set_var('trans_id','') ;
		$t->set_var('fromyear_selectlist',$def_year_sl);
		$t->set_var('frommonth_selectlist',$def_month_sl) ;
		$t->set_var('fromday_selectlist',$def_day_sl) ;
		$t->set_var('toyear_selectlist',$def_year_sl);
		$t->set_var('tomonth_selectlist',$def_month_sl) ;
		$t->set_var('today_selectlist',$def_day_sl) ;
		$t->set_var('leavecode_selectlist',$leavecode_sl) ;
		$t->set_var('duration','') ;
		$t->set_var('delrowno',$row_.$i) ;
		$t->set_var('tsreadonly',"") ;
		$t->set_var('tsdisabled',"") ;
		$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
		$t->set_var('tr_color',$tr_color) ;
		$t->parse('detail_section','detail', True);
		}

	$t->parse('out','report',True);
	}

//---- Leave Post - PreCommit Routine

    function leave_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	foreach ($ckapi[params_post] as $key => $value)	$$key = $value ;

	if ($op<>'new')		$phpgw->db->query("DELETE from ${pre}leave where empid='$id'");
	if ($op<>'delete') {
		For ($i=1;isset($dt['duration'.$i]);$i++) {
			$trans_id	=	$dt['trans_id'.$i] ;
			$leavefrom	=$dt['fromyear'.$i].'-'.$dt['frommonth'.$i].'-'.$dt['fromday'.$i] ;
			$leaveto	=	$dt['toyear'.$i].'-'.$dt['tomonth'.$i].'-'.$dt['today'.$i] ;
			$leavecode	=	$dt['leavecode'.$i] ;
			$duration	=	$dt['duration'.$i] ;
			if ($trans_id=='')	$trans_id=0 ;
			$sql = "INSERT INTO ${pre}leave (empid,trans_id,leavefrom,leaveto," ;
			$sql.= "leavecode,duration) ";
			$sql.= "VALUES ('$id','$trans_id','$leavefrom','$leaveto','$leavecode','$duration')" ;
			$phpgw->db->query($sql);
			}
		}
	}
    }

?>
