<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: inventorylist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-inv' ;
	$tran = 'inventory' ;
	$enable_nm = True ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}parts" 		);
	$ckapi[phrases] = array('lang_title'	=> lang("List of Inventory Items :") ,
				'lang_add'	=> lang("Add New Inventory Item") ,	);
	$ckapi[columns] = array('partnumber'	=> lang('Part Name/Number') ,
				'bin'		=> lang('Bin Location') ,
				'description'	=> lang('Description') ,
				'notes'		=> lang('Notes') ,
				'price'		=> lang('Price') ,
				'id'		=> lang('Audit ID') 		);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'ihist'		=> "/$app/${tran}hist.php" ,
				'photo'		=> "/$app/photoedit.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_ihist'	=> lang("Balance/History") ,
				'lang_photo'	=> lang("Photo") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

?>
