<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.attrib.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class attrib {

//---- Attribute Read

    function attrib_read() {
	global $ckapi,$phpgw ;

	$attrib = ($_GET["attrib"]) ? $_GET["attrib"] : $_POST["attrib"] ;
	$caption = ($_GET["caption"]) ? $_GET["caption"] : $_POST["caption"] ;
	$table = ($_GET["table"]) ? $_GET["table"] : $_POST["table"] ;
	$sdfld = ($_GET["sdfld"]) ? $_GET["sdfld"] : $_POST["sdfld"] ;
	$ldfld = ($_GET["ldfld"]) ? $_GET["ldfld"] : $_POST["ldfld"] ;
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;

	$phpgw->db->query("SELECT * from $table WHERE id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$dt[attrib] = $attrib ;
	$dt[caption] = $caption ;
	$dt[table] = $table ;
	$dt[sdfld] = $sdfld ;
	$dt[ldfld] = $ldfld ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Attribute Add Initialisation

    function attrib_add_init() {
	global $ckapi ;

	$attrib = ($_GET["attrib"]) ? $_GET["attrib"] : $_POST["attrib"] ;
	$caption = ($_GET["caption"]) ? $_GET["caption"] : $_POST["caption"] ;
	$table = ($_GET["table"]) ? $_GET["table"] : $_POST["table"] ;
	$sdfld = ($_GET["sdfld"]) ? $_GET["sdfld"] : $_POST["sdfld"] ;
	$ldfld = ($_GET["ldfld"]) ? $_GET["ldfld"] : $_POST["ldfld"] ;

	$dt = &$ckapi[params_post][dt] ;
	$dt = array(	'attrib'	=> $attrib,
			'caption'	=> $caption,
			'table'		=> $table ,
			'sdfld'		=> $sdfld ,
			'ldfld'		=> $ldfld		) ;
	}

//---- Attribute Detail Validation Checks

    function attrib_validate() {
	global $ckapi,$phpgw ;

	$sdfld = ($_GET["sdfld"]) ? $_GET["sdfld"] : $_POST["sdfld"] ;
	$ldfld = ($_GET["ldfld"]) ? $_GET["ldfld"] : $_POST["ldfld"] ;
	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$dt = &$ckapi[params_post][dt] ;

	$err="";  $error = lang("Error") ;
	$missing = lang("Missing") ;
	$alreadyexists = lang("already exists") ;
	if ($dt["$sdfld"]=="")		$err="$sdfld $missing";
	if ($dt["$ldfld"]=="")		$err="$ldfld $missing";
	if ($dt[$sdfld]<>$dt["old$sdfld"]) {
		$phpgw->db->query("SELECT * FROM $table WHERE $sdfld='$dt[$sdfld]'");
		if ($phpgw->db->num_rows()>0)	$err="$sdfld $alreadyexists" ;
		}

	if ($err)			$err="<b>$error: $err</b>" ;
	return $err ;
	}

//---- Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$caption = ($_GET["caption"]) ? $_GET["caption"] : $_POST["caption"] ;
	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$errmsg1 = lang("This %1 is in use within an existing",$caption) ;
	$journal = lang('journal');
	$id = $dt[id] ;
	$sql = "SELECT * from ${pre}acc_trans WHERE attrib1='$id' or attrib2='$id' or attrib3='$id'" ;
	$phpgw->db->query($sql);
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $journal id#".$phpgw->db->f('trans_id') ;
		}
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Attribute Detail

    function attrib_write() {
	global $ckapi,$phpgw ;

	$sdfld = ($_GET["sdfld"]) ? $_GET["sdfld"] : $_POST["sdfld"] ;
	$ldfld = ($_GET["ldfld"]) ? $_GET["ldfld"] : $_POST["ldfld"] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_sdfld',$sdfld);
	$t->set_var('lang_ldfld',$ldfld);

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('attrib',$dt[attrib]);
	$t->set_var('caption',$dt[caption]);
	$t->set_var('table',$dt[table]);
	$t->set_var('sdfld',$sdfld);
	$t->set_var('ldfld',$ldfld);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('sdesc',$dt[$sdfld]);
	$t->set_var('ldesc',$dt[$ldfld]);
	$t->parse('out','report',True);
	}

    }

?>
