<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: bulkpayrollfilter_validate.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'bulkpayroll' ;
	$noheader = True ;  $nonavbar = True ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$err = ($_GET["err"]) ? $_GET["err"] : $_POST["err"] ;
	$actnum = ($_GET["actnum"]) ? $_GET["actnum"] : $_POST["actnum"] ;
	$period = ($_GET["period"]) ? $_GET["period"] : $_POST["period"] ;
	$datefrom = ($_GET["datefrom"]) ? $_GET["datefrom"] : $_POST["datefrom"] ;
	$dateto = ($_GET["dateto"]) ? $_GET["dateto"] : $_POST["dateto"] ;
	$empid = ($_GET["empid"]) ? $_GET["empid"] : $_POST["empid"] ;

/* --------------------- Validation Check Start ----------------------------	*/

	$error = lang("Error") ;
	$lang_payperiod = lang('Payroll for period') ;
	$lang_from = lang('from') ;
	$lang_to = lang('to') ;
	$lang_scheque = lang('SalaryCheque') ;
	$lang_empid = lang('empid') ;
	$lang_period = lang('period') ;

	if ($err)	$err=lang("Error flagged before validation") ;
	if ($period<>'' and ($actnum==1 or $actnum==2)) {
		$phpgw->db->query("SELECT * FROM ${pre}payroll WHERE period='$period'");
		if ($phpgw->db->num_rows()==0)	$err=lang("No staff (with the selected pay period) found");
		}
	if ($datefrom<>"") {
		$date=input2date($datefrom) ;
		if ($date=="")	$err=lang("Invalid Period From Date");
			else	$datefrom = $date ;
		}
	if ($dateto<>"") {
		$date=input2date($dateto) ;
		if ($date=="")	$err=lang("Invalid Period To Date");
			else	$dateto = $date ;
		}
	if ($datefrom<>"" and $dateto<>"" and strtotime($datefrom)>strtotime($dateto))
				$err=lang("Period From later than Period To");
	if ($actnum==1 or $actnum==2) {

		$lang_from = lang('from') ;
		$lang_to = lang('to') ;
		$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
		$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
		$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
		$topos = "position('$tomarker' in description)+$tomarkerlen" ;
		$descdatefrom = "substring(description,$frompos,10)" ;
		$descdateto = "substring(description,$topos,10)" ;

		$sql =	"SELECT * FROM ${pre}gl " ;
		$sql.=	"WHERE source='PYRO' and " ;
		$sql.=	"(($descdatefrom>='$datefrom' and $descdatefrom<='$dateto') " ;
		$sql.=	"or ($descdateto>='$datefrom' and $descdateto<='$dateto'))" ;
		$phpgw->db->query($sql);
		if ($phpgw->db->num_rows()>0)	$err=lang("Period From/To overlaps with previous payroll periods") ;
		if ($datefrom=="")		$err=lang("Payroll Generation From Date must not be blank") ;
		if ($dateto=="")		$err=lang("Payroll Generation To Date must not be blank") ;
		}
	if ($actnum==2 and !$err)	{
		$user = $ckapi[hostsys][username];
		$where = "WHERE resource='bulkpayrollgen'" ;
		$phpgw->db->query("SELECT * FROM ${pre}resourcelock $where");
		$phpgw->db->next_record() ;
		$used_by = $phpgw->db->Record['used_by'] ;
		if ($used_by=="")
				$phpgw->db->query("UPDATE ${pre}resourcelock SET used_by='$user' $where");
			else	$err = lang("Bulk Payroll Generation is being accessed by")." $used_by";
		}

	if ($err)		$err = "<b>$error: $err</b>" ;

/* --------------------- Validation Check Complete -------------------------	*/

if (!$err)
	{
	switch ($actnum) {
		case 1:
			$getstr = "period=$period&datefrom=$datefrom&dateto=$dateto" ;
			Header('Location: '.$phpgw->link("/$app/${tran}test.php",$getstr));
			exit();
		case 2:
			$getstr = "period=$period&datefrom=$datefrom&dateto=$dateto" ;
			Header('Location: '.$phpgw->link("/$app/${tran}gen.php",$getstr));
			exit();
		case 3:
			$frommarker = $lang_from.'::' ;  $frmarkerlen=strlen($frommarker);
			$tomarker = $lang_to.'::' ;  $tomarkerlen = strlen($tomarker) ;
			$frompos = "position('$frommarker' in description)+$frmarkerlen" ;
			$topos = "position('$tomarker' in description)+$tomarkerlen" ;
			$descdatefrom = "substring(description,$frompos,10)" ;
			$descdateto = "substring(description,$topos,10)" ;
			if ($datefrom)
				$filter .= " AND $descdatefrom>='$datefrom' and $descdatefrom<='$dateto' ";
			if ($dateto)
				$filter .= " AND $descdateto>='$datefrom' and $descdateto<='$dateto' ";
			$filter = urlencode($filter) ;
			Header('Location: '.$phpgw->link("/$app/${tran}list.php","filter=$filter"));
			exit();
		default:
			echo lang("Should not be here.  Weird Action Number") ;
		}
	}
else
	{
	$getstr = "actnum=$actnum&period=$period&datefrom=$datefrom&dateto=$dateto&empid=$empid&err=$err" ;
	Header('Location: '.$phpgw->link("/ck-payroll/bulkpayrollfilter.php",$getstr));
	exit();
	}

?>
