<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: index.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'index' ;
	include('../ck-api/ckapi.inc.php') ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir('ck-api'));
	$t->set_file('report','index.tpl') ;
	$t->set_block('report','detail','detail_row');
	$t->set_block('report','ack','ack_row');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

$t->set_var('lang_caption',lang("Welcome to Payroll"));
$t->set_var('lang_motto',lang("CK: Common Knowledge - to be shared and developed by all"));
$t->set_var('lang_welcome','');
$t->set_var('lang_user_admin',lang('User/Administrator'));
$t->set_var('lang_auditor',lang('Auditor'));
$t->set_var('lang_developer',lang('Developer'));
$user1a = lang("Irrespective of any assertion from any person or source, there are BUGS/ERRORS associated with Payroll.") ;
$user1b = lang("You are using Payroll or any derivative of Payroll at your own risk.") ;
$user1	= "<b>$user1a  $user1b</b>" ;
$user2	= "<b>".lang("Do not expect any help nor assistance on Payroll from anyone.")."</b>" ;
$user3a = lang("You should report to relevant government authority once you have concrete evidence that major fictitious entries are being put through the system");
$user3b = lang("or the system itself is being used for illegal purpose, e.g. money laundering") ;
$user3  = "<b>$user3a, $user3b</b>" ;
$user4a = lang("Payroll is intended to run on top of Linux, Postgres/MySQL, Apache, PHP and PHPGroupWare.") ;
$user4b = lang("For similar platforms, it may work, but no guarantees.") ;
$user4	= "<b>$user4a  $user4b</b>" ;
$user5a = lang("Payroll is distributed WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.") ;
$user5b = lang("See the GNU General Public License for more detail.") ;
$user5	= "$user5a  $user5b" ;
$user6a = lang("Payroll is designed with simplicity in mind and no attempt is made to speed up execution.") ;
$user6b = lang("Client display is best viewed at 1024x768 or above.");
$user6c = lang("Recommended font size: (Konqueror - minimum=7, medium=9; Mozilla - proportional=12, monospace=9)") ;
$user6	= "$user6a  $user6b  $user6c" ;
$user7a = lang("Since Payroll communicates via http, it is exposed to hacking attempts from inside/outside of the installation site.") ;
$user7b = lang("It is recommended that the Payroll server be disconnected physically from the network whenever possible,") ;
$user7c = lang("or putting the server and client on the same machine, so network connection is not necessary.") ;
$user7  = "$user7a  $user7b $user7c" ;
$user8a	= lang("The best way to study Payroll is to follow the steps:") ;
$user8b = lang("Admin/Setup -> 1 - Setup Data Tables") ;
$user8c = lang("Admin/Setup -> 2 - Build Chart -> Default Chart") ;
$user8d = lang("Admin/Setup -> 3 - Create Test Data") ;
$user8e = lang("Play around with the various features.  If stuck,") ;
$user8f = lang("Admin/Setup -> 4 - Delete all Data") ;
$user8g = lang("and repeat the process") ;
$user8h = lang("(Pls refer to Developer column for test data setup)") ;
$user8  = "$user8a<br>$user8b<br>$user8c<br>$user8d<br>$user8e<br>$user8f<br>$user8g<br>$user8h" ;
$user9a = lang("If you are reporting an error and/or bug, please try to recreate the symptoms using the standard test data,") ;
$user9b = lang("so other people can readily recreate the error to help in debugging.") ;
$user9  = "$user9a $user9b" ;
$auditor1a = lang("Major database items are assigned an audit (trail) id.") ;
$auditor1b = lang("Item creation, update and delete trail information are stored in the log table") ;
$auditor1  = "<b>$auditor1a  $auditor1b</b>" ;
$auditor2  = $user2 ;
$auditor3  = $user3 ;
$auditor4  = lang("To ensure data integrity, it is important to print a copy of the audit control report before and after each audit.") ;
$auditor5a = lang("Access control is implemented using phpGW's User/Group access feature.") ;
$auditor5b = lang("However, a user with direct access to the underlying database WILL CIRCUMVENT ALL SUCH CONTROLS.") ;
$auditor5c = lang("In a PC environment, the existence of such a user must be assumed.") ;
$auditor5  = "$auditor5a  $auditor5b  $auditor5c" ;
$auditor6a = lang("Because Payroll is written in PHP, you should check in detail the entire content of php.ini,") ;
$auditor6b = lang("to ensure that all operating parameters and startup environment are safe and secure.") ;
$auditor6c = lang("These parameters may also be modified by the host system or middle layer software during script execution.") ;
$auditor6  = "$auditor6a $auditor6b  $auditor6c" ;
$auditor7a = lang("Duplicate entries are easy to create inadvertently via Copy/Modify or Posting twice.") ;
$auditor7b = lang("Therefore, it is important to check for such entries, ie entries with all fields being the same, except for audit id.") ;
$auditor7c = lang("HR staff is allowed to modify attendance record post staff sign-in/out.") ;
$auditor7d = lang("It is important to ensure that such modification is authorised and done correctly.") ;
$auditor7  = "$auditor7a  $auditor7b<br>$auditor7c  $auditor7d" ;
$auditor8  = lang("There are other areas of audit concern regarding the OS, middleware, development language, co-existing applications, etc, etc, etc.") ;
$developer1a = lang("Payroll is GPL software.") ;
$developer1b = lang("If you display this -- Welcome to Payroll -- page exactly as it is,") ;
$developer1c = lang("or display this same page's translation (into a different language), without loss of meaning,") ;
$developer1d = lang("then you may redistribute and/or modify it under the terms of the GNU General Public License as published by the Free Software Foundation.") ;
$developer1  = "<b>$developer1a  $developer1b  $developer1c $developer1d</b>" ;
$developer2  = $user2 ;
$developer3  = $user3 ;
$developer4a = lang("Payroll is intended to be used by SMEs that cannot afford a full-blown ERP.") ;
$developer4b = lang("Therefore, I don't intent to implement any advanced feature beyond a basic vanila Payroll system.") ;
$developer4  = "$developer4a  $developer4b" ;
$developer5a = lang("To follow the logic of Payroll, you must have basic Payroll knowledge.") ;
$developer5b = lang("Just ask how you would manage the personnel records of a corporation in a manual paper based environment.") ;
$developer5c = lang("If you are not sure how these are done, pick up an introductory Payroll text and work your way through.") ;
$developer5  = "$developer5a  $developer5b  $developer5c" ;
$developer7a = lang("For ease of system maintenance and error recovery, no index/sequence nor interim result/balance are stored.") ;
$developer7b = lang("It follows that judicial addition of index/sequence should speed up execution quite a bit.") ;
$developer7  = "$developer7a  $developer7b" ;
$developer8a = lang("With the standard test data set,") ;
$developer8b = lang("Payroll records for ckchai and demo carry the most complete set of data.") ;
$developer8c = lang("Only check payment has been implemented.  Autopay may be added in future") ;
$developer8  = "$developer8a<br><br>$developer8b<br><br>$developer8c" ;
$developer9a = lang("Legal environment for Payroll management is quite different for different jurisdictions.") ;
$developer9b = lang("Payroll may not fullfil all legal requirements for use in your region.") ;
$developer9  = "$developer9a  $developer9b" ;

For ($i=1;$i<=9;$i++) {
	$user='user'.$i;
	$auditor='auditor'.$i;
	$developer='developer'.$i;
	$t->set_var('user',$$user);
	$t->set_var('auditor',$$auditor);
	$t->set_var('developer',$$developer);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('detail_row','detail',True);
	}

$t->set_var('lang_ack',lang('ACKNOWLEDGEMENT'));
$t->set_var('lang_date',lang('Date'));
$t->set_var('lang_detail',lang('Detail'));
$t->set_var('lang_contributor',lang('Contributor'));

$dates = array(
		lang("Pre-2004-07"),
		lang("2004-07")
		) ;
$details = array(
		lang("Predecessor of CK-ERP is CK-Ledger"),
		lang("CK-ERP v.0.8.1; Payroll being a sub-module")
		) ;
$contributors = array (
		lang("Wu Chiu Kay aka CK Wu aka CK") ,
		lang("Wu Chiu Kay aka CK Wu aka CK")
		) ;

foreach ($dates as $key => $date ) {
	$t->set_var('date',$date);
	$t->set_var('detail',$details[$key]);
	$t->set_var('contributor',$contributors[$key]);
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('ack_row','ack',True);
	}

$t->pparse('out','report', true);

?>

