<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: nrtranslist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'nrtrans' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'nrtrans',
				'tran'		=> $tran ,
				'table'		=> "${pre}pynr_trans" ,
				'sortkey'	=> "empname,pyrname"			);
	$msg1 = lang('Payroll staff is allowed to create/update payroll items independently.') ;
	$msg2 = lang('Affected staff and his/her supervisor will be advised by email of such update action.');
	$ckapi[phrases] = array('lang_title'	=> lang("List of Non-recurring Payroll Items") ,
				'lang_add'	=> lang("Add New Non-recurring Payroll Item") ,
				'message'	=> "$msg1   $msg2"		);
	$ckapi[columns] = array('empname'	=> lang('Employee Name/#') ,
				'pyrname'	=> lang('E/A Name') ,
				'description'	=> lang('Expense/Allowance Description') ,
				'qty'		=> lang('Quantity') ,
				'unit'		=> lang('Unit') ,
				'rate'		=> lang('Pay Rate') ,
				'comment'	=> lang('Comment') ,
				'approved_by'	=> lang('Approved By') ,
				'id'		=> lang('Audit ID') 			);
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")		) ;
	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

?>
