<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: payrollfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'payroll' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'payroll',
				'tran'		=> $tran ,
				'table'		=> "${pre}payroll" 			) ;
	$msg1 = lang('To search for all items, leave fields blank.');
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Staff Payroll Master :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Individual Staff Payroll Master") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;

	$ckapi[filter][] = array(criteria	=>	lang('Staff Name') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.employee_selectlist('','') ,
				varname		=>	'empid' ,
				defval		=>	'' ,
				note		=>lang('Search for payroll record of the target staff'));

	$ckapi[filter][] = array(criteria	=>	lang('Pay Period') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.pperiod_selectlist('','') ,
				varname		=>	'period' ,
				defval		=>	'' ,
				note		=>	lang('Search for payroll record with target pay period'));

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
