<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: pyrcodefilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'pyrcode' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'pyrcode',
				'tran'		=> $tran ,
				'table'		=> "${pre}pyrcode" 			) ;
	$msg1 = lang('To search for all items, leave fields blank.');
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Allowance/Deduction Codes :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Allowance/Deduction Code") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$nullopt = "<OPTION value='ALL'></OPTION>" ;
	$note1 = lang('Search for target [Basis of Calculation]') ;
	$note2a = lang("bs - basic salary, pc - allowance/deduction unit amount, dp - imputed daily pay,") ;
	$note2b = lang("hp - imputed hourly pay, qty - inputted qty, amt - inputted amount");

	$ckapi[filter][] = array(criteria	=>	lang('Basis of Calculation') ,
				type		=>	'select' ,
				selectlist	=>	$nullopt.basis_selectlist('','') ,
				varname		=>	'basis' ,
				defval		=>	'' ,
				note		=>	"$note1:<br>$note2a<br>$note2b"		);

	$ckapi[filter][] = array(criteria	=>	lang('Code Name') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	'' ,
				note		=>	lang('Search for target keyword embedded in the Allowance/Deduction Code'));

	$ckapi[filter][] = array(criteria	=>	lang('Code Description') ,
				type		=>	'input' ,
				varname		=>	'desc' ,
				defval		=>	'' ,
				note		=>	lang('Search for target keyword embedded in the Allowance/Deduction Description'));

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
