<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: reductnfilter.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-payroll' ;
	$tran = 'reductn' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> 'reductn',
				'tran'		=> $tran ,
				'table'		=> "${pre}reductn" 			) ;
	$msg1 = lang('To search for all items, leave fields blank.');
	$msg2 = lang('Maximum length of search string is 15 characters.') ;
	$ckapi[phrases] = array('lang_title'	=> lang("Search among existing Summary Level Reductions :") ,
				'lang_criteria'	=> lang("Searching Criteria") ,
				'lang_value'	=> lang("Value") ,
				'lang_note'	=> lang("Note") ,
				'lang_search'	=> lang("Start Search") ,
				'lang_add'	=> lang("Add New Summary Level Reduction") ,
			'lang_search_message'	=> "$msg1<br>$msg2" ,
				'message'	=> ""				);

	$ckapi[filter][] = array(criteria	=>	lang('Reduction Name') ,
				type		=>	'input' ,
				varname		=>	'name' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Reduction Name Field'));

	$ckapi[filter][] = array(criteria	=>	lang('Reduction Description') ,
				type		=>	'input' ,
				varname		=>	'desc' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Reduction Description Field'));

	$ckapi[filter][] = array(criteria	=>	lang('Locality') ,
				type		=>	'input' ,
				varname		=>	'locality' ,
				defval		=>	'' ,
				note		=>	lang('Search for target key word in the Locality Field')) ;

	$proc = CreateObject('ck-api.process') ;
	$proc->process_filter() ;

?>
