<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cashballist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'cashbal' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	
	$filter = urldecode(stripslashes($filter)) ;
	$proc = CreateObject('ck-api.process') ;
	$where = $proc->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$t->set_file('report',"${tran}list.tpl") ;
	$t->set_block('report','cashbal','cashbal_section');
	$t->set_block('report','cashanal','cashanal_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Shift End Cash Balances'));
$t->set_var('lang_sorthead',lang('[click column heading to re-sort table]'));
$t->set_var('lang_cashbox',lang('Cash Box Name'));
$t->set_var('lang_done',lang('Done'));
$t->set_var('done_action',$phpgw->link("/$app/${tran}filter.php"));
$script = "/$app/${tran}list.php" ;
$t->set_var('sort_transdate',$phpgw->nextmatchs->show_sort_order($sort,'transdate',$order,$script,lang('Cash Sale Date'),$filter));
$t->set_var('sort_shift',$phpgw->nextmatchs->show_sort_order($sort,'shift',$order,$script,lang('Shift'),$filter));
$t->set_var('sort_name',$phpgw->nextmatchs->show_sort_order($sort,'name',$order,$script,lang('Quasi-Cash Name'),$filter));
$t->set_var('sort_itemtype',$phpgw->nextmatchs->show_sort_order($sort,'itemtype',$order,$script,lang('Item Type'),$filter));
$t->set_var('sort_amount',$phpgw->nextmatchs->show_sort_order($sort,'amount',$order,$script,lang('Amount'),$filter));
$t->set_var('lang_view',lang('View Detail'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

$rpos = strrpos($where,"'") ;
$lpos = strrpos(substr($where,1,$rpos-1),"'") ;
$cboxid = substr($where,$lpos) ;
$phpgw->db->query("SELECT name FROM ${pre}cashbox WHERE id=$cboxid");
$phpgw->db->next_record() ;
$t->set_var('cashbox',$phpgw->db->f('name')) ;

// ---------------------- Write Quasi-Cash Balances Section -------------------------

if (!$order) {$order = "name" ; }
if (!$sort)  {$sort = "ASC" ; }
$blankdate = "transdate = ''" ;
if (substr_count($where,$blankdate)>0)	$where = str_replace($blankdate,"1<>1",$where) ;
$sql =	"SELECT itemid,transdate,b.shift as shift,c.name as name,itemtype,sum(qty*a.value) as amount " ;
$sql.=	"FROM ${pre}positem a, ${pre}pos b, ${pre}qcash c " ;
$sql.=	"WHERE $where and itemtype='q' and a.trans_id=b.id and a.itemid=c.id  " ;
$sql.=	"GROUP BY itemid,transdate,b.shift,c.name,itemtype ORDER BY ".$order." ".$sort ;
$phpgw->db->query($sql);

if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'shift'		=> "",
				'name'		=> "",
				'itemtype'	=> "",
				'amount'	=> "",
				'view'		=> "" ));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashbal_section','cashbal',True);
	}
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('itemid') ;
	$name = $phpgw->db->f('name') ;
	$amount = $phpgw->db->f('amount') ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'shift'		=> $phpgw->db->f('shift'),
				'name'		=> $name ,
				'itemtype'	=> $phpgw->db->f('itemtype'),
				'amount'	=> $amount ,
				'view'	=> $phpgw->link("/$app/${tran}view.php","id=$id&filter=$filter")  ));
	if ($name==lang("Cash"))	$cashamount = number_format($amount,2,".",'') ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashbal_section','cashbal',true);
	}

$sql =	"SELECT itemid,transdate,shift,sum(qty*value) as amount FROM ${pre}positem a, ${pre}pos b " ;
$sql.=	"WHERE $where and itemtype='c' and a.trans_id=b.id GROUP BY itemid,transdate,shift" ;
$phpgw->db->query($sql) ;
$phpgw->db->next_record() ;
$id = $phpgw->db->f('itemid') ;
$changeamount = number_format($phpgw->db->f('amount'),2,".",'') ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('Cash Change') ,
			'itemtype'	=> "c",
			'amount'	=> $changeamount,
			'view'		=> $phpgw->link("/$app/${tran}view.php","id=$id&filter=$filter")  ));
$t->set_var('tr_color',$ckapi[hostsys][th_bg]) ;
$t->parse('cashbal_section','cashbal',true);
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashbal','cashbal_section',true);

// -------------------------------- Write Cash Balance Analysis Section -----------------------------------------

$t->set_var('lang_analysis',lang('Cash Balance Analysis')) ;
$t->set_var('lang_note1',lang('[Shift]:  1-Morning, 2-Afternoon, 3-Overnight'));
$t->set_var('lang_note2',lang('[TranType]: s - start-of-shift, +/- => Cash in/out, e - end-of-shift'));
$t->set_var('lang_transdate',lang('Cash Sale Date')) ;
$t->set_var('lang_shift',lang('Shift')) ;
$t->set_var('lang_name',lang('Item Detail')) ;
$t->set_var('lang_trantype',lang('Transaction Type')) ;
$t->set_var('lang_amount',lang('Amount')) ;

$netbal = 0 ;
$sql =	"SELECT * from ${pre}cbtran WHERE $where and trantype='s'" ;
$phpgw->db->query($sql) ;
$phpgw->db->next_record() ;
$amount = number_format($phpgw->db->f('amount'),2,".",'') ; $netbal+= $amount ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('Start-of-shift Cash-in'),
			'trantype'	=> $phpgw->db->f('trantype'),
			'amount'	=> $amount			)) ;
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal_section','cashanal',true);
$netbal+= number_format($cashamount,2,".",'') ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('Total Cash tendered by Customer'),
			'trantype'	=> '',
			'amount'	=> $cashamount			)) ;
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal_section','cashanal',true);

$netbal+= number_format($changeamount,2,".",'') ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('Total Cash Change returned to Customer'),
			'trantype'	=> '',
			'amount'	=> $changeamount		)) ;
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal_section','cashanal',true);

$sql =	"SELECT * from ${pre}cbtran WHERE $where and trantype<>'s' and trantype<>'e'" ;
$phpgw->db->query($sql);
while ($phpgw->db->next_record()) {
	$id = $phpgw->db->f('id') ;
	$trantype = $phpgw->db->f('trantype') ;
	$amount = number_format($phpgw->db->f('amount'),2,".",''); $netbal+= $amount ;
	if ($trantype=='+')	$name = lang("Additional Cash transferred in during Shift") ;
	if ($trantype=='-')	$name = lang("Additional Cash transferred out during Shift") ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'shift'		=> $phpgw->db->f('shift'),
				'name'		=> $name,
				'trantype'	=> $trantype,
				'amount'	=> $amount	));
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashanal_section','cashanal',true);
	}

$sql =	"SELECT * from ${pre}cbtran WHERE $where and trantype='e'" ;
$phpgw->db->query($sql) ;
$phpgw->db->next_record() ;
$amount = number_format($phpgw->db->f('amount'),2,".",''); $netbal+= $amount ;
$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
			'shift'		=> $phpgw->db->f('shift'),
			'name'		=> lang('End-of-shift Cash-out'),
			'trantype'	=> $phpgw->db->f('trantype'),
			'amount'	=> $amount			)) ;
$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal_section','cashanal',true);

$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
$t->set_var('tr_color',$tr_color) ;
$t->parse('cashanal','cashanal_section',true);

$t->set_var('lang_netbal',lang('Cash Balance that should be available inside CashBox or Cash ShortFall(+ve)/Surplus(-ve) post End-of-Shift operation')) ;
$t->set_var('netbal',$netbal) ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','report',True);

?>
