<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cashbalview.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'cashbal' ;
	include('../ck-api/ckapi.inc.php') ;

//	$_POST = $HTTP_POST_VARS ;  $_GET = $HTTP_GET_VARS ; (* for pre-PHP-4.1.0 installs *)
	$id = ($_GET["id"]) ? $_GET["id"] : $_POST["id"] ;
	$filter = ($_GET["filter"]) ? $_GET["filter"] : $_POST["filter"] ;
	$order = ($_GET["order"]) ? $_GET["order"] : $_POST["order"] ;
	$sort = ($_GET["sort"]) ? $_GET["sort"] : $_POST["sort"] ;
	
	$filter = urldecode(stripslashes($filter)) ;
	$proc = CreateObject('ck-api.process') ;
	$where = $proc->decode_where($filter) ;
	$filter = urlencode($filter) ;

	$t = CreateObject('phpgwapi.Template',$phpgw->common->get_tpl_dir($app));
	$nm = $phpgw->nextmatchs ;
	$t->set_file('report',"${tran}view.tpl") ;
	$t->set_block('report','cashbal','cashbal_section');
	$t->set_block('report','cashanal','cashanal_section');
	$t->set_var('th_bg',$ckapi[hostsys][th_bg]);
	$tr_color = $tr_color1 = $ckapi[hostsys][tr_color1] ;
	$tr_color2 = $ckapi[hostsys][tr_color2] ;

//---------------------------- list variable template-declarations -------------------------

$t->set_var('lang_title',lang('List of Shift End Balances (Detail View)'));
$t->set_var('lang_cashbox',lang('Cash Box Name'));
$t->set_var('lang_done',lang('Done'));
$t->set_var('done_action',$phpgw->link("/$app/${tran}list.php","filter=$filter"));
$extravar['id'] = $id ;
$script = "/$app/${tran}view.php" ;
$t->set_var('sort_transdate',$nm->show_sort_order($sort,'transdate',$order,$script,lang('Cash Sale Date'),$extravar));
$t->set_var('sort_shift',$nm->show_sort_order($sort,'shift',$order,$script,lang('Shift'),$extravar));
$t->set_var('sort_name',$nm->show_sort_order($sort,'name',$order,$script,lang('Quasi-Cash Name'),$extravar));
$t->set_var('sort_posnumber',$nm->show_sort_order($sort,'posnumber',$order,$script,lang('Cash Sale#'),$extravar));
$t->set_var('sort_qty',$nm->show_sort_order($sort,'qty',$order,$script,lang('Qty'),$extravar));
$t->set_var('sort_value',$nm->show_sort_order($sort,'value',$order,$script,lang('Value'),$extravar));
$t->set_var('sort_amount',$nm->show_sort_order($sort,'amount',$order,$script,lang('Amount'),$extravar));
$t->set_var('lang_view',lang('View Detail'));
$t->set_var('lang_copy',lang('Copy/Modify'));
$t->set_var('lang_delete',lang('Delete'));

$rpos = strrpos($where,"'") ;
$lpos = strrpos(substr($where,1,$rpos-1),"'") ;
$cboxid = substr($where,$lpos) ;
$phpgw->db->query("SELECT name FROM ${pre}cashbox WHERE id=$cboxid");
$phpgw->db->next_record() ;
$t->set_var('cashbox',$phpgw->db->f('name')) ;

// ------------------------- Write Quasi-Cash Balances (Detail View) -------------------------

if (!$order) {$order = "posnumber" ; }
if (!$sort)  {$sort = "ASC" ; }
$sql =	"SELECT itemid,transdate,b.shift as shift,c.name as name,posnumber,qty,a.value as value,";
$sql.=		"qty*a.value as amount " ;
$sql.=	"FROM ${pre}positem a, ${pre}pos b, ${pre}qcash c " ;
$sql.=	"WHERE $where and itemid=$id and a.trans_id=b.id and a.itemid=c.id  " ;
$sql.=	"ORDER BY $order $sort" ;
if ($id==0)	{
	$sql =	"SELECT transdate,shift,'Cash Change' as name,posnumber,qty,value,qty*value as amount " ;
	$sql.=	"FROM ${pre}positem a, ${pre}pos b " ;
	$sql.=	"WHERE $where and itemtype='c' and a.trans_id=b.id ORDER BY $order $sort" ;
	}
$phpgw->db->query($sql);
if ($phpgw->db->num_rows()==0) {
	$t->set_var(array(	'transdate'	=> lang("No Matching Item Found"),
				'shift'		=> "",
				'name'		=> "",
				'posnumber'	=> "",
				'qty'		=> "",
				'value'		=> "",
				'amount'	=> ""		)) ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashbal_section','cashbal',True);
	}
$total == 0 ;
while ($phpgw->db->next_record()) {
	$amount = number_format($phpgw->db->f('amount'),2,".",'') ;
	$name = $phpgw->db->f('name') ;
	$t->set_var(array(	'transdate'	=> $phpgw->db->f('transdate'),
				'shift'		=> $phpgw->db->f('shift'),
				'name'		=> $name,
				'posnumber'	=> $phpgw->db->f('posnumber'),
				'qty'		=> $phpgw->db->f('qty') ,
				'value'		=> $phpgw->db->f('value') ,
				'amount'	=> $amount 		)) ;
	if ($name=="Cash")	$cashamount = number_format($amount,2,".",'') ;
	$tr_color = ($tr_color==$tr_color1) ? $tr_color2 : $tr_color1 ;
	$t->set_var('tr_color',$tr_color) ;
	$t->parse('cashbal_section','cashbal',true);
	$total += $amount ;
	}

$t->parse('cashbal','cashbal_section',true);
$t->set_var('lang_total',lang("Total for this Shift -")." $name") ;
$t->set_var('total',$total) ;

// ---------------------------- end list records -----------------------------------------

	$t->pparse('out','report',True);

?>
