<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: cbtranlist.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-pos-m' ;
	$tran = 'cbtran' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}cbtran" 			) ;
	$note1 = lang('[Shift]:  1 - Morning, 2 - Afternoon, 3 - Overnight') ;
	$note2 = lang('[Tran Type]: s - start-of-shift, +/- => Cash in/out, e - end-of-shift') ;
	$ckapi[phrases] = array('lang_title'	=> lang("List of Cash Box Transactions") ,
				'lang_add'	=> lang("Add New Cash Box Transaction") ,
				'lang_note1'	=> $note1 ,
				'lang_note2'	=> $note2				) ;
	$ckapi[columns] = array('cbtnumber'	=> lang('CashBox Tran#') ,
				'name'		=> lang('CashBox Name') ,
				'manager'	=> lang('Manager') ,
				'cashier'	=> lang('Cashier') ,
				'transdate'	=> lang('Cash Sale Date') ,
				'shift'		=> lang('Shift') ,
				'trantype'	=> lang('Tran Type') ,
				'amount'	=> lang('Amount') ,
				'id'		=> lang('Audit ID') 			) ;
	$ckapi[links]	 = array('view'		=> "/$app/${tran}view.php" ,
				'acctran'	=> "/$app/${tran}acctran.php" ,
				'edit'		=> "/$app/${tran}edit.php" ,
				'copy'		=> "/$app/${tran}copy.php" ,
				'delete'	=> "/$app/${tran}delete.php"		) ;
	$ckapi[lang_links] = array('lang_view'	=> lang("View") ,
				'lang_acctran'	=> lang('View Accounting Entries') ,
				'lang_edit'	=> lang("Edit") ,
				'lang_copy'	=> lang("Copy/Modify") ,
				'lang_delete'	=> lang("Delete") ,
				'lang_log'	=> lang("Log")				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_list() ;

?>
