<?php
  /**************************************************************************\
  * CK-Ledger (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.tax.inc.php,v 0.0.5 2002/02/11 C K Wu $ */

    class tax {

//---- Tax Detail Validation Checks

    function tax_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$table = $ckapi[params][table] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang("Error") ;
	if (!$dt[taxnumber] or $dt[taxnumber]=="")	$err=lang('Tax Name/Number Missing');
		else	{
			$phpgw->db->query("SELECT * from $table WHERE taxnumber='$dt[taxnumber]'") ;
			if ($phpgw->db->num_rows()<>0 and $dt[taxnumber]<>$dt[oldtaxnumber])
				$err=lang('Tax Name/Number already in use');
			}
	if ($dt[rate] and !is_numeric($dt[rate]))	$err=lang('Tax Rate must be numeric');
	if ($dt[rate]<0 or $dt[rate]>10)	$err=lang('Rate must be 0-10(assumed maximum)');
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Tax Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$errmsg1 = lang("This tax is still listed as default") ;
	$itemrec = lang("within add-on item record") ;
	$phpgw->db->query("SELECT * from ${pre}itemtax where tax_id='$dt[id]'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $itemrec id#".$phpgw->db->f('item_id') ;
		}
	if ($err<>"")				$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Tax Detail

    function tax_write() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_id',lang('Audit ID:')."  ");
	$t->set_var('lang_taxnumber',lang('Name/Number'));
	$t->set_var('lang_rate',lang('Rate'));
	$t->set_var('lang_account',lang('Associated Ledger A/C'));
	$t->set_var('lang_notes',lang('Notes'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('taxnumber',$dt[taxnumber]);
	$t->set_var('rate',$dt[rate]);
	$t->set_var('chart_id',$dt[chart_id]);
	$t->set_var('acc_selectlist',account_selectlist("WHERE link like '%CS_tax%'",$dt[chart_id]));
	$t->set_var('notes',$dt[notes]);
	$t->parse('out','report',True);
	}

    }

?>
