<?php
  /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: class.customer.inc.php,v 0.8.1 2004/03/31 C K Wu $ */

    class customer {

//---- Customer Read

    function customer_read() {
	global $ckapi,$phpgw ;

	foreach ($ckapi[params] as $key => $value)	$$key = $value ;
	$id = $ckapi[params_post][id] ;
	$op = $ckapi[params_post][op] ;

	$phpgw->db->query("select * from ${pre}customer where id='$id'");
	$phpgw->db->next_record();
	$dt = $phpgw->db->Record ;
	$phpgw->db->query("select * from ${pre}customertax where customer_id = '$id' and taxtype=1");
	$phpgw->db->next_record();
	$dt[tax1] = $phpgw->db->f('tax_id') ;
	$phpgw->db->query("select * from ${pre}customertax where customer_id = '$id' and taxtype=2");
	$phpgw->db->next_record();
	$dt[tax2] = $phpgw->db->f('tax_id') ;
	if ($op=='edit' and is_array($uniqueflds))
		foreach ($uniqueflds as $key => $val)	$dt["old$val"] = $dt["$val"] ;
	return $dt ;
	}

//---- Customer Detail Validation Checks

    function customer_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang("Error");
	if ($dt[name]=="")				$err=lang("Customer Name Missing");
	if ($dt[contact]=="")				$err=lang("Customer Contact Missing");
	if ($dt[phone] and !is_numeric($dt[phone]))	$err=lang("phone# must be numeric");
	if ($dt[fax] and !is_numeric($dt[fax]))		$err=lang("fax# must be numeric");
	if ($dt[email] and strpos($dt[email],'@')=='')	$err=lang("invalid email address");
	if ($dt[shiptophone] and !is_numeric($dt[shiptophone]))	$err=lang("ship-to phone# must be numeric");
	if ($dt[shiptofax] and !is_numeric($dt[shiptofax]))	$err=lang("ship-to fax# must be numeric");
	if ($dt[shiptoemail] and strpos($dt[shiptoemail],'@')=='') $err=lang("invalid ship-to email address");
	if ($dt[terms] and !is_numeric($dt[terms]))	$err=lang("payment term must be numeric");
	if ($dt[terms]<0 or $dt[terms]>366)	$err=lang("payment term must be 0-366 days");
	if ($dt[creditlimit] and !is_numeric($dt[creditlimit]))	$err=lang("credit limit must be numeric");
	if ($dt[discount] and !is_numeric($dt[discount]))	$err=lang("discount must be numeric");
	if ($dt[discount]<0 or $dt[discount]>1)		$err=lang("discount must be 0-1");
	if ($dt[name]<>$dt[oldname]) {
		$phpgw->db->query("SELECT * from ${pre}customer where name='$dt[name]'");
		if ($phpgw->db->num_rows()>0)	$err = lang("Customer Name already exists") ;
		}
	if ($err)	$err = "<b>$error:  $err</b>" ;
	return $err ;
	}

//---- Customer Delete Validation Checks

    function delete_validate() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$dt = $ckapi[params_post][dt] ;

	$err=""; $error=lang('Error') ;
	$invoice = lang('invoice') ; $order = lang('sales order');
	$quote = lang('quotation') ; $cashsale = lang('cash sale') ;
	$errmsg1 = lang("This customer is in use within an existing") ;
	$id = $dt[id] ;
	$phpgw->db->query("SELECT * from ${pre}ar WHERE customer='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $invoice id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}so WHERE customer='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $order id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}quote WHERE customer='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $quote id#".$phpgw->db->f('id') ;
		}
	$phpgw->db->query("SELECT * from ${pre}pos WHERE customer='$id'");
	if ($phpgw->db->num_rows()>0) {
		$phpgw->db->next_record();
		$err = "$errmsg1 $cashsale id#".$phpgw->db->f('id') ;
		}
	if ($err<>"")			$err = "<b>$error: $err</b>" ;
	return $err ;
	}

//---- Write Customer Detail

    function customer_write() {
	global $ckapi,$phpgw ;

	$dt = &$ckapi[params_post][dt] ;
	$t = &$ckapi[objects][template] ;

	$t->set_var('lang_billing',lang('Billing'));
	$t->set_var('lang_shipping',lang('Shipping'));
	$t->set_var('lang_name',lang('Name'));
	$t->set_var('lang_address',lang('Address'));
	$t->set_var('lang_terms',lang('Terms:Net'));
	$t->set_var('lang_day',lang('Days'));
	$t->set_var('lang_tax',lang('Tax Included'));
	$t->set_var('lang_taxnote',lang('Invoice Unit Price listed with Tax Included [Initital Default]'));
	$t->set_var('lang_contact',lang('Contact'));
	$t->set_var('lang_phone',lang('Phone'));
	$t->set_var('lang_fax',lang('Fax'));
	$t->set_var('lang_email',lang('E-Mail'));
	$t->set_var('lang_notes',lang('Notes'));
	$t->set_var('lang_id',lang('Audit ID:'));
	$t->set_var('lang_creditlimit',lang('Credit Limit'));
	$t->set_var('lang_discount',lang('%Discount'));
	$t->set_var('lang_percent',lang('%'));
	$t->set_var('lang_tax1',lang('Primary Tax'));
	$t->set_var('lang_tax2',lang('Secondary Tax'));
	$t->set_var('lang_reserved',lang('Reserved Space'));

	if (is_array($ckapi[params][uniqueflds]))
	  	foreach ($ckapi[params][uniqueflds] as $key => $val)
			$t->set_var("old$val",$dt["old$val"]);
	$t->set_var('id',$dt[id]);
	$t->set_var('control',$dt[control]);
	$t->set_var('name',$dt[name]);
	$t->set_var('addr1',$dt[addr1]);
	$t->set_var('addr2',$dt[addr2]);
	$t->set_var('addr3',$dt[addr3]);
	$t->set_var('addr4',$dt[addr4]);
	$t->set_var('contact',$dt[contact]);
	$t->set_var('phone',$dt[phone]);
	$t->set_var('fax',$dt[fax]);
	$t->set_var('email',$dt[email]);
	$t->set_var('shiptoname',$dt[shiptoname]);
	$t->set_var('shiptoaddr1',$dt[shiptoaddr1]);
	$t->set_var('shiptoaddr2',$dt[shiptoaddr2]);
	$t->set_var('shiptoaddr3',$dt[shiptoaddr3]);
	$t->set_var('shiptoaddr4',$dt[shiptoaddr4]);
	$t->set_var('shiptocontact',$dt[shiptocontact]);
	$t->set_var('shiptophone',$dt[shiptophone]);
	$t->set_var('shiptofax',$dt[shiptofax]);
	$t->set_var('shiptoemail',$dt[shiptoemail]);
	$t->set_var('terms',$dt[terms]);
	$t->set_var('creditlimit',$dt[creditlimit]);
	$t->set_var('discount',$dt[discount]);
	$discpct = $dt[discount]*100 ;
	$t->set_var('lang_discnote',lang("i.e.")." $discpct %");
	if ($dt[taxincluded]=='t' or $dt[taxincluded]=='yes')		$t->set_var('checked',"checked");
	$t->set_var('tax1_selectlist',tax_selectlist("WHERE taxgroup='ar'",$dt[tax1]));
	$t->set_var('tax2_selectlist',tax_selectlist("WHERE taxgroup='ar'",$dt[tax2]));
	$t->set_var('notes',$dt[notes]);
	$t->parse('out','report',True);
	}

//---- Customer Post Initialisation

    function customer_post_init() {
	global $ckapi ;

	$dt = &$ckapi[params_post][dt] ;
	$dt[taxincluded] = ($dt[taxincluded]=='yes') ? "t" : "f" ;
	$dt[discount] = ($dt[discount]=="") ? 0 : $dt[discount] ;
	$dt[creditlimit] = ($dt[creditlimit]=="") ? 0 : $dt[creditlimit] ;
	$dt[terms] = ($dt[terms]=="") ? 0 : $dt[terms] ;
	}

//---- Customer Post - PreCommit Routine

    function customer_post_precommit() {
	global $ckapi,$phpgw ;

	$pre = $ckapi[params][pre] ;
	$op = $ckapi[params_post][op] ;
	$id = $ckapi[params_post][id] ;
	$dt = $ckapi[params_post][dt] ;
	$table = "${pre}customertax" ;

	if ($op<>'new')
		$phpgw->db->query("DELETE FROM $table WHERE customer_id=$id and (taxtype=1 or taxtype=2)") ;
	if ($op<>'delete') {
		$sql="INSERT INTO $table (customer_id,tax_id,taxtype) " ;
		if ($dt[tax1]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[tax1]','1')");
		if ($dt[tax2]<>"")	$phpgw->db->query("$sql VALUES ('$id','$dt[tax2]','2')");
		}
	}

    }
