<?php
 /**************************************************************************\
  * CK-ERP (running on top of phpgroupware)                               *
  * Written by CK Wu [ckwu@cheerful.com]                                     *
  * -----------------------------------------------                          *
  *  This program is free software; you can redistribute it and/or modify it *
  *  under the terms of the GNU General Public License as published by the   *
  *  Free Software Foundation; either version 2 of the License, or (at your  *
  *  option) any later version.                                              *
  \**************************************************************************/
  /* $Id: sqmatchedit.php,v 0.8.1 2004/03/31 C K Wu $ */

	$app = 'ck-so' ;
	$tran = 'sqmatch' ;
	include('../ck-api/ckapi.inc.php') ;

	$ckapi[params] = array( 'pre'		=> $pre ,
				'app'		=> $app ,
				'class'		=> $tran ,
				'tran'		=> $tran ,
				'table'		=> "${pre}so" ,
				'uniqueflds'	=> ""				);
	$warn1 = lang("Because a quotation or its line items can be accepted more than once") ;
$warn2=lang("total accepted amount for a quotation is allowed to exceed the quotation's original full value");
$warn3 = lang("Thus, user would have to be extra careful not to match SO against the wrong Quotation.");
	$warning = "<font size='-1'>[$warn1, $warn2.<br>$warn3]</font>" ;
	$msg1 = lang("If either auto-allocation button is clicked, the [Amount Accepted via this SO to be updated to] field will be ignored and blanked out.") ;
	$msg2 = lang("Which Quotation got allocated first will affect the final SO/Quotation pairing.") ;
$msg = lang("If the ACCEPTED/(full) QUOTATION Lists get too complicated, press [clear allocation] button to start afresh");
	$ckapi[phrases] = array('lang_title'	=> lang("Edit SO/Quotation Matching Detail") ,
				'lang_match'	=> lang("Auto-allocate SO's Remaining Amount by :") ,
				'lang_match_equal'=>lang("Matching Oldest Equal Amount") ,
				'lang_match_fifo'=> lang("FIFO Scheme") ,
				'lang_clear'	=> lang("Clear Allocation") ,
				'lang_post'	=> lang("Post SO/Quotation Matching") ,
				'lang_update'	=> lang("Refresh Page") ,
				'lang_tran'	=> lang("Quotations matching to SO") ,
				'warning'	=> $warning ,
				'message1'	=> "$msg1  $msg2" ,
				'message'	=> $msg				);
	$ckapi[tables]["parents"] = array(	"${pre}so"=> "skipskip"		) ;
	$ckapi[tables]["children"] = array(	"${pre}sqmatch"=> "soid"	) ;
	$ckapi[buttons] = array('move'		=> "" ,
				'match_equal'	=> "" ,
				'match_fifo'	=> "" ,
				'clear'		=> "" ,
				'post'		=> "" ,
				'update'	=> ""				) ;

	$proc1 = CreateObject('ck-api.process1') ;
	$proc1->process1_edit() ;

?>
